/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "AtomList.h"
#include "MediaTrackConstraintSetBinding.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/OwningNonNull.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/ScriptSettings.h"
#include "xpcpublic.h"

namespace mozilla {
namespace dom {

namespace SupportedVideoConstraintsValues {
  extern const EnumEntry strings[9] = {
    {"other", 5},
    {"facingMode", 10},
    {"width", 5},
    {"height", 6},
    {"frameRate", 9},
    {"mediaSource", 11},
    {"browserWindow", 13},
    {"scrollWithPage", 14},
    { nullptr, 0 }
  };
} // namespace SupportedVideoConstraintsValues


namespace SupportedAudioConstraintsValues {
  extern const EnumEntry strings[2] = {
    {"other", 5},
    { nullptr, 0 }
  };
} // namespace SupportedAudioConstraintsValues



MediaTrackConstraintSet::MediaTrackConstraintSet()
{
  // Safe to pass a null context if we pass a null value
  Init(nullptr, JS::NullHandleValue);
}



bool
MediaTrackConstraintSet::InitIds(JSContext* cx, MediaTrackConstraintSetAtoms* atomsCache)
{
  MOZ_ASSERT(!*reinterpret_cast<jsid**>(atomsCache));

  // Initialize these in reverse order so that any failure leaves the first one
  // uninitialized.
  if (!atomsCache->width_id.init(cx, "width") ||
      !atomsCache->scrollWithPage_id.init(cx, "scrollWithPage") ||
      !atomsCache->mediaSource_id.init(cx, "mediaSource") ||
      !atomsCache->height_id.init(cx, "height") ||
      !atomsCache->frameRate_id.init(cx, "frameRate") ||
      !atomsCache->facingMode_id.init(cx, "facingMode") ||
      !atomsCache->browserWindow_id.init(cx, "browserWindow")) {
    return false;
  }
  return true;
}

bool
MediaTrackConstraintSet::Init(JSContext* cx, JS::Handle<JS::Value> val, const char* sourceDescription, bool passedToJSImpl)
{
  // Passing a null JSContext is OK only if we're initing from null,
  // Since in that case we will not have to do any property gets
  MOZ_ASSERT_IF(!cx, val.isNull());
  MediaTrackConstraintSetAtoms* atomsCache = nullptr;
  if (cx) {
    atomsCache = GetAtomCache<MediaTrackConstraintSetAtoms>(cx);
    if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
      return false;
    }
  }

  if (!IsConvertibleToDictionary(cx, val)) {
    return ThrowErrorMessage(cx, MSG_NOT_DICTIONARY, sourceDescription);
  }

  bool isNull = val.isNullOrUndefined();
  // We only need these if !isNull, in which case we have |cx|.
  Maybe<JS::Rooted<JSObject *> > object;
  Maybe<JS::Rooted<JS::Value> > temp;
  if (!isNull) {
    object.emplace(cx, &val.toObject());
    temp.emplace(cx);
  }
  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->browserWindow_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mBrowserWindow.Construct();
    if (!ValueToPrimitive<int64_t, eDefault>(cx, temp.ref(), &(mBrowserWindow.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->facingMode_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mFacingMode.Construct();
    {
      bool ok;
      int index = FindEnumStringIndex<true>(cx, temp.ref(), VideoFacingModeEnumValues::strings, "VideoFacingModeEnum", "'facingMode' member of MediaTrackConstraintSet", &ok);
      if (!ok) {
        return false;
      }
      MOZ_ASSERT(index >= 0);
      (mFacingMode.Value()) = static_cast<VideoFacingModeEnum>(index);
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->frameRate_id, temp.ptr())) {
    return false;
  }
  if (!mFrameRate.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'frameRate' member of MediaTrackConstraintSet", passedToJSImpl)) {
    return false;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->height_id, temp.ptr())) {
    return false;
  }
  if (!mHeight.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'height' member of MediaTrackConstraintSet", passedToJSImpl)) {
    return false;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->mediaSource_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    {
      bool ok;
      int index = FindEnumStringIndex<true>(cx, temp.ref(), MediaSourceEnumValues::strings, "MediaSourceEnum", "'mediaSource' member of MediaTrackConstraintSet", &ok);
      if (!ok) {
        return false;
      }
      MOZ_ASSERT(index >= 0);
      mMediaSource = static_cast<MediaSourceEnum>(index);
    }
  } else {
    mMediaSource = MediaSourceEnum::Camera;
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->scrollWithPage_id, temp.ptr())) {
    return false;
  }
  if (!isNull && !temp->isUndefined()) {
    mScrollWithPage.Construct();
    if (!ValueToPrimitive<bool, eDefault>(cx, temp.ref(), &(mScrollWithPage.Value()))) {
      return false;
    }
  }

  if (!isNull && !JS_GetPropertyById(cx, *object, atomsCache->width_id, temp.ptr())) {
    return false;
  }
  if (!mWidth.Init(cx, (!isNull && !temp->isUndefined()) ? temp.ref() : JS::NullHandleValue, "'width' member of MediaTrackConstraintSet", passedToJSImpl)) {
    return false;
  }
  return true;
}

bool
MediaTrackConstraintSet::Init(const nsAString& aJSON)
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoSafeJSContext cx;
  JS::Rooted<JS::Value> json(cx);
  bool ok = ParseJSON(cx, aJSON, &json);
  NS_ENSURE_TRUE(ok, false);
  return Init(cx, json);
}

bool
MediaTrackConstraintSet::ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const
{
  MediaTrackConstraintSetAtoms* atomsCache = GetAtomCache<MediaTrackConstraintSetAtoms>(cx);
  if (!*reinterpret_cast<jsid**>(atomsCache) && !InitIds(cx, atomsCache)) {
    return false;
  }

  JS::Rooted<JSObject*> obj(cx, JS_NewObject(cx, nullptr, JS::NullPtr(), JS::NullPtr()));
  if (!obj) {
    return false;
  }
  rval.set(JS::ObjectValue(*obj));

  if (mBrowserWindow.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      int64_t const & currentValue = mBrowserWindow.InternalValue();
      temp.set(JS_NumberValue(double(currentValue)));
      if (!JS_DefinePropertyById(cx, obj, atomsCache->browserWindow_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  if (mFacingMode.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      VideoFacingModeEnum const & currentValue = mFacingMode.InternalValue();
      {
        // Scope for resultStr
        MOZ_ASSERT(uint32_t(currentValue) < ArrayLength(VideoFacingModeEnumValues::strings));
        JSString* resultStr = JS_NewStringCopyN(cx, VideoFacingModeEnumValues::strings[uint32_t(currentValue)].value, VideoFacingModeEnumValues::strings[uint32_t(currentValue)].length);
        if (!resultStr) {
          return false;
        }
        temp.setString(resultStr);
        if (!JS_DefinePropertyById(cx, obj, atomsCache->facingMode_id, temp, JSPROP_ENUMERATE)) {
          return false;
        }
        break;
      }
    } while(0);
  }

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    ConstrainDoubleRange const & currentValue = mFrameRate;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->frameRate_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    ConstrainLongRange const & currentValue = mHeight;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->height_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    MediaSourceEnum const & currentValue = mMediaSource;
    {
      // Scope for resultStr
      MOZ_ASSERT(uint32_t(currentValue) < ArrayLength(MediaSourceEnumValues::strings));
      JSString* resultStr = JS_NewStringCopyN(cx, MediaSourceEnumValues::strings[uint32_t(currentValue)].value, MediaSourceEnumValues::strings[uint32_t(currentValue)].length);
      if (!resultStr) {
        return false;
      }
      temp.setString(resultStr);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->mediaSource_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    }
  } while(0);

  if (mScrollWithPage.WasPassed()) {
    do {
      // block for our 'break' successCode and scope for 'temp' and 'currentValue'
      JS::Rooted<JS::Value> temp(cx);
      bool const & currentValue = mScrollWithPage.InternalValue();
      temp.setBoolean(currentValue);
      if (!JS_DefinePropertyById(cx, obj, atomsCache->scrollWithPage_id, temp, JSPROP_ENUMERATE)) {
        return false;
      }
      break;
    } while(0);
  }

  do {
    // block for our 'break' successCode and scope for 'temp' and 'currentValue'
    JS::Rooted<JS::Value> temp(cx);
    ConstrainLongRange const & currentValue = mWidth;
    if (!currentValue.ToObjectInternal(cx, &temp)) {
      return false;
    }
    if (!JS_DefinePropertyById(cx, obj, atomsCache->width_id, temp, JSPROP_ENUMERATE)) {
      return false;
    }
    break;
  } while(0);

  return true;
}

bool
MediaTrackConstraintSet::ToJSON(nsAString& aJSON) const
{
  MOZ_ASSERT(NS_IsMainThread());
  AutoJSAPI jsapi;
  jsapi.Init();
  JSContext *cx = jsapi.cx();
  JSAutoCompartment ac(cx, xpc::UnprivilegedJunkScope()); // Usage approved by bholley
  JS::Rooted<JS::Value> obj(cx);
  return ToObjectInternal(cx, &obj) && StringifyToJSON(cx, &obj, aJSON);
}

void
MediaTrackConstraintSet::TraceDictionary(JSTracer* trc)
{
}

void
MediaTrackConstraintSet::operator=(const MediaTrackConstraintSet& aOther)
{
  if (aOther.mBrowserWindow.WasPassed()) {
    mBrowserWindow.Construct();
    mBrowserWindow.Value() = aOther.mBrowserWindow.Value();
  } else {
    mBrowserWindow.Reset();
  }
  if (aOther.mFacingMode.WasPassed()) {
    mFacingMode.Construct();
    mFacingMode.Value() = aOther.mFacingMode.Value();
  } else {
    mFacingMode.Reset();
  }
  mFrameRate = aOther.mFrameRate;
  mHeight = aOther.mHeight;
  mMediaSource = aOther.mMediaSource;
  if (aOther.mScrollWithPage.WasPassed()) {
    mScrollWithPage.Construct();
    mScrollWithPage.Value() = aOther.mScrollWithPage.Value();
  } else {
    mScrollWithPage.Reset();
  }
  mWidth = aOther.mWidth;
}

namespace binding_detail {
} // namespace binding_detail


} // namespace dom
} // namespace mozilla
