/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "EventBinding.h"
#include "RTCPeerConnectionIdentityErrorEvent.h"
#include "RTCPeerConnectionIdentityErrorEventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/RTCPeerConnectionIdentityErrorEvent.h"
#include "nsDOMQS.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(RTCPeerConnectionIdentityErrorEvent)

NS_IMPL_ADDREF_INHERITED(RTCPeerConnectionIdentityErrorEvent, Event)
NS_IMPL_RELEASE_INHERITED(RTCPeerConnectionIdentityErrorEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(RTCPeerConnectionIdentityErrorEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(RTCPeerConnectionIdentityErrorEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(RTCPeerConnectionIdentityErrorEvent, Event)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(RTCPeerConnectionIdentityErrorEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

RTCPeerConnectionIdentityErrorEvent::RTCPeerConnectionIdentityErrorEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

RTCPeerConnectionIdentityErrorEvent::~RTCPeerConnectionIdentityErrorEvent()
{
}

RTCPeerConnectionIdentityErrorEvent*
RTCPeerConnectionIdentityErrorEvent::AsRTCPeerConnectionIdentityErrorEvent()
{
  return this;
}

JSObject*
RTCPeerConnectionIdentityErrorEvent::WrapObject(JSContext* aCx)
{
  return RTCPeerConnectionIdentityErrorEventBinding::Wrap(aCx, this);
}

already_AddRefed<RTCPeerConnectionIdentityErrorEvent>
RTCPeerConnectionIdentityErrorEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const RTCPeerConnectionIdentityErrorEventInit& aEventInitDict)
{
  nsRefPtr<RTCPeerConnectionIdentityErrorEvent> e = new RTCPeerConnectionIdentityErrorEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  e->mIdp = aEventInitDict.mIdp;
  e->mProtocol = aEventInitDict.mProtocol;
  e->mLoginUrl = aEventInitDict.mLoginUrl;
  e->SetTrusted(trusted);
  return e.forget();
}

already_AddRefed<RTCPeerConnectionIdentityErrorEvent>
RTCPeerConnectionIdentityErrorEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const RTCPeerConnectionIdentityErrorEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

void
RTCPeerConnectionIdentityErrorEvent::GetIdp(nsString& aRetVal) const
{
  aRetVal = mIdp;
}

void
RTCPeerConnectionIdentityErrorEvent::GetProtocol(nsString& aRetVal) const
{
  aRetVal = mProtocol;
}

void
RTCPeerConnectionIdentityErrorEvent::GetLoginUrl(nsString& aRetVal) const
{
  aRetVal = mLoginUrl;
}


} // namespace dom
} // namespace mozilla
