/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "EventBinding.h"
#include "RTCPeerConnectionIdentityEvent.h"
#include "RTCPeerConnectionIdentityEventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/RTCPeerConnectionIdentityEvent.h"
#include "nsDOMQS.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(RTCPeerConnectionIdentityEvent)

NS_IMPL_ADDREF_INHERITED(RTCPeerConnectionIdentityEvent, Event)
NS_IMPL_RELEASE_INHERITED(RTCPeerConnectionIdentityEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(RTCPeerConnectionIdentityEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(RTCPeerConnectionIdentityEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(RTCPeerConnectionIdentityEvent, Event)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(RTCPeerConnectionIdentityEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

RTCPeerConnectionIdentityEvent::RTCPeerConnectionIdentityEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

RTCPeerConnectionIdentityEvent::~RTCPeerConnectionIdentityEvent()
{
}

RTCPeerConnectionIdentityEvent*
RTCPeerConnectionIdentityEvent::AsRTCPeerConnectionIdentityEvent()
{
  return this;
}

JSObject*
RTCPeerConnectionIdentityEvent::WrapObject(JSContext* aCx)
{
  return RTCPeerConnectionIdentityEventBinding::Wrap(aCx, this);
}

already_AddRefed<RTCPeerConnectionIdentityEvent>
RTCPeerConnectionIdentityEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const RTCPeerConnectionIdentityEventInit& aEventInitDict)
{
  nsRefPtr<RTCPeerConnectionIdentityEvent> e = new RTCPeerConnectionIdentityEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInitDict.mBubbles, aEventInitDict.mCancelable);
  e->mAssertion = aEventInitDict.mAssertion;
  e->SetTrusted(trusted);
  return e.forget();
}

already_AddRefed<RTCPeerConnectionIdentityEvent>
RTCPeerConnectionIdentityEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const RTCPeerConnectionIdentityEventInit& aEventInitDict, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInitDict);
}

void
RTCPeerConnectionIdentityEvent::GetAssertion(nsString& aRetVal) const
{
  aRetVal = mAssertion;
}


} // namespace dom
} // namespace mozilla
