#include "BlobBinding.h"
#include "ConsoleBinding.h"
#include "DOMExceptionBinding.h"
#include "DataStoreBinding.h"
#include "DedicatedWorkerGlobalScopeBinding.h"
#include "EventBinding.h"
#include "EventTargetBinding.h"
#include "FileBinding.h"
#include "FileReaderSyncBinding.h"
#include "HeadersBinding.h"
#include "ImageDataBinding.h"
#include "InstallPhaseEventBinding.h"
#include "MessageEventBinding.h"
#include "MessagePortBinding.h"
#include "PerformanceBinding.h"
#include "PromiseBinding.h"
#include "RequestBinding.h"
#include "ResponseBinding.h"
#include "ServiceWorkerGlobalScopeBinding.h"
#include "SharedWorkerGlobalScopeBinding.h"
#include "TextDecoderBinding.h"
#include "TextEncoderBinding.h"
#include "URLBinding.h"
#include "URLSearchParamsBinding.h"
#include "WebSocketBinding.h"
#include "WorkerBinding.h"
#include "WorkerGlobalScopeBinding.h"
#include "WorkerLocationBinding.h"
#include "WorkerNavigatorBinding.h"
#include "XMLHttpRequestBinding.h"
#include "XMLHttpRequestUploadBinding.h"

namespace mozilla {
namespace dom {
bool
RegisterWorkerBindings(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  if (DataStoreCursorBinding_workers::ConstructorEnabled(aCx, aObj) && !DataStoreCursorBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (DataStoreBinding_workers::ConstructorEnabled(aCx, aObj) && !DataStoreBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (DedicatedWorkerGlobalScopeBinding_workers::ConstructorEnabled(aCx, aObj) && !DedicatedWorkerGlobalScopeBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!FileReaderSyncBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (InstallPhaseEventBinding_workers::ConstructorEnabled(aCx, aObj) && !InstallPhaseEventBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!PerformanceBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ServiceWorkerGlobalScopeBinding_workers::ConstructorEnabled(aCx, aObj) && !ServiceWorkerGlobalScopeBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (SharedWorkerGlobalScopeBinding_workers::ConstructorEnabled(aCx, aObj) && !SharedWorkerGlobalScopeBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!URLBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!WorkerGlobalScopeBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!WorkerLocationBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!WorkerNavigatorBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!XMLHttpRequestUploadBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!XMLHttpRequestBinding_workers::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!BlobBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ChromeWorkerBinding::ConstructorEnabled(aCx, aObj) && !ChromeWorkerBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ConsoleBinding::ConstructorEnabled(aCx, aObj) && !ConsoleBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!DOMExceptionBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!EventBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!EventTargetBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!FileBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (HeadersBinding::ConstructorEnabled(aCx, aObj) && !HeadersBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!ImageDataBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!MessageEventBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!MessagePortBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!PromiseBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (RequestBinding::ConstructorEnabled(aCx, aObj) && !RequestBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (ResponseBinding::ConstructorEnabled(aCx, aObj) && !ResponseBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!TextDecoderBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!TextEncoderBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (!URLSearchParamsBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WebSocketBinding::ConstructorEnabled(aCx, aObj) && !WebSocketBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  if (WorkerBinding::ConstructorEnabled(aCx, aObj) && !WorkerBinding::GetConstructorObject(aCx, aObj)) {
    return false;
  }

  return true;
}

} // namespace dom
} // namespace mozilla

