/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
/* vim:set ts=2 sw=2 sts=2 et cindent: */
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "EventBinding.h"
#include "SelectionChangeEvent.h"
#include "SelectionChangeEventBinding.h"
#include "js/GCAPI.h"
#include "mozilla/dom/DOMRect.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/SelectionChangeEvent.h"
#include "nsDOMQS.h"

namespace mozilla {
namespace dom {


NS_IMPL_CYCLE_COLLECTION_CLASS(SelectionChangeEvent)

NS_IMPL_ADDREF_INHERITED(SelectionChangeEvent, Event)
NS_IMPL_RELEASE_INHERITED(SelectionChangeEvent, Event)

NS_IMPL_CYCLE_COLLECTION_TRAVERSE_BEGIN_INHERITED(SelectionChangeEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_TRAVERSE(mBoundingClientRect)
NS_IMPL_CYCLE_COLLECTION_TRAVERSE_END

NS_IMPL_CYCLE_COLLECTION_TRACE_BEGIN_INHERITED(SelectionChangeEvent, Event)
NS_IMPL_CYCLE_COLLECTION_TRACE_END

NS_IMPL_CYCLE_COLLECTION_UNLINK_BEGIN_INHERITED(SelectionChangeEvent, Event)
  NS_IMPL_CYCLE_COLLECTION_UNLINK(mBoundingClientRect)
NS_IMPL_CYCLE_COLLECTION_UNLINK_END

NS_INTERFACE_MAP_BEGIN_CYCLE_COLLECTION_INHERITED(SelectionChangeEvent)
NS_INTERFACE_MAP_END_INHERITING(Event)

SelectionChangeEvent::SelectionChangeEvent(mozilla::dom::EventTarget* aOwner)
  : Event(aOwner, nullptr, nullptr)
{
}

SelectionChangeEvent::~SelectionChangeEvent()
{
}

SelectionChangeEvent*
SelectionChangeEvent::AsSelectionChangeEvent()
{
  return this;
}

JSObject*
SelectionChangeEvent::WrapObject(JSContext* aCx)
{
  return SelectionChangeEventBinding::Wrap(aCx, this);
}

already_AddRefed<SelectionChangeEvent>
SelectionChangeEvent::Constructor(mozilla::dom::EventTarget* aOwner, const nsAString& aType, const SelectionChangeEventInit& aEventInit)
{
  nsRefPtr<SelectionChangeEvent> e = new SelectionChangeEvent(aOwner);
  bool trusted = e->Init(aOwner);
  e->InitEvent(aType, aEventInit.mBubbles, aEventInit.mCancelable);
  e->mSelectedText = aEventInit.mSelectedText;
  e->mBoundingClientRect = aEventInit.mBoundingClientRect;
  e->mReasons.AppendElements(aEventInit.mReasons);
  e->SetTrusted(trusted);
  return e.forget();
}

already_AddRefed<SelectionChangeEvent>
SelectionChangeEvent::Constructor(const GlobalObject& aGlobal, const nsAString& aType, const SelectionChangeEventInit& aEventInit, ErrorResult& aRv)
{
  nsCOMPtr<mozilla::dom::EventTarget> owner = do_QueryInterface(aGlobal.GetAsSupports());
  return Constructor(owner, aType, aEventInit);
}

void
SelectionChangeEvent::GetSelectedText(nsString& aRetVal) const
{
  aRetVal = mSelectedText;
}

DOMRectReadOnly*
SelectionChangeEvent::GetBoundingClientRect() const
{
  return mBoundingClientRect;
}

void
SelectionChangeEvent::GetReasons(nsTArray<SelectionChangeReason>& aRetVal) const
{
  aRetVal = mReasons;
}


} // namespace dom
} // namespace mozilla
