/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "EventHandlerBinding.h"
#include "EventTargetBinding.h"
#include "TelephonyBinding.h"
#include "WrapperFactory.h"
#include "mozilla/Preferences.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/CallsList.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/OwningNonNull.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/Promise.h"
#include "mozilla/dom/Telephony.h"
#include "mozilla/dom/TelephonyCallGroup.h"
#include "mozilla/dom/UnionConversions.h"

namespace mozilla {
namespace dom {

namespace TelephonyBinding {

static bool
dial(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  if (args.length() < 1) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "Telephony.dial");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  Optional<uint32_t> arg1;
  if (args.hasDefined(1)) {
    arg1.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1.Value())) {
      return false;
    }
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::Promise>(self->Dial(NonNullHelper(Constify(arg0)), Constify(arg1), rv)));
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "Telephony", "dial");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!WrapNewBindingObject(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static bool
dial_promiseWrapper(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  // Make sure to save the callee before someone maybe messes
  // with rval().
  JS::Rooted<JSObject*> callee(cx, &args.callee());
  bool ok = dial(cx, obj, self, args);
  if (ok) {
    return true;
  }
  return ConvertExceptionToPromise(cx, xpc::XrayAwareCalleeGlobal(callee),
                                   args.rval());
}


static const JSJitInfo dial_methodinfo = {
 { (JSJitGetterOp)dial_promiseWrapper },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
dialEmergency(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  if (args.length() < 1) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "Telephony.dialEmergency");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  Optional<uint32_t> arg1;
  if (args.hasDefined(1)) {
    arg1.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1.Value())) {
      return false;
    }
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::Promise>(self->DialEmergency(NonNullHelper(Constify(arg0)), Constify(arg1), rv)));
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "Telephony", "dialEmergency");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!WrapNewBindingObject(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static bool
dialEmergency_promiseWrapper(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  // Make sure to save the callee before someone maybe messes
  // with rval().
  JS::Rooted<JSObject*> callee(cx, &args.callee());
  bool ok = dialEmergency(cx, obj, self, args);
  if (ok) {
    return true;
  }
  return ConvertExceptionToPromise(cx, xpc::XrayAwareCalleeGlobal(callee),
                                   args.rval());
}


static const JSJitInfo dialEmergency_methodinfo = {
 { (JSJitGetterOp)dialEmergency_promiseWrapper },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
startTone(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  if (args.length() < 1) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "Telephony.startTone");
  }
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  Optional<uint32_t> arg1;
  if (args.hasDefined(1)) {
    arg1.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[1], &arg1.Value())) {
      return false;
    }
  }
  ErrorResult rv;
  self->StartTone(NonNullHelper(Constify(arg0)), Constify(arg1), rv);
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "Telephony", "startTone");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}


static const JSJitInfo startTone_methodinfo = {
 { (JSJitGetterOp)startTone },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
stopTone(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, const JSJitMethodCallArgs& args)
{
  Optional<uint32_t> arg0;
  if (args.hasDefined(0)) {
    arg0.Construct();
    if (!ValueToPrimitive<uint32_t, eDefault>(cx, args[0], &arg0.Value())) {
      return false;
    }
  }
  ErrorResult rv;
  self->StopTone(Constify(arg0), rv);
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "Telephony", "stopTone");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setUndefined();
  return true;
}


static const JSJitInfo stopTone_methodinfo = {
 { (JSJitGetterOp)stopTone },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_muted(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  ErrorResult rv;
  bool result(self->GetMuted(rv));
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "Telephony", "muted");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static bool
set_muted(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  bool arg0;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  ErrorResult rv;
  self->SetMuted(arg0, rv);
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "Telephony", "muted");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo muted_getterinfo = {
 { (JSJitGetterOp)get_muted },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo muted_setterinfo = {
 { (JSJitGetterOp)set_muted },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_speakerEnabled(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  ErrorResult rv;
  bool result(self->GetSpeakerEnabled(rv));
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "Telephony", "speakerEnabled");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static bool
set_speakerEnabled(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  bool arg0;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  ErrorResult rv;
  self->SetSpeakerEnabled(arg0, rv);
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "Telephony", "speakerEnabled");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo speakerEnabled_getterinfo = {
 { (JSJitGetterOp)get_speakerEnabled },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo speakerEnabled_setterinfo = {
 { (JSJitGetterOp)set_speakerEnabled },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_active(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  Nullable<OwningTelephonyCallOrTelephonyCallGroup> result;
  self->GetActive(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result.IsNull()) {
    args.rval().setNull();
    return true;
  }
  if (!result.Value().ToJSVal(cx, obj, args.rval())) {
    return false;
  }
  return true;
}


static const JSJitInfo active_getterinfo = {
 { (JSJitGetterOp)get_active },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_calls(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  auto result(StrongOrRawPtr<mozilla::dom::CallsList>(self->Calls()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!WrapNewBindingObject(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}


static const JSJitInfo calls_getterinfo = {
 { (JSJitGetterOp)get_calls },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_conferenceGroup(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  auto result(StrongOrRawPtr<mozilla::dom::TelephonyCallGroup>(self->ConferenceGroup()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!WrapNewBindingObject(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}


static const JSJitInfo conferenceGroup_getterinfo = {
 { (JSJitGetterOp)get_conferenceGroup },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_onready(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> result(self->GetOnready());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onready(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOnready(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo onready_getterinfo = {
 { (JSJitGetterOp)get_onready },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo onready_setterinfo = {
 { (JSJitGetterOp)set_onready },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_onincoming(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> result(self->GetOnincoming());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onincoming(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOnincoming(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo onincoming_getterinfo = {
 { (JSJitGetterOp)get_onincoming },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo onincoming_setterinfo = {
 { (JSJitGetterOp)set_onincoming },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_oncallschanged(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> result(self->GetOncallschanged());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_oncallschanged(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOncallschanged(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo oncallschanged_getterinfo = {
 { (JSJitGetterOp)get_oncallschanged },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo oncallschanged_setterinfo = {
 { (JSJitGetterOp)set_oncallschanged },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_onremoteheld(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> result(self->GetOnremoteheld());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onremoteheld(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOnremoteheld(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo onremoteheld_getterinfo = {
 { (JSJitGetterOp)get_onremoteheld },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo onremoteheld_setterinfo = {
 { (JSJitGetterOp)set_onremoteheld },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_onremoteresumed(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitGetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> result(self->GetOnremoteresumed());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onremoteresumed(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Telephony* self, JSJitSetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOnremoteresumed(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo onremoteresumed_getterinfo = {
 { (JSJitGetterOp)get_onremoteresumed },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo onremoteresumed_setterinfo = {
 { (JSJitGetterOp)set_onremoteresumed },
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::MutableHandle<JS::Value> vp)
{
  mozilla::dom::Telephony* self = UnwrapDOMObject<mozilla::dom::Telephony>(obj);
  // We don't want to preserve if we don't have a wrapper.
  if (self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::Telephony* self = UnwrapDOMObject<mozilla::dom::Telephony>(obj);
  if (self) {
    JSBindingFinalized<mozilla::dom::Telephony>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::Telephony, nsRefPtr >(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::Telephony* self = UnwrapDOMObject<mozilla::dom::Telephony>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("dial", GenericPromiseReturningBindingMethod, reinterpret_cast<const JSJitInfo*>(&dial_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("dialEmergency", GenericPromiseReturningBindingMethod, reinterpret_cast<const JSJitInfo*>(&dialEmergency_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("startTone", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&startTone_methodinfo), 1, JSPROP_ENUMERATE, nullptr),
  JS_FNSPEC("stopTone", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&stopTone_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { false, nullptr }
};

static jsid sMethods_ids[5];

static const JSPropertySpec sAttributes_specs[] = {
  { "muted", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &muted_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &muted_setterinfo } }},
  { "speakerEnabled", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &speakerEnabled_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &speakerEnabled_setterinfo } }},
  { "active", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &active_getterinfo } }, JSOP_NULLWRAPPER},
  { "calls", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &calls_getterinfo } }, JSOP_NULLWRAPPER},
  { "conferenceGroup", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &conferenceGroup_getterinfo } }, JSOP_NULLWRAPPER},
  { "onready", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &onready_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &onready_setterinfo } }},
  { "onincoming", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &onincoming_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &onincoming_setterinfo } }},
  { "oncallschanged", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &oncallschanged_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &oncallschanged_setterinfo } }},
  { "onremoteheld", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &onremoteheld_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &onremoteheld_setterinfo } }},
  { "onremoteresumed", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &onremoteresumed_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &onremoteresumed_setterinfo } }},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { true, nullptr, nullptr, nullptr, &sAttributes_specs[0] },
  { false, nullptr }
};

static jsid sAttributes_ids[11];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  sAttributes, sAttributes_ids, sAttributes_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, nullptr },
  prototypes::id::Telephony,
  constructors::id::Telephony,
  EventTargetBinding::sNativePropertyHooks
} };

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    JS_PropertyStub,       /* addProperty */
    JS_DeletePropertyStub, /* delProperty */
    JS_PropertyStub,       /* getProperty */
    JS_StrictPropertyStub, /* setProperty */
    JS_EnumerateStub,
    JS_ResolveStub,
    JS_ConvertStub,
    nullptr,               /* finalize */
    ThrowingConstructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    ThrowingConstructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function Telephony() {\n    [native code]\n}",
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  EventTargetBinding::GetConstructorObject
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "TelephonyPrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    JS_PropertyStub,       /* addProperty */
    JS_DeletePropertyStub, /* delProperty */
    JS_PropertyStub,       /* getProperty */
    JS_StrictPropertyStub, /* setProperty */
    JS_EnumerateStub,
    JS_ResolveStub,
    JS_ConvertStub,
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object TelephonyPrototype]",
  prototypes::id::Telephony,
  PrototypeTraits<prototypes::id::Telephony>::Depth,
  EventTargetBinding::GetProtoObject
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("dom.telephony.enabled");
}

static const DOMJSClass Class = {
  { "Telephony",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    JS_DeletePropertyStub, /* delProperty */
    JS_PropertyStub,       /* getProperty */
    JS_StrictPropertyStub, /* setProperty */
    JS_EnumerateStub, /* enumerate */
    JS_ResolveStub, /* resolve */
    JS_ConvertStub,
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      nullptr, /* iteratorObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::EventTarget, prototypes::id::Telephony, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::Telephony >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::Telephony>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::Telephony>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

JSObject*
Wrap(JSContext* aCx, mozilla::dom::Telephony* aObject, nsWrapperCache* aCache)
{
  MOZ_ASSERT(static_cast<mozilla::dom::Telephony*>(aObject) ==
             reinterpret_cast<mozilla::dom::Telephony*>(aObject));
  MOZ_ASSERT(static_cast<mozilla::dom::EventTarget*>(aObject) ==
             reinterpret_cast<mozilla::dom::EventTarget*>(aObject));
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx,
    GetRealParentObject(aObject,
                        WrapNativeParent(aCx, aObject->GetParentObject())));
  if (!parent) {
    return nullptr;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.  Scope so we don't
  // collide with the "obj" we declare in CreateBindingJSObject.
  {
    JSObject* obj = aCache->GetWrapper();
    if (obj) {
      return obj;
    }
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, JS_GetGlobalForObject(aCx, parent));
  JS::Handle<JSObject*> proto = GetProtoObjectHandle(aCx, global);
  if (!proto) {
    return nullptr;
  }

  JS::Rooted<JSObject*> obj(aCx);
  obj = JS_NewObject(aCx, Class.ToJSClass(), proto, parent);
  if (!obj) {
    return nullptr;
  }

  js::SetReservedSlot(obj, DOM_OBJECT_SLOT, PRIVATE_TO_JSVAL(aObject));
  NS_ADDREF(aObject);


  aCache->SetWrapper(obj);
  return obj;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Handle<JSObject*> parentProto(EventTargetBinding::GetProtoObjectHandle(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Handle<JSObject*> constructorProto(EventTargetBinding::GetConstructorObjectHandle(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sAttributes, sAttributes_ids)) {
      return;
    }
    sIdsInited = true;
  }

  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::Telephony),
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 0, nullptr,
                              &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::Telephony),
                              &sNativeProperties,
                              nullptr,
                              "Telephony", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::Telephony)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::Telephony).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::Telephony)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::Telephony).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace TelephonyBinding



} // namespace dom
} // namespace mozilla
