/* THIS FILE IS AUTOGENERATED - DO NOT EDIT */

#include "EventHandlerBinding.h"
#include "EventTargetBinding.h"
#include "VTTCueBinding.h"
#include "WrapperFactory.h"
#include "mozilla/FloatingPoint.h"
#include "mozilla/Preferences.h"
#include "mozilla/dom/BindingUtils.h"
#include "mozilla/dom/DOMJSClass.h"
#include "mozilla/dom/DocumentFragment.h"
#include "mozilla/dom/HTMLDivElement.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/OwningNonNull.h"
#include "mozilla/dom/PrimitiveConversions.h"
#include "mozilla/dom/TextTrack.h"
#include "mozilla/dom/TextTrackCue.h"
#include "mozilla/dom/TextTrackRegion.h"
#include "mozilla/dom/UnionConversions.h"
#include "nsContentUtils.h"

namespace mozilla {
namespace dom {

namespace AutoKeywordValues {
  extern const EnumEntry strings[2] = {
    {"auto", 4},
    { nullptr, 0 }
  };
} // namespace AutoKeywordValues


namespace AlignSettingValues {
  extern const EnumEntry strings[6] = {
    {"start", 5},
    {"middle", 6},
    {"end", 3},
    {"left", 4},
    {"right", 5},
    { nullptr, 0 }
  };
} // namespace AlignSettingValues


namespace DirectionSettingValues {
  extern const EnumEntry strings[4] = {
    {"", 0},
    {"rl", 2},
    {"lr", 2},
    { nullptr, 0 }
  };
} // namespace DirectionSettingValues


namespace VTTCueBinding {

static bool
get_track(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  auto result(StrongOrRawPtr<mozilla::dom::TextTrack>(self->GetTrack()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!result) {
    args.rval().setNull();
    return true;
  }
  if (!WrapNewBindingObject(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}


static const JSJitInfo track_getterinfo = {
 { (JSJitGetterOp)get_track },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_id(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetId(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static bool
set_id(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  self->SetId(NonNullHelper(Constify(arg0)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo id_getterinfo = {
 { (JSJitGetterOp)get_id },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo id_setterinfo = {
 { (JSJitGetterOp)set_id },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_startTime(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  double result(self->StartTime());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().set(JS_NumberValue(double(result)));
  return true;
}

static bool
set_startTime(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  double arg0;
  if (!ValueToPrimitive<double, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Value being assigned to VTTCue.startTime");
    return false;
  }
  self->SetStartTime(arg0);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo startTime_getterinfo = {
 { (JSJitGetterOp)get_startTime },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo startTime_setterinfo = {
 { (JSJitGetterOp)set_startTime },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_endTime(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  double result(self->EndTime());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().set(JS_NumberValue(double(result)));
  return true;
}

static bool
set_endTime(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  double arg0;
  if (!ValueToPrimitive<double, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Value being assigned to VTTCue.endTime");
    return false;
  }
  self->SetEndTime(arg0);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo endTime_getterinfo = {
 { (JSJitGetterOp)get_endTime },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_DOUBLE,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo endTime_setterinfo = {
 { (JSJitGetterOp)set_endTime },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_pauseOnExit(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  bool result(self->PauseOnExit());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static bool
set_pauseOnExit(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  bool arg0;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  self->SetPauseOnExit(arg0);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo pauseOnExit_getterinfo = {
 { (JSJitGetterOp)get_pauseOnExit },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo pauseOnExit_setterinfo = {
 { (JSJitGetterOp)set_pauseOnExit },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_region(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  auto result(StrongOrRawPtr<mozilla::dom::TextTrackRegion>(self->GetRegion()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!result) {
    args.rval().setNull();
    return true;
  }
  if (!WrapNewBindingObject(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static bool
set_region(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  mozilla::dom::TextTrackRegion* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::VTTRegion, mozilla::dom::TextTrackRegion>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Value being assigned to VTTCue.region", "VTTRegion");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Value being assigned to VTTCue.region");
    return false;
  }
  self->SetRegion(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo region_getterinfo = {
 { (JSJitGetterOp)get_region },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo region_setterinfo = {
 { (JSJitGetterOp)set_region },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_vertical(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  DirectionSetting result(self->Vertical());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  {
    // Scope for resultStr
    MOZ_ASSERT(uint32_t(result) < ArrayLength(DirectionSettingValues::strings));
    JSString* resultStr = JS_NewStringCopyN(cx, DirectionSettingValues::strings[uint32_t(result)].value, DirectionSettingValues::strings[uint32_t(result)].length);
    if (!resultStr) {
      return false;
    }
    args.rval().setString(resultStr);
    return true;
  }
}

static bool
set_vertical(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  DirectionSetting arg0;
  {
    bool ok;
    int index = FindEnumStringIndex<false>(cx, args[0], DirectionSettingValues::strings, "DirectionSetting", "Value being assigned to VTTCue.vertical", &ok);
    if (!ok) {
      return false;
    }
    if (index < 0) {
      return true;
    }
    arg0 = static_cast<DirectionSetting>(index);
  }
  self->SetVertical(arg0);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo vertical_getterinfo = {
 { (JSJitGetterOp)get_vertical },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo vertical_setterinfo = {
 { (JSJitGetterOp)set_vertical },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_snapToLines(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  bool result(self->SnapToLines());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}

static bool
set_snapToLines(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  bool arg0;
  if (!ValueToPrimitive<bool, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  self->SetSnapToLines(arg0);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo snapToLines_getterinfo = {
 { (JSJitGetterOp)get_snapToLines },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo snapToLines_setterinfo = {
 { (JSJitGetterOp)set_snapToLines },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_line(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  OwningLongOrAutoKeyword result;
  self->GetLine(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!result.ToJSVal(cx, obj, args.rval())) {
    return false;
  }
  return true;
}

static bool
set_line(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  LongOrAutoKeyword arg0;
  LongOrAutoKeywordArgument arg0_holder(arg0);
  {
    bool done = false, failed = false, tryNext;
    do {
      if (args[0].isNumber()) {
        done = (failed = !arg0_holder.TrySetToLong(cx, args[0], tryNext)) || !tryNext;
        break;
      }
      done = (failed = !arg0_holder.TrySetToAutoKeyword(cx, args[0], tryNext)) || !tryNext;
      break;
    } while (0);
    if (failed) {
      return false;
    }
    if (!done) {
      ThrowErrorMessage(cx, MSG_NOT_IN_UNION, "Value being assigned to VTTCue.line", "");
      return false;
    }
  }
  self->SetLine(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo line_getterinfo = {
 { (JSJitGetterOp)get_line },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo line_setterinfo = {
 { (JSJitGetterOp)set_line },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_lineAlign(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  AlignSetting result(self->LineAlign());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  {
    // Scope for resultStr
    MOZ_ASSERT(uint32_t(result) < ArrayLength(AlignSettingValues::strings));
    JSString* resultStr = JS_NewStringCopyN(cx, AlignSettingValues::strings[uint32_t(result)].value, AlignSettingValues::strings[uint32_t(result)].length);
    if (!resultStr) {
      return false;
    }
    args.rval().setString(resultStr);
    return true;
  }
}

static bool
set_lineAlign(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  AlignSetting arg0;
  {
    bool ok;
    int index = FindEnumStringIndex<false>(cx, args[0], AlignSettingValues::strings, "AlignSetting", "Value being assigned to VTTCue.lineAlign", &ok);
    if (!ok) {
      return false;
    }
    if (index < 0) {
      return true;
    }
    arg0 = static_cast<AlignSetting>(index);
  }
  ErrorResult rv;
  self->SetLineAlign(arg0, rv);
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "VTTCue", "lineAlign");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo lineAlign_getterinfo = {
 { (JSJitGetterOp)get_lineAlign },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo lineAlign_setterinfo = {
 { (JSJitGetterOp)set_lineAlign },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_position(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  int32_t result(self->Position());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static bool
set_position(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  int32_t arg0;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  ErrorResult rv;
  self->SetPosition(arg0, rv);
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "VTTCue", "position");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo position_getterinfo = {
 { (JSJitGetterOp)get_position },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo position_setterinfo = {
 { (JSJitGetterOp)set_position },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_positionAlign(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  AlignSetting result(self->PositionAlign());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  {
    // Scope for resultStr
    MOZ_ASSERT(uint32_t(result) < ArrayLength(AlignSettingValues::strings));
    JSString* resultStr = JS_NewStringCopyN(cx, AlignSettingValues::strings[uint32_t(result)].value, AlignSettingValues::strings[uint32_t(result)].length);
    if (!resultStr) {
      return false;
    }
    args.rval().setString(resultStr);
    return true;
  }
}

static bool
set_positionAlign(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  AlignSetting arg0;
  {
    bool ok;
    int index = FindEnumStringIndex<false>(cx, args[0], AlignSettingValues::strings, "AlignSetting", "Value being assigned to VTTCue.positionAlign", &ok);
    if (!ok) {
      return false;
    }
    if (index < 0) {
      return true;
    }
    arg0 = static_cast<AlignSetting>(index);
  }
  ErrorResult rv;
  self->SetPositionAlign(arg0, rv);
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "VTTCue", "positionAlign");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo positionAlign_getterinfo = {
 { (JSJitGetterOp)get_positionAlign },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo positionAlign_setterinfo = {
 { (JSJitGetterOp)set_positionAlign },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_size(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  int32_t result(self->Size());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setInt32(int32_t(result));
  return true;
}

static bool
set_size(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  int32_t arg0;
  if (!ValueToPrimitive<int32_t, eDefault>(cx, args[0], &arg0)) {
    return false;
  }
  ErrorResult rv;
  self->SetSize(arg0, rv);
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "VTTCue", "size");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo size_getterinfo = {
 { (JSJitGetterOp)get_size },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_INT32,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo size_setterinfo = {
 { (JSJitGetterOp)set_size },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_align(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  AlignSetting result(self->Align());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  {
    // Scope for resultStr
    MOZ_ASSERT(uint32_t(result) < ArrayLength(AlignSettingValues::strings));
    JSString* resultStr = JS_NewStringCopyN(cx, AlignSettingValues::strings[uint32_t(result)].value, AlignSettingValues::strings[uint32_t(result)].length);
    if (!resultStr) {
      return false;
    }
    args.rval().setString(resultStr);
    return true;
  }
}

static bool
set_align(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  AlignSetting arg0;
  {
    bool ok;
    int index = FindEnumStringIndex<false>(cx, args[0], AlignSettingValues::strings, "AlignSetting", "Value being assigned to VTTCue.align", &ok);
    if (!ok) {
      return false;
    }
    if (index < 0) {
      return true;
    }
    arg0 = static_cast<AlignSetting>(index);
  }
  self->SetAlign(arg0);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo align_getterinfo = {
 { (JSJitGetterOp)get_align },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo align_setterinfo = {
 { (JSJitGetterOp)set_align },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_text(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  DOMString result;
  self->GetText(result);
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!xpc::NonVoidStringToJsval(cx, result, args.rval())) {
    return false;
  }
  return true;
}

static bool
set_text(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  binding_detail::FakeString arg0;
  if (!ConvertJSValueToString(cx, args[0], eStringify, eStringify, arg0)) {
    return false;
  }
  self->SetText(NonNullHelper(Constify(arg0)));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo text_getterinfo = {
 { (JSJitGetterOp)get_text },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_STRING,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo text_setterinfo = {
 { (JSJitGetterOp)set_text },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
getCueAsHTML(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, const JSJitMethodCallArgs& args)
{
  auto result(StrongOrRawPtr<mozilla::dom::DocumentFragment>(self->GetCueAsHTML()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!WrapNewBindingObject(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}


static const JSJitInfo getCueAsHTML_methodinfo = {
 { (JSJitGetterOp)getCueAsHTML },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Method,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_OBJECT,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_onenter(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> result(self->GetOnenter());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onenter(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOnenter(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo onenter_getterinfo = {
 { (JSJitGetterOp)get_onenter },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo onenter_setterinfo = {
 { (JSJitGetterOp)set_onenter },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_onexit(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> result(self->GetOnexit());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (result) {
    args.rval().setObject(*GetCallbackFromCallbackObject(result));
    if (!MaybeWrapObjectOrNullValue(cx, args.rval())) {
      return false;
    }
    return true;
  } else {
    args.rval().setNull();
    return true;
  }
}

static bool
set_onexit(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  nsRefPtr<EventHandlerNonNull> arg0;
  if (args[0].isObject()) {
      { // Scope for tempRoot
        JS::Rooted<JSObject*> tempRoot(cx, &args[0].toObject());
        arg0 = new EventHandlerNonNull(tempRoot, mozilla::dom::GetIncumbentGlobal());
      }
  } else {
    arg0 = nullptr;
  }
  self->SetOnexit(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo onexit_getterinfo = {
 { (JSJitGetterOp)get_onexit },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo onexit_setterinfo = {
 { (JSJitGetterOp)set_onexit },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_displayState(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  auto result(StrongOrRawPtr<mozilla::dom::HTMLDivElement>(self->GetDisplayState()));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  if (!result) {
    args.rval().setNull();
    return true;
  }
  if (!WrapNewBindingObject(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static bool
set_displayState(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitSetterCallArgs args)
{
  mozilla::dom::HTMLDivElement* arg0;
  if (args[0].isObject()) {
    {
      nsresult rv = UnwrapObject<prototypes::id::HTMLDivElement, mozilla::dom::HTMLDivElement>(&args[0].toObject(), arg0);
      if (NS_FAILED(rv)) {
        ThrowErrorMessage(cx, MSG_DOES_NOT_IMPLEMENT_INTERFACE, "Value being assigned to VTTCue.displayState", "HTMLDivElement");
        return false;
      }
    }
  } else if (args[0].isNullOrUndefined()) {
    arg0 = nullptr;
  } else {
    ThrowErrorMessage(cx, MSG_NOT_OBJECT, "Value being assigned to VTTCue.displayState");
    return false;
  }
  self->SetDisplayState(Constify(arg0));
  MOZ_ASSERT(!JS_IsExceptionPending(cx));

  return true;
}


static const JSJitInfo displayState_getterinfo = {
 { (JSJitGetterOp)get_displayState },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNKNOWN,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static const JSJitInfo displayState_setterinfo = {
 { (JSJitGetterOp)set_displayState },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Setter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_UNDEFINED,  /* returnType.  Not relevant for setters. */
  false,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
get_hasBeenReset(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::TextTrackCue* self, JSJitGetterCallArgs args)
{
  bool result(self->HasBeenReset());
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  args.rval().setBoolean(result);
  return true;
}


static const JSJitInfo hasBeenReset_getterinfo = {
 { (JSJitGetterOp)get_hasBeenReset },
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  JSJitInfo::Getter,
  JSJitInfo::AliasEverything, /* aliasSet.  Not relevant for setters. */
  JSVAL_TYPE_BOOLEAN,  /* returnType.  Not relevant for setters. */
  true,  /* isInfallible. False in setters. */
  false,  /* isMovable.  Not relevant for setters. */
  false, /* isAlwaysInSlot.  Only relevant for getters. */
  false, /* isLazilyCachedInSlot.  Only relevant for getters. */
  false,  /* isTypedMethod.  Only relevant for methods. */
  0   /* Reserved slot index, if we're stored in a slot, else 0. */
};

static bool
_addProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::MutableHandle<JS::Value> vp)
{
  mozilla::dom::TextTrackCue* self = UnwrapDOMObject<mozilla::dom::TextTrackCue>(obj);
  // We don't want to preserve if we don't have a wrapper.
  if (self->GetWrapperPreserveColor()) {
    PreserveWrapper(self);
  }
  return true;
}

static void
_finalize(js::FreeOp* fop, JSObject* obj)
{
  mozilla::dom::TextTrackCue* self = UnwrapDOMObject<mozilla::dom::TextTrackCue>(obj);
  if (self) {
    JSBindingFinalized<mozilla::dom::TextTrackCue>::Finalized(self);
    ClearWrapper(self, self);
    AddForDeferredFinalization<mozilla::dom::TextTrackCue, nsRefPtr >(self);
  }
}

static void
_objectMoved(JSObject* obj, const JSObject* old)
{
  mozilla::dom::TextTrackCue* self = UnwrapDOMObject<mozilla::dom::TextTrackCue>(obj);
  if (self) {
    UpdateWrapper(self, self, obj, old);
  }
}

static const JSFunctionSpec sMethods_specs[] = {
  JS_FNSPEC("getCueAsHTML", GenericBindingMethod, reinterpret_cast<const JSJitInfo*>(&getCueAsHTML_methodinfo), 0, JSPROP_ENUMERATE, nullptr),
  JS_FS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSFunctionSpec> sMethods[] = {
  { true, nullptr, nullptr, nullptr, &sMethods_specs[0] },
  { false, nullptr }
};

static jsid sMethods_ids[2];

static const JSPropertySpec sAttributes_specs[] = {
  { "track", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &track_getterinfo } }, JSOP_NULLWRAPPER},
  { "id", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &id_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &id_setterinfo } }},
  { "startTime", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &startTime_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &startTime_setterinfo } }},
  { "endTime", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &endTime_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &endTime_setterinfo } }},
  { "pauseOnExit", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &pauseOnExit_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &pauseOnExit_setterinfo } }},
  JS_PS_END,
  { "region", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &region_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &region_setterinfo } }},
  JS_PS_END,
  { "vertical", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &vertical_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &vertical_setterinfo } }},
  { "snapToLines", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &snapToLines_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &snapToLines_setterinfo } }},
  { "line", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &line_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &line_setterinfo } }},
  { "lineAlign", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &lineAlign_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &lineAlign_setterinfo } }},
  { "position", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &position_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &position_setterinfo } }},
  { "positionAlign", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &positionAlign_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &positionAlign_setterinfo } }},
  { "size", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &size_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &size_setterinfo } }},
  { "align", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &align_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &align_setterinfo } }},
  { "text", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &text_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &text_setterinfo } }},
  { "onenter", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &onenter_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &onenter_setterinfo } }},
  { "onexit", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &onexit_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &onexit_setterinfo } }},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sAttributes[] = {
  { true, nullptr, nullptr, nullptr, &sAttributes_specs[0] },
  { true, nullptr, nullptr, nullptr, &sAttributes_specs[6] },
  { true, nullptr, nullptr, nullptr, &sAttributes_specs[8] },
  { false, nullptr }
};

static jsid sAttributes_ids[20];

static const JSPropertySpec sChromeAttributes_specs[] = {
  { "displayState", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &displayState_getterinfo } }, { { JS_CAST_NATIVE_TO(GenericBindingSetter, JSStrictPropertyOp), &displayState_setterinfo } }},
  { "hasBeenReset", JSPROP_SHARED | JSPROP_ENUMERATE | JSPROP_NATIVE_ACCESSORS, { { JS_CAST_NATIVE_TO(GenericBindingGetter, JSPropertyOp), &hasBeenReset_getterinfo } }, JSOP_NULLWRAPPER},
  JS_PS_END
};

// Can't be const because the pref-enabled boolean needs to be writable
static Prefable<const JSPropertySpec> sChromeAttributes[] = {
  { true, nullptr, nullptr, nullptr, &sChromeAttributes_specs[0] },
  { false, nullptr }
};

static jsid sChromeAttributes_ids[3];


static const NativeProperties sNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sMethods, sMethods_ids, sMethods_specs,
  sAttributes, sAttributes_ids, sAttributes_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr
};

static const NativeProperties sChromeOnlyNativeProperties = {
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  sChromeAttributes, sChromeAttributes_ids, sChromeAttributes_specs,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr,
  nullptr, nullptr, nullptr
};

const NativePropertyHooks sNativePropertyHooks[] = { {
  nullptr,
  nullptr,
  { &sNativeProperties, &sChromeOnlyNativeProperties },
  prototypes::id::VTTCue,
  constructors::id::VTTCue,
  EventTargetBinding::sNativePropertyHooks
} };

static bool
_constructor(JSContext* cx, unsigned argc, JS::Value* vp)
{
  JS::CallArgs args = JS::CallArgsFromVp(argc, vp);
  JS::Rooted<JSObject*> obj(cx, &args.callee());
  bool mayInvoke = args.isConstructing();
#ifdef RELEASE_BUILD
  mayInvoke = mayInvoke || nsContentUtils::ThreadsafeIsCallerChrome();
#endif // RELEASE_BUILD
  if (!mayInvoke) {
    // XXXbz wish I could get the name from the callee instead of
    // Adding more relocations
    return ThrowConstructorWithoutNew(cx, "VTTCue");
  }

  if (args.length() < 3) {
    return ThrowErrorMessage(cx, MSG_MISSING_ARGUMENTS, "VTTCue");
  }
  GlobalObject global(cx, obj);
  if (global.Failed()) {
    return false;
  }

  bool objIsXray = xpc::WrapperFactory::IsXrayWrapper(obj);
  double arg0;
  if (!ValueToPrimitive<double, eDefault>(cx, args[0], &arg0)) {
    return false;
  } else if (!mozilla::IsFinite(arg0)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 1 of VTTCue.constructor");
    return false;
  }
  double arg1;
  if (!ValueToPrimitive<double, eDefault>(cx, args[1], &arg1)) {
    return false;
  } else if (!mozilla::IsFinite(arg1)) {
    // Note: mozilla::IsFinite will do the right thing
    //       when passed a non-finite float too.
    ThrowErrorMessage(cx, MSG_NOT_FINITE, "Argument 2 of VTTCue.constructor");
    return false;
  }
  binding_detail::FakeString arg2;
  if (!ConvertJSValueToString(cx, args[2], eStringify, eStringify, arg2)) {
    return false;
  }
  Maybe<JSAutoCompartment> ac;
  if (objIsXray) {
    obj = js::CheckedUnwrap(obj);
    if (!obj) {
      return false;
    }
    ac.emplace(cx, obj);
  }
  ErrorResult rv;
  auto result(StrongOrRawPtr<mozilla::dom::TextTrackCue>(mozilla::dom::TextTrackCue::Constructor(global, arg0, arg1, NonNullHelper(Constify(arg2)), rv)));
  rv.WouldReportJSException();
  if (rv.Failed()) {
    return ThrowMethodFailedWithDetails(cx, rv, "VTTCue", "constructor");
  }
  MOZ_ASSERT(!JS_IsExceptionPending(cx));
  static_assert(!IsPointer<decltype(result)>::value,
                "NewObject implies that we need to keep the object alive with a strong reference.");
  if (!WrapNewBindingObject(cx, obj, result, args.rval())) {
    MOZ_ASSERT(true || JS_IsExceptionPending(cx));
    return false;
  }
  return true;
}

static const DOMIfaceAndProtoJSClass InterfaceObjectClass = {
  {
    "Function",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_SLOTS_BASE),
    JS_PropertyStub,       /* addProperty */
    JS_DeletePropertyStub, /* delProperty */
    JS_PropertyStub,       /* getProperty */
    JS_StrictPropertyStub, /* setProperty */
    JS_EnumerateStub,
    JS_ResolveStub,
    JS_ConvertStub,
    nullptr,               /* finalize */
    _constructor, /* call */
    InterfaceHasInstance, /* hasInstance */
    _constructor, /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterface,
  sNativePropertyHooks,
  "function VTTCue() {\n    [native code]\n}",
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  EventTargetBinding::GetConstructorObject
};

static const DOMIfaceAndProtoJSClass PrototypeClass = {
  {
    "VTTCuePrototype",
    JSCLASS_IS_DOMIFACEANDPROTOJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(DOM_INTERFACE_PROTO_SLOTS_BASE),
    JS_PropertyStub,       /* addProperty */
    JS_DeletePropertyStub, /* delProperty */
    JS_PropertyStub,       /* getProperty */
    JS_StrictPropertyStub, /* setProperty */
    JS_EnumerateStub,
    JS_ResolveStub,
    JS_ConvertStub,
    nullptr,               /* finalize */
    nullptr,               /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr,               /* trace */
    JS_NULL_CLASS_SPEC,
    JS_NULL_CLASS_EXT,
    JS_NULL_OBJECT_OPS
  },
  eInterfacePrototype,
  sNativePropertyHooks,
  "[object VTTCuePrototype]",
  prototypes::id::VTTCue,
  PrototypeTraits<prototypes::id::VTTCue>::Depth,
  EventTargetBinding::GetProtoObject
};

JSObject*
DefineDOMInterface(JSContext* aCx, JS::Handle<JSObject*> aGlobal, JS::Handle<jsid> id, bool aDefineOnGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal, aDefineOnGlobal);
}

bool
ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  return Preferences::GetBool("media.webvtt.enabled");
}

static const DOMJSClass Class = {
  { "VTTCue",
    JSCLASS_IS_DOMJSCLASS | JSCLASS_HAS_RESERVED_SLOTS(1),
    _addProperty, /* addProperty */
    JS_DeletePropertyStub, /* delProperty */
    JS_PropertyStub,       /* getProperty */
    JS_StrictPropertyStub, /* setProperty */
    JS_EnumerateStub, /* enumerate */
    JS_ResolveStub, /* resolve */
    JS_ConvertStub,
    _finalize, /* finalize */
    nullptr, /* call */
    nullptr,               /* hasInstance */
    nullptr,               /* construct */
    nullptr, /* trace */
    JS_NULL_CLASS_SPEC,
    {
      nullptr, /* outerObject */
      nullptr, /* innerObject */
      nullptr, /* iteratorObject */
      false,   /* isWrappedNative */
      nullptr, /* weakmapKeyDelegateOp */
      _objectMoved /* objectMovedOp */
    },
    JS_NULL_OBJECT_OPS
  },
  { prototypes::id::EventTarget, prototypes::id::VTTCue, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count, prototypes::id::_ID_Count },
  IsBaseOf<nsISupports, mozilla::dom::TextTrackCue >::value,
  sNativePropertyHooks,
  GetParentObject<mozilla::dom::TextTrackCue>::Get,
  GetProtoObjectHandle,
  GetCCParticipant<mozilla::dom::TextTrackCue>::Get()
};
static_assert(1 == DOM_INSTANCE_RESERVED_SLOTS,
              "Must have the right minimal number of reserved slots.");
static_assert(1 >= 1,
              "Must have enough reserved slots.");

const JSClass*
GetJSClass()
{
  return Class.ToJSClass();
}

JSObject*
Wrap(JSContext* aCx, mozilla::dom::TextTrackCue* aObject, nsWrapperCache* aCache)
{
  MOZ_ASSERT(static_cast<mozilla::dom::TextTrackCue*>(aObject) ==
             reinterpret_cast<mozilla::dom::TextTrackCue*>(aObject));
  MOZ_ASSERT(static_cast<mozilla::dom::EventTarget*>(aObject) ==
             reinterpret_cast<mozilla::dom::EventTarget*>(aObject));
  MOZ_ASSERT(ToSupportsIsCorrect(aObject));

  MOZ_ASSERT(ToSupportsIsOnPrimaryInheritanceChain(aObject, aCache),
             "nsISupports must be on our primary inheritance chain");

  JS::Rooted<JSObject*> parent(aCx,
    GetRealParentObject(aObject,
                        WrapNativeParent(aCx, aObject->GetParentObject())));
  if (!parent) {
    return nullptr;
  }

  // That might have ended up wrapping us already, due to the wonders
  // of XBL.  Check for that, and bail out as needed.  Scope so we don't
  // collide with the "obj" we declare in CreateBindingJSObject.
  {
    JSObject* obj = aCache->GetWrapper();
    if (obj) {
      return obj;
    }
  }

  JSAutoCompartment ac(aCx, parent);
  JS::Rooted<JSObject*> global(aCx, JS_GetGlobalForObject(aCx, parent));
  JS::Handle<JSObject*> proto = GetProtoObjectHandle(aCx, global);
  if (!proto) {
    return nullptr;
  }

  JS::Rooted<JSObject*> obj(aCx);
  obj = JS_NewObject(aCx, Class.ToJSClass(), proto, parent);
  if (!obj) {
    return nullptr;
  }

  js::SetReservedSlot(obj, DOM_OBJECT_SLOT, PRIVATE_TO_JSVAL(aObject));
  NS_ADDREF(aObject);


  aCache->SetWrapper(obj);
  return obj;
}

void
CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal)
{
  JS::Handle<JSObject*> parentProto(EventTargetBinding::GetProtoObjectHandle(aCx, aGlobal));
  if (!parentProto) {
    return;
  }

  JS::Handle<JSObject*> constructorProto(EventTargetBinding::GetConstructorObjectHandle(aCx, aGlobal));
  if (!constructorProto) {
    return;
  }

  static bool sIdsInited = false;
  if (!sIdsInited && NS_IsMainThread()) {
    if (!InitIds(aCx, sMethods, sMethods_ids)) {
      return;
    }
    if (!InitIds(aCx, sChromeAttributes, sChromeAttributes_ids)) {
      return;
    }
    if (!InitIds(aCx, sAttributes, sAttributes_ids)) {
      return;
    }
    sIdsInited = true;
  }

  static bool sPrefCachesInited = false;
  if (!sPrefCachesInited) {
    sPrefCachesInited = true;
    Preferences::AddBoolVarCache(&sAttributes[1].enabled, "media.webvtt.regions.enabled");
  }

  dom::CreateInterfaceObjects(aCx, aGlobal, parentProto,
                              &PrototypeClass.mBase, &aProtoAndIfaceCache.EntrySlotOrCreate(prototypes::id::VTTCue),
                              constructorProto, &InterfaceObjectClass.mBase, nullptr, 3, nullptr,
                              &aProtoAndIfaceCache.EntrySlotOrCreate(constructors::id::VTTCue),
                              &sNativeProperties,
                              nsContentUtils::ThreadsafeIsCallerChrome() ? &sChromeOnlyNativeProperties : nullptr,
                              "VTTCue", aDefineOnGlobal);
}

JS::Handle<JSObject*>
GetProtoObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  /* Get the interface prototype object for this class.  This will create the
     object as needed. */
  bool aDefineOnGlobal = true;

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(prototypes::id::VTTCue)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(prototypes::id::VTTCue).address());
}

JS::Handle<JSObject*>
GetConstructorObjectHandle(JSContext* aCx, JS::Handle<JSObject*> aGlobal, bool aDefineOnGlobal)
{
  /* Get the interface object for this class.  This will create the object as
     needed. */

  /* Make sure our global is sane.  Hopefully we can remove this sometime */
  if (!(js::GetObjectClass(aGlobal)->flags & JSCLASS_DOM_GLOBAL)) {
    return JS::NullPtr();
  }

  /* Check to see whether the interface objects are already installed */
  ProtoAndIfaceCache& protoAndIfaceCache = *GetProtoAndIfaceCache(aGlobal);
  if (!protoAndIfaceCache.EntrySlotIfExists(constructors::id::VTTCue)) {
    CreateInterfaceObjects(aCx, aGlobal, protoAndIfaceCache, aDefineOnGlobal);
  }

  /*
   * The object might _still_ be null, but that's OK.
   *
   * Calling fromMarkedLocation() is safe because protoAndIfaceCache is
   * traced by TraceProtoAndIfaceCache() and its contents are never
   * changed after they have been set.
   */
  return JS::Handle<JSObject*>::fromMarkedLocation(protoAndIfaceCache.EntrySlotMustExist(constructors::id::VTTCue).address());
}

JSObject*
GetConstructorObject(JSContext* aCx, JS::Handle<JSObject*> aGlobal)
{
  return GetConstructorObjectHandle(aCx, aGlobal);
}

} // namespace VTTCueBinding



} // namespace dom
} // namespace mozilla
