//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PDNSRequestChild.h"

#include "mozilla/net/PNeckoChild.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace net {


auto PDNSRequestChild::ActorDestroy(ActorDestroyReason aWhy) -> void
{
}

MOZ_IMPLICIT PDNSRequestChild::PDNSRequestChild() :
    mId(0),
    mState(PDNSRequest::__Dead)
{
    MOZ_COUNT_CTOR(PDNSRequestChild);
}

PDNSRequestChild::~PDNSRequestChild()
{
    MOZ_COUNT_DTOR(PDNSRequestChild);
}

auto PDNSRequestChild::Manager() const -> PNeckoChild*
{
    return static_cast<PNeckoChild*>(mManager);
}

auto PDNSRequestChild::state() -> PDNSRequest::State
{
    return mState;
}

auto PDNSRequestChild::SendCancelDNSRequest(
        const nsCString& hostName,
        const uint32_t& flags,
        const nsresult& reason) -> bool
{
    PDNSRequest::Msg_CancelDNSRequest* __msg = new PDNSRequest::Msg_CancelDNSRequest();

    Write(hostName, __msg);
    Write(flags, __msg);
    Write(reason, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PDNSRequestChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PDNSRequest", "AsyncSendCancelDNSRequest", js::ProfileEntry::Category::OTHER);
    if ((!(PDNSRequest::Transition(mState, Trigger(Trigger::Recv, PDNSRequest::Msg_CancelDNSRequest__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PDNSRequestChild::Send__delete__(PDNSRequestChild* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    if ((!(actor))) {
        return false;
    }

    PDNSRequest::Msg___delete__* __msg = new PDNSRequest::Msg___delete__();

    (actor)->Write(actor, __msg, false);

    (__msg)->set_routing_id((actor)->mId);
    (__msg)->set_priority(1);


    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PDNSRequestChild] Sending ", (actor)->OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PDNSRequest", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PDNSRequest::Transition((actor)->mState, Trigger(Trigger::Recv, PDNSRequest::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = ((actor)->mChannel)->Send(__msg);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PDNSRequestMsgStart, actor);
    return __sendok;
}

auto PDNSRequestChild::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PDNSRequestChild::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PDNSRequestChild::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PDNSRequestChild::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PDNSRequestChild::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PDNSRequestChild::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PDNSRequestChild::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PDNSRequestChild::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PDNSRequestChild::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PDNSRequestChild::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PDNSRequestChild::OtherProcess() const -> ProcessHandle
{
    return (mManager)->OtherProcess();
}

auto PDNSRequestChild::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PDNSRequestChild::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PDNSRequestChild::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PDNSRequest has not yet been implemented");
    return nullptr;
}

auto PDNSRequestChild::OnMessageReceived(const Message& __msg) -> PDNSRequestChild::Result
{
    switch ((__msg).type()) {
    case PDNSRequest::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    case PDNSRequest::Msg_LookupCompleted__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PDNSRequest::Msg_LookupCompleted");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PDNSRequest::Msg_LookupCompleted*>((&(__msg))))->Log("[PDNSRequestChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PDNSRequest", "RecvLookupCompleted", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            DNSRequestResponse reply;

            if ((!(Read((&(reply)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'DNSRequestResponse'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PDNSRequest::Transition(mState, Trigger(Trigger::Send, PDNSRequest::Msg_LookupCompleted__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvLookupCompleted(reply)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for LookupCompleted returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PDNSRequestChild::OnMessageReceived(
        const Message& __msg,
        Message*& __reply) -> PDNSRequestChild::Result
{
    return MsgNotKnown;
}

auto PDNSRequestChild::OnCallReceived(
        const Message& __msg,
        Message*& __reply) -> PDNSRequestChild::Result
{
    return MsgNotKnown;
}

auto PDNSRequestChild::OnProcessingError(Result aCode) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PDNSRequestChild::GetProtocolTypeId() -> int32_t
{
    return PDNSRequestMsgStart;
}

auto PDNSRequestChild::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PDNSRequestChild::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PDNSRequestChild::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PDNSRequestChild::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PDNSRequestChild::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PDNSRequestChild::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PDNSRequestChild::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PDNSRequestChild::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PDNSRequestChild::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PDNSRequestChild", aMsg, 0, false);
}

auto PDNSRequestChild::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PDNSRequestChild::DeallocSubtree() -> void
{
}

auto PDNSRequestChild::Write(
        const DNSRequestResponse& __v,
        Message* __msg) -> void
{
    typedef DNSRequestResponse __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::TDNSRecord:
        {
            Write((__v).get_DNSRecord(), __msg);
            return;
        }
    case __type::Tnsresult:
        {
            Write((__v).get_nsresult(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PDNSRequestChild::Read(
        DNSRequestResponse* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef DNSRequestResponse __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'DNSRequestResponse'");
        return false;
    }

    switch (type) {
    case __type::TDNSRecord:
        {
            DNSRecord tmp = DNSRecord();
            (*(__v)) = tmp;
            return Read((&((__v)->get_DNSRecord())), __msg, __iter);
        }
    case __type::Tnsresult:
        {
            nsresult tmp = nsresult();
            (*(__v)) = tmp;
            return Read((&((__v)->get_nsresult())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PDNSRequestChild::Write(
        PDNSRequestChild* __v,
        Message* __msg,
        bool __nullable) -> void
{
    int32_t id;
    if ((!(__v))) {
        if ((!(__nullable))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (__v)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, __msg);
}

auto PDNSRequestChild::Read(
        PDNSRequestChild** __v,
        const Message* __msg,
        void** __iter,
        bool __nullable) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), __msg, __iter)))) {
        FatalError("Error deserializing 'id' for 'PDNSRequestChild'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(__nullable))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PDNSRequest");
        return false;
    }

    if ((0) == (id)) {
        (*(__v)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PDNSRequest");
        return false;
    }

    if ((PDNSRequestMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PDNSRequest has different type");
        return false;
    }

    (*(__v)) = static_cast<PDNSRequestChild*>(listener);
    return true;
}

auto PDNSRequestChild::Write(
        const DNSRecord& __v,
        Message* __msg) -> void
{
    Write((__v).canonicalName(), __msg);
    Write((__v).addrs(), __msg);
}

auto PDNSRequestChild::Read(
        DNSRecord* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->canonicalName())), __msg, __iter)))) {
        FatalError("Error deserializing 'canonicalName' (nsCString) member of 'DNSRecord'");
        return false;
    }
    if ((!(Read((&((__v)->addrs())), __msg, __iter)))) {
        FatalError("Error deserializing 'addrs' (NetAddrArray) member of 'DNSRecord'");
        return false;
    }
    return true;
}



} // namespace net
} // namespace mozilla
