//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PFTPChannelParent.h"

#include "mozilla/net/PNeckoParent.h"
#include "mozilla/dom/PBlobParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace net {


auto PFTPChannelParent::Recv__delete__() -> bool
{
    return true;
}


MOZ_IMPLICIT PFTPChannelParent::PFTPChannelParent() :
    mId(0),
    mState(PFTPChannel::__Dead)
{
    MOZ_COUNT_CTOR(PFTPChannelParent);
}

PFTPChannelParent::~PFTPChannelParent()
{
    MOZ_COUNT_DTOR(PFTPChannelParent);
}

auto PFTPChannelParent::Manager() const -> PNeckoParent*
{
    return static_cast<PNeckoParent*>(mManager);
}

auto PFTPChannelParent::state() -> PFTPChannel::State
{
    return mState;
}

auto PFTPChannelParent::SendOnStartRequest(
        const nsresult& aChannelStatus,
        const int64_t& aContentLength,
        const nsCString& aContentType,
        const PRTime& aLastModified,
        const nsCString& aEntityID,
        const URIParams& aURI) -> bool
{
    PFTPChannel::Msg_OnStartRequest* __msg = new PFTPChannel::Msg_OnStartRequest();

    Write(aChannelStatus, __msg);
    Write(aContentLength, __msg);
    Write(aContentType, __msg);
    Write(aLastModified, __msg);
    Write(aEntityID, __msg);
    Write(aURI, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PFTPChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PFTPChannel", "AsyncSendOnStartRequest", js::ProfileEntry::Category::OTHER);
    if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Send, PFTPChannel::Msg_OnStartRequest__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PFTPChannelParent::SendOnDataAvailable(
        const nsresult& channelStatus,
        const nsCString& data,
        const uint64_t& offset,
        const uint32_t& count) -> bool
{
    PFTPChannel::Msg_OnDataAvailable* __msg = new PFTPChannel::Msg_OnDataAvailable();

    Write(channelStatus, __msg);
    Write(data, __msg);
    Write(offset, __msg);
    Write(count, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PFTPChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PFTPChannel", "AsyncSendOnDataAvailable", js::ProfileEntry::Category::OTHER);
    if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Send, PFTPChannel::Msg_OnDataAvailable__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PFTPChannelParent::SendOnStopRequest(const nsresult& channelStatus) -> bool
{
    PFTPChannel::Msg_OnStopRequest* __msg = new PFTPChannel::Msg_OnStopRequest();

    Write(channelStatus, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PFTPChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PFTPChannel", "AsyncSendOnStopRequest", js::ProfileEntry::Category::OTHER);
    if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Send, PFTPChannel::Msg_OnStopRequest__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PFTPChannelParent::SendFailedAsyncOpen(const nsresult& statusCode) -> bool
{
    PFTPChannel::Msg_FailedAsyncOpen* __msg = new PFTPChannel::Msg_FailedAsyncOpen();

    Write(statusCode, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PFTPChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PFTPChannel", "AsyncSendFailedAsyncOpen", js::ProfileEntry::Category::OTHER);
    if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Send, PFTPChannel::Msg_FailedAsyncOpen__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PFTPChannelParent::SendFlushedForDiversion() -> bool
{
    PFTPChannel::Msg_FlushedForDiversion* __msg = new PFTPChannel::Msg_FlushedForDiversion();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PFTPChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PFTPChannel", "AsyncSendFlushedForDiversion", js::ProfileEntry::Category::OTHER);
    if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Send, PFTPChannel::Msg_FlushedForDiversion__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PFTPChannelParent::SendDivertMessages() -> bool
{
    PFTPChannel::Msg_DivertMessages* __msg = new PFTPChannel::Msg_DivertMessages();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PFTPChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PFTPChannel", "AsyncSendDivertMessages", js::ProfileEntry::Category::OTHER);
    if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Send, PFTPChannel::Msg_DivertMessages__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PFTPChannelParent::SendDeleteSelf() -> bool
{
    PFTPChannel::Msg_DeleteSelf* __msg = new PFTPChannel::Msg_DeleteSelf();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PFTPChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PFTPChannel", "AsyncSendDeleteSelf", js::ProfileEntry::Category::OTHER);
    if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Send, PFTPChannel::Msg_DeleteSelf__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PFTPChannelParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PFTPChannelParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PFTPChannelParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PFTPChannelParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PFTPChannelParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PFTPChannelParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PFTPChannelParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PFTPChannelParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PFTPChannelParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PFTPChannelParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PFTPChannelParent::OtherProcess() const -> ProcessHandle
{
    return (mManager)->OtherProcess();
}

auto PFTPChannelParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PFTPChannelParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PFTPChannelParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PFTPChannel has not yet been implemented");
    return nullptr;
}

auto PFTPChannelParent::OnMessageReceived(const Message& __msg) -> PFTPChannelParent::Result
{
    switch ((__msg).type()) {
    case PFTPChannel::Msg___delete____ID:
        {
            (const_cast<Message&>(__msg)).set_name("PFTPChannel::Msg___delete__");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PFTPChannel::Msg___delete__*>((&(__msg))))->Log("[PFTPChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PFTPChannel", "Recv__delete__", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            PFTPChannelParent* actor;

            if ((!(Read((&(actor)), (&(__msg)), (&(__iter)), false)))) {
                FatalError("Error deserializing 'PFTPChannelParent'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Recv, PFTPChannel::Msg___delete____ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(Recv__delete__()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for __delete__ returned error code");
                return MsgProcessingError;
            }

            (actor)->DestroySubtree(Deletion);
            (actor)->DeallocSubtree();
            ((actor)->mManager)->RemoveManagee(PFTPChannelMsgStart, actor);


            return MsgProcessed;
        }
    case PFTPChannel::Msg_Cancel__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PFTPChannel::Msg_Cancel");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PFTPChannel::Msg_Cancel*>((&(__msg))))->Log("[PFTPChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PFTPChannel", "RecvCancel", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsresult status;

            if ((!(Read((&(status)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Recv, PFTPChannel::Msg_Cancel__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvCancel(status)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Cancel returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PFTPChannel::Msg_Suspend__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PFTPChannel::Msg_Suspend");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PFTPChannel::Msg_Suspend*>((&(__msg))))->Log("[PFTPChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PFTPChannel", "RecvSuspend", js::ProfileEntry::Category::OTHER);

            if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Recv, PFTPChannel::Msg_Suspend__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSuspend()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Suspend returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PFTPChannel::Msg_Resume__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PFTPChannel::Msg_Resume");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PFTPChannel::Msg_Resume*>((&(__msg))))->Log("[PFTPChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PFTPChannel", "RecvResume", js::ProfileEntry::Category::OTHER);

            if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Recv, PFTPChannel::Msg_Resume__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvResume()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Resume returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PFTPChannel::Msg_DivertOnDataAvailable__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PFTPChannel::Msg_DivertOnDataAvailable");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PFTPChannel::Msg_DivertOnDataAvailable*>((&(__msg))))->Log("[PFTPChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PFTPChannel", "RecvDivertOnDataAvailable", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString data;
            uint64_t offset;
            uint32_t count;

            if ((!(Read((&(data)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(offset)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(Read((&(count)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Recv, PFTPChannel::Msg_DivertOnDataAvailable__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDivertOnDataAvailable(data, offset, count)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DivertOnDataAvailable returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PFTPChannel::Msg_DivertOnStopRequest__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PFTPChannel::Msg_DivertOnStopRequest");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PFTPChannel::Msg_DivertOnStopRequest*>((&(__msg))))->Log("[PFTPChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PFTPChannel", "RecvDivertOnStopRequest", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsresult statusCode;

            if ((!(Read((&(statusCode)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Recv, PFTPChannel::Msg_DivertOnStopRequest__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDivertOnStopRequest(statusCode)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DivertOnStopRequest returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PFTPChannel::Msg_DivertComplete__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PFTPChannel::Msg_DivertComplete");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PFTPChannel::Msg_DivertComplete*>((&(__msg))))->Log("[PFTPChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PFTPChannel", "RecvDivertComplete", js::ProfileEntry::Category::OTHER);

            if ((!(PFTPChannel::Transition(mState, Trigger(Trigger::Recv, PFTPChannel::Msg_DivertComplete__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDivertComplete()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DivertComplete returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PFTPChannelParent::OnMessageReceived(
        const Message& __msg,
        Message*& __reply) -> PFTPChannelParent::Result
{
    return MsgNotKnown;
}

auto PFTPChannelParent::OnCallReceived(
        const Message& __msg,
        Message*& __reply) -> PFTPChannelParent::Result
{
    return MsgNotKnown;
}

auto PFTPChannelParent::OnProcessingError(Result aCode) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PFTPChannelParent::GetProtocolTypeId() -> int32_t
{
    return PFTPChannelMsgStart;
}

auto PFTPChannelParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PFTPChannelParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PFTPChannelParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PFTPChannelParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PFTPChannelParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PFTPChannelParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PFTPChannelParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PFTPChannelParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PFTPChannelParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PFTPChannelParent", aMsg, OtherProcess(), true);
}

auto PFTPChannelParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PFTPChannelParent::DeallocSubtree() -> void
{
}

auto PFTPChannelParent::Write(
        const JARURIParams& __v,
        Message* __msg) -> void
{
    Write((__v).jarFile(), __msg);
    Write((__v).jarEntry(), __msg);
    Write((__v).charset(), __msg);
}

auto PFTPChannelParent::Read(
        JARURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->jarFile())), __msg, __iter)))) {
        FatalError("Error deserializing 'jarFile' (URIParams) member of 'JARURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->jarEntry())), __msg, __iter)))) {
        FatalError("Error deserializing 'jarEntry' (URIParams) member of 'JARURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->charset())), __msg, __iter)))) {
        FatalError("Error deserializing 'charset' (nsCString) member of 'JARURIParams'");
        return false;
    }
    return true;
}

auto PFTPChannelParent::Write(
        const StandardURLParams& __v,
        Message* __msg) -> void
{
    Write((__v).urlType(), __msg);
    Write((__v).port(), __msg);
    Write((__v).defaultPort(), __msg);
    Write((__v).spec(), __msg);
    Write((__v).scheme(), __msg);
    Write((__v).authority(), __msg);
    Write((__v).username(), __msg);
    Write((__v).password(), __msg);
    Write((__v).host(), __msg);
    Write((__v).path(), __msg);
    Write((__v).filePath(), __msg);
    Write((__v).directory(), __msg);
    Write((__v).baseName(), __msg);
    Write((__v).extension(), __msg);
    Write((__v).query(), __msg);
    Write((__v).ref(), __msg);
    Write((__v).originCharset(), __msg);
    Write((__v).isMutable(), __msg);
    Write((__v).supportsFileURL(), __msg);
    Write((__v).hostEncoding(), __msg);
}

auto PFTPChannelParent::Read(
        StandardURLParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->urlType())), __msg, __iter)))) {
        FatalError("Error deserializing 'urlType' (uint32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->port())), __msg, __iter)))) {
        FatalError("Error deserializing 'port' (int32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->defaultPort())), __msg, __iter)))) {
        FatalError("Error deserializing 'defaultPort' (int32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->spec())), __msg, __iter)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->scheme())), __msg, __iter)))) {
        FatalError("Error deserializing 'scheme' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->authority())), __msg, __iter)))) {
        FatalError("Error deserializing 'authority' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->username())), __msg, __iter)))) {
        FatalError("Error deserializing 'username' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->password())), __msg, __iter)))) {
        FatalError("Error deserializing 'password' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->host())), __msg, __iter)))) {
        FatalError("Error deserializing 'host' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->path())), __msg, __iter)))) {
        FatalError("Error deserializing 'path' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->filePath())), __msg, __iter)))) {
        FatalError("Error deserializing 'filePath' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->directory())), __msg, __iter)))) {
        FatalError("Error deserializing 'directory' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->baseName())), __msg, __iter)))) {
        FatalError("Error deserializing 'baseName' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->extension())), __msg, __iter)))) {
        FatalError("Error deserializing 'extension' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->query())), __msg, __iter)))) {
        FatalError("Error deserializing 'query' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->ref())), __msg, __iter)))) {
        FatalError("Error deserializing 'ref' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->originCharset())), __msg, __iter)))) {
        FatalError("Error deserializing 'originCharset' (nsCString) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->isMutable())), __msg, __iter)))) {
        FatalError("Error deserializing 'isMutable' (bool) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->supportsFileURL())), __msg, __iter)))) {
        FatalError("Error deserializing 'supportsFileURL' (bool) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->hostEncoding())), __msg, __iter)))) {
        FatalError("Error deserializing 'hostEncoding' (uint32_t) member of 'StandardURLParams'");
        return false;
    }
    return true;
}

auto PFTPChannelParent::Write(
        const GenericURIParams& __v,
        Message* __msg) -> void
{
    Write((__v).spec(), __msg);
    Write((__v).charset(), __msg);
}

auto PFTPChannelParent::Read(
        GenericURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->spec())), __msg, __iter)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'GenericURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->charset())), __msg, __iter)))) {
        FatalError("Error deserializing 'charset' (nsCString) member of 'GenericURIParams'");
        return false;
    }
    return true;
}

auto PFTPChannelParent::Write(
        const StandardURLSegment& __v,
        Message* __msg) -> void
{
    Write((__v).position(), __msg);
    Write((__v).length(), __msg);
}

auto PFTPChannelParent::Read(
        StandardURLSegment* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->position())), __msg, __iter)))) {
        FatalError("Error deserializing 'position' (uint32_t) member of 'StandardURLSegment'");
        return false;
    }
    if ((!(Read((&((__v)->length())), __msg, __iter)))) {
        FatalError("Error deserializing 'length' (int32_t) member of 'StandardURLSegment'");
        return false;
    }
    return true;
}

auto PFTPChannelParent::Write(
        PFTPChannelParent* __v,
        Message* __msg,
        bool __nullable) -> void
{
    int32_t id;
    if ((!(__v))) {
        if ((!(__nullable))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (__v)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, __msg);
}

auto PFTPChannelParent::Read(
        PFTPChannelParent** __v,
        const Message* __msg,
        void** __iter,
        bool __nullable) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), __msg, __iter)))) {
        FatalError("Error deserializing 'id' for 'PFTPChannelParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(__nullable))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PFTPChannel");
        return false;
    }

    if ((0) == (id)) {
        (*(__v)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PFTPChannel");
        return false;
    }

    if ((PFTPChannelMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PFTPChannel has different type");
        return false;
    }

    (*(__v)) = static_cast<PFTPChannelParent*>(listener);
    return true;
}

auto PFTPChannelParent::Write(
        const URIParams& __v,
        Message* __msg) -> void
{
    typedef URIParams __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::TSimpleURIParams:
        {
            Write((__v).get_SimpleURIParams(), __msg);
            return;
        }
    case __type::TStandardURLParams:
        {
            Write((__v).get_StandardURLParams(), __msg);
            return;
        }
    case __type::TJARURIParams:
        {
            Write((__v).get_JARURIParams(), __msg);
            return;
        }
    case __type::TGenericURIParams:
        {
            Write((__v).get_GenericURIParams(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PFTPChannelParent::Read(
        URIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef URIParams __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'URIParams'");
        return false;
    }

    switch (type) {
    case __type::TSimpleURIParams:
        {
            SimpleURIParams tmp = SimpleURIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_SimpleURIParams())), __msg, __iter);
        }
    case __type::TStandardURLParams:
        {
            StandardURLParams tmp = StandardURLParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_StandardURLParams())), __msg, __iter);
        }
    case __type::TJARURIParams:
        {
            JARURIParams tmp = JARURIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_JARURIParams())), __msg, __iter);
        }
    case __type::TGenericURIParams:
        {
            GenericURIParams tmp = GenericURIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_GenericURIParams())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PFTPChannelParent::Write(
        const SimpleURIParams& __v,
        Message* __msg) -> void
{
    Write((__v).scheme(), __msg);
    Write((__v).path(), __msg);
    Write((__v).ref(), __msg);
    Write((__v).isMutable(), __msg);
}

auto PFTPChannelParent::Read(
        SimpleURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->scheme())), __msg, __iter)))) {
        FatalError("Error deserializing 'scheme' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->path())), __msg, __iter)))) {
        FatalError("Error deserializing 'path' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->ref())), __msg, __iter)))) {
        FatalError("Error deserializing 'ref' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->isMutable())), __msg, __iter)))) {
        FatalError("Error deserializing 'isMutable' (bool) member of 'SimpleURIParams'");
        return false;
    }
    return true;
}



} // namespace net
} // namespace mozilla
