//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/gmp/PGMPStorageChild.h"

#include "mozilla/gmp/PGMPChild.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace gmp {


auto PGMPStorageChild::ActorDestroy(ActorDestroyReason aWhy) -> void
{
}

MOZ_IMPLICIT PGMPStorageChild::PGMPStorageChild() :
    mId(0),
    mState(PGMPStorage::__Dead)
{
    MOZ_COUNT_CTOR(PGMPStorageChild);
}

PGMPStorageChild::~PGMPStorageChild()
{
    MOZ_COUNT_DTOR(PGMPStorageChild);
}

auto PGMPStorageChild::Manager() const -> PGMPChild*
{
    return static_cast<PGMPChild*>(mManager);
}

auto PGMPStorageChild::state() -> PGMPStorage::State
{
    return mState;
}

auto PGMPStorageChild::SendOpen(const nsCString& aRecordName) -> bool
{
    PGMPStorage::Msg_Open* __msg = new PGMPStorage::Msg_Open();

    Write(aRecordName, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (__msg)->Log("[PGMPStorageChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendOpen", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Open__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PGMPStorageChild::SendRead(const nsCString& aRecordName) -> bool
{
    PGMPStorage::Msg_Read* __msg = new PGMPStorage::Msg_Read();

    Write(aRecordName, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (__msg)->Log("[PGMPStorageChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendRead", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Read__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PGMPStorageChild::SendWrite(
        const nsCString& aRecordName,
        const nsTArray<uint8_t>& aBytes) -> bool
{
    PGMPStorage::Msg_Write* __msg = new PGMPStorage::Msg_Write();

    Write(aRecordName, __msg);
    Write(aBytes, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (__msg)->Log("[PGMPStorageChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendWrite", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Write__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PGMPStorageChild::SendClose(const nsCString& aRecordName) -> bool
{
    PGMPStorage::Msg_Close* __msg = new PGMPStorage::Msg_Close();

    Write(aRecordName, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (__msg)->Log("[PGMPStorageChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendClose", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Close__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PGMPStorageChild::Send__delete__(PGMPStorageChild* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    if ((!(actor))) {
        return false;
    }

    PGMPStorage::Msg___delete__* __msg = new PGMPStorage::Msg___delete__();

    (actor)->Write(actor, __msg, false);

    (__msg)->set_routing_id((actor)->mId);
    (__msg)->set_priority(1);


    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (__msg)->Log("[PGMPStorageChild] Sending ", (actor)->OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition((actor)->mState, Trigger(Trigger::Recv, PGMPStorage::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = ((actor)->mChannel)->Send(__msg);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PGMPStorageMsgStart, actor);
    return __sendok;
}

auto PGMPStorageChild::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PGMPStorageChild::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PGMPStorageChild::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PGMPStorageChild::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PGMPStorageChild::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PGMPStorageChild::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PGMPStorageChild::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PGMPStorageChild::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PGMPStorageChild::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PGMPStorageChild::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PGMPStorageChild::OtherProcess() const -> ProcessHandle
{
    return (mManager)->OtherProcess();
}

auto PGMPStorageChild::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PGMPStorageChild::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PGMPStorageChild::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PGMPStorage has not yet been implemented");
    return nullptr;
}

auto PGMPStorageChild::OnMessageReceived(const Message& __msg) -> PGMPStorageChild::Result
{
    switch ((__msg).type()) {
    case PGMPStorage::Msg_OpenComplete__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PGMPStorage::Msg_OpenComplete");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_OpenComplete*>((&(__msg))))->Log("[PGMPStorageChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvOpenComplete", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString aRecordName;
            GMPErr aStatus;

            if ((!(Read((&(aRecordName)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aStatus)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'GMPErr'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_OpenComplete__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvOpenComplete(aRecordName, aStatus)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for OpenComplete returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_ReadComplete__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PGMPStorage::Msg_ReadComplete");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_ReadComplete*>((&(__msg))))->Log("[PGMPStorageChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvReadComplete", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString aRecordName;
            GMPErr aStatus;
            nsTArray<uint8_t> aBytes;

            if ((!(Read((&(aRecordName)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aStatus)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'GMPErr'");
                return MsgValueError;
            }
            if ((!(Read((&(aBytes)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsTArray'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_ReadComplete__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvReadComplete(aRecordName, aStatus, aBytes)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for ReadComplete returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_WriteComplete__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PGMPStorage::Msg_WriteComplete");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_WriteComplete*>((&(__msg))))->Log("[PGMPStorageChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvWriteComplete", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString aRecordName;
            GMPErr aStatus;

            if ((!(Read((&(aRecordName)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aStatus)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'GMPErr'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_WriteComplete__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvWriteComplete(aRecordName, aStatus)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for WriteComplete returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_Shutdown__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PGMPStorage::Msg_Shutdown");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_Shutdown*>((&(__msg))))->Log("[PGMPStorageChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvShutdown", js::ProfileEntry::Category::OTHER);

            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_Shutdown__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvShutdown()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Shutdown returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PGMPStorageChild::OnMessageReceived(
        const Message& __msg,
        Message*& __reply) -> PGMPStorageChild::Result
{
    return MsgNotKnown;
}

auto PGMPStorageChild::OnCallReceived(
        const Message& __msg,
        Message*& __reply) -> PGMPStorageChild::Result
{
    return MsgNotKnown;
}

auto PGMPStorageChild::OnProcessingError(Result aCode) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PGMPStorageChild::GetProtocolTypeId() -> int32_t
{
    return PGMPStorageMsgStart;
}

auto PGMPStorageChild::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PGMPStorageChild::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PGMPStorageChild::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PGMPStorageChild::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PGMPStorageChild::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPStorageChild::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPStorageChild::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPStorageChild::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PGMPStorageChild::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PGMPStorageChild", aMsg, 0, false);
}

auto PGMPStorageChild::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PGMPStorageChild::DeallocSubtree() -> void
{
}

auto PGMPStorageChild::Write(
        PGMPStorageChild* __v,
        Message* __msg,
        bool __nullable) -> void
{
    int32_t id;
    if ((!(__v))) {
        if ((!(__nullable))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (__v)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, __msg);
}

auto PGMPStorageChild::Read(
        PGMPStorageChild** __v,
        const Message* __msg,
        void** __iter,
        bool __nullable) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), __msg, __iter)))) {
        FatalError("Error deserializing 'id' for 'PGMPStorageChild'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(__nullable))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PGMPStorage");
        return false;
    }

    if ((0) == (id)) {
        (*(__v)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PGMPStorage");
        return false;
    }

    if ((PGMPStorageMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PGMPStorage has different type");
        return false;
    }

    (*(__v)) = static_cast<PGMPStorageChild*>(listener);
    return true;
}



} // namespace gmp
} // namespace mozilla
