//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/gmp/PGMPStorageParent.h"

#include "mozilla/gmp/PGMPParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace gmp {


auto PGMPStorageParent::Recv__delete__() -> bool
{
    return true;
}


MOZ_IMPLICIT PGMPStorageParent::PGMPStorageParent() :
    mId(0),
    mState(PGMPStorage::__Dead)
{
    MOZ_COUNT_CTOR(PGMPStorageParent);
}

PGMPStorageParent::~PGMPStorageParent()
{
    MOZ_COUNT_DTOR(PGMPStorageParent);
}

auto PGMPStorageParent::Manager() const -> PGMPParent*
{
    return static_cast<PGMPParent*>(mManager);
}

auto PGMPStorageParent::state() -> PGMPStorage::State
{
    return mState;
}

auto PGMPStorageParent::SendOpenComplete(
        const nsCString& aRecordName,
        const GMPErr& aStatus) -> bool
{
    PGMPStorage::Msg_OpenComplete* __msg = new PGMPStorage::Msg_OpenComplete();

    Write(aRecordName, __msg);
    Write(aStatus, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (__msg)->Log("[PGMPStorageParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendOpenComplete", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_OpenComplete__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PGMPStorageParent::SendReadComplete(
        const nsCString& aRecordName,
        const GMPErr& aStatus,
        const nsTArray<uint8_t>& aBytes) -> bool
{
    PGMPStorage::Msg_ReadComplete* __msg = new PGMPStorage::Msg_ReadComplete();

    Write(aRecordName, __msg);
    Write(aStatus, __msg);
    Write(aBytes, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (__msg)->Log("[PGMPStorageParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendReadComplete", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_ReadComplete__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PGMPStorageParent::SendWriteComplete(
        const nsCString& aRecordName,
        const GMPErr& aStatus) -> bool
{
    PGMPStorage::Msg_WriteComplete* __msg = new PGMPStorage::Msg_WriteComplete();

    Write(aRecordName, __msg);
    Write(aStatus, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (__msg)->Log("[PGMPStorageParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendWriteComplete", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_WriteComplete__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PGMPStorageParent::SendShutdown() -> bool
{
    PGMPStorage::Msg_Shutdown* __msg = new PGMPStorage::Msg_Shutdown();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
        (__msg)->Log("[PGMPStorageParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PGMPStorage", "AsyncSendShutdown", js::ProfileEntry::Category::OTHER);
    if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Send, PGMPStorage::Msg_Shutdown__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PGMPStorageParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PGMPStorageParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PGMPStorageParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PGMPStorageParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PGMPStorageParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PGMPStorageParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PGMPStorageParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PGMPStorageParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PGMPStorageParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PGMPStorageParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PGMPStorageParent::OtherProcess() const -> ProcessHandle
{
    return (mManager)->OtherProcess();
}

auto PGMPStorageParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PGMPStorageParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PGMPStorageParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PGMPStorage has not yet been implemented");
    return nullptr;
}

auto PGMPStorageParent::OnMessageReceived(const Message& __msg) -> PGMPStorageParent::Result
{
    switch ((__msg).type()) {
    case PGMPStorage::Msg_Open__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PGMPStorage::Msg_Open");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_Open*>((&(__msg))))->Log("[PGMPStorageParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvOpen", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString aRecordName;

            if ((!(Read((&(aRecordName)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Open__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvOpen(aRecordName)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Open returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_Read__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PGMPStorage::Msg_Read");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_Read*>((&(__msg))))->Log("[PGMPStorageParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvRead", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString aRecordName;

            if ((!(Read((&(aRecordName)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Read__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvRead(aRecordName)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Read returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_Write__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PGMPStorage::Msg_Write");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_Write*>((&(__msg))))->Log("[PGMPStorageParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvWrite", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString aRecordName;
            nsTArray<uint8_t> aBytes;

            if ((!(Read((&(aRecordName)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aBytes)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsTArray'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Write__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvWrite(aRecordName, aBytes)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Write returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg_Close__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PGMPStorage::Msg_Close");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg_Close*>((&(__msg))))->Log("[PGMPStorageParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "RecvClose", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString aRecordName;

            if ((!(Read((&(aRecordName)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg_Close__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvClose(aRecordName)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Close returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PGMPStorage::Msg___delete____ID:
        {
            (const_cast<Message&>(__msg)).set_name("PGMPStorage::Msg___delete__");
            if (mozilla::ipc::LoggingEnabledFor("PGMP")) {
                (static_cast<const PGMPStorage::Msg___delete__*>((&(__msg))))->Log("[PGMPStorageParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PGMPStorage", "Recv__delete__", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            PGMPStorageParent* actor;

            if ((!(Read((&(actor)), (&(__msg)), (&(__iter)), false)))) {
                FatalError("Error deserializing 'PGMPStorageParent'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PGMPStorage::Transition(mState, Trigger(Trigger::Recv, PGMPStorage::Msg___delete____ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(Recv__delete__()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for __delete__ returned error code");
                return MsgProcessingError;
            }

            (actor)->DestroySubtree(Deletion);
            (actor)->DeallocSubtree();
            ((actor)->mManager)->RemoveManagee(PGMPStorageMsgStart, actor);


            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PGMPStorageParent::OnMessageReceived(
        const Message& __msg,
        Message*& __reply) -> PGMPStorageParent::Result
{
    return MsgNotKnown;
}

auto PGMPStorageParent::OnCallReceived(
        const Message& __msg,
        Message*& __reply) -> PGMPStorageParent::Result
{
    return MsgNotKnown;
}

auto PGMPStorageParent::OnProcessingError(Result aCode) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PGMPStorageParent::GetProtocolTypeId() -> int32_t
{
    return PGMPStorageMsgStart;
}

auto PGMPStorageParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PGMPStorageParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PGMPStorageParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PGMPStorageParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PGMPStorageParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPStorageParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPStorageParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PGMPStorageParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PGMPStorageParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PGMPStorageParent", aMsg, OtherProcess(), true);
}

auto PGMPStorageParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PGMPStorageParent::DeallocSubtree() -> void
{
}

auto PGMPStorageParent::Write(
        PGMPStorageParent* __v,
        Message* __msg,
        bool __nullable) -> void
{
    int32_t id;
    if ((!(__v))) {
        if ((!(__nullable))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (__v)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, __msg);
}

auto PGMPStorageParent::Read(
        PGMPStorageParent** __v,
        const Message* __msg,
        void** __iter,
        bool __nullable) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), __msg, __iter)))) {
        FatalError("Error deserializing 'id' for 'PGMPStorageParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(__nullable))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PGMPStorage");
        return false;
    }

    if ((0) == (id)) {
        (*(__v)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PGMPStorage");
        return false;
    }

    if ((PGMPStorageMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PGMPStorage has different type");
        return false;
    }

    (*(__v)) = static_cast<PGMPStorageParent*>(listener);
    return true;
}



} // namespace gmp
} // namespace mozilla
