//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PHttpChannelChild.h"
#include "mozilla/net/TimingStruct.h"
#include "nsHttp.h"
#include "nsHttpHeaderArray.h"
#include "nsHttpResponseHead.h"

#include "mozilla/net/PNeckoChild.h"
#include "mozilla/dom/PBlobChild.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace net {


auto PHttpChannelChild::ActorDestroy(ActorDestroyReason aWhy) -> void
{
}

MOZ_IMPLICIT PHttpChannelChild::PHttpChannelChild() :
    mId(0),
    mState(PHttpChannel::__Dead)
{
    MOZ_COUNT_CTOR(PHttpChannelChild);
}

PHttpChannelChild::~PHttpChannelChild()
{
    MOZ_COUNT_DTOR(PHttpChannelChild);
}

auto PHttpChannelChild::Manager() const -> PNeckoChild*
{
    return static_cast<PNeckoChild*>(mManager);
}

auto PHttpChannelChild::state() -> PHttpChannel::State
{
    return mState;
}

auto PHttpChannelChild::SendSetPriority(const uint16_t& priority) -> bool
{
    PHttpChannel::Msg_SetPriority* __msg = new PHttpChannel::Msg_SetPriority();

    Write(priority, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendSetPriority", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_SetPriority__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelChild::SendSetCacheTokenCachedCharset(const nsCString& charset) -> bool
{
    PHttpChannel::Msg_SetCacheTokenCachedCharset* __msg = new PHttpChannel::Msg_SetCacheTokenCachedCharset();

    Write(charset, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendSetCacheTokenCachedCharset", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_SetCacheTokenCachedCharset__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelChild::SendUpdateAssociatedContentSecurity(
        const int32_t& broken,
        const int32_t& no) -> bool
{
    PHttpChannel::Msg_UpdateAssociatedContentSecurity* __msg = new PHttpChannel::Msg_UpdateAssociatedContentSecurity();

    Write(broken, __msg);
    Write(no, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendUpdateAssociatedContentSecurity", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_UpdateAssociatedContentSecurity__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelChild::SendSuspend() -> bool
{
    PHttpChannel::Msg_Suspend* __msg = new PHttpChannel::Msg_Suspend();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendSuspend", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_Suspend__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelChild::SendResume() -> bool
{
    PHttpChannel::Msg_Resume* __msg = new PHttpChannel::Msg_Resume();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendResume", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_Resume__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelChild::SendCancel(const nsresult& status) -> bool
{
    PHttpChannel::Msg_Cancel* __msg = new PHttpChannel::Msg_Cancel();

    Write(status, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendCancel", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_Cancel__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelChild::SendRedirect2Verify(
        const nsresult& result,
        const RequestHeaderTuples& changedHeaders,
        const OptionalURIParams& apiRedirectTo) -> bool
{
    PHttpChannel::Msg_Redirect2Verify* __msg = new PHttpChannel::Msg_Redirect2Verify();

    Write(result, __msg);
    Write(changedHeaders, __msg);
    Write(apiRedirectTo, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendRedirect2Verify", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_Redirect2Verify__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelChild::SendDocumentChannelCleanup() -> bool
{
    PHttpChannel::Msg_DocumentChannelCleanup* __msg = new PHttpChannel::Msg_DocumentChannelCleanup();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendDocumentChannelCleanup", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_DocumentChannelCleanup__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelChild::SendMarkOfflineCacheEntryAsForeign() -> bool
{
    PHttpChannel::Msg_MarkOfflineCacheEntryAsForeign* __msg = new PHttpChannel::Msg_MarkOfflineCacheEntryAsForeign();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendMarkOfflineCacheEntryAsForeign", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_MarkOfflineCacheEntryAsForeign__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelChild::SendDivertOnDataAvailable(
        const nsCString& data,
        const uint64_t& offset,
        const uint32_t& count) -> bool
{
    PHttpChannel::Msg_DivertOnDataAvailable* __msg = new PHttpChannel::Msg_DivertOnDataAvailable();

    Write(data, __msg);
    Write(offset, __msg);
    Write(count, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendDivertOnDataAvailable", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_DivertOnDataAvailable__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelChild::SendDivertOnStopRequest(const nsresult& statusCode) -> bool
{
    PHttpChannel::Msg_DivertOnStopRequest* __msg = new PHttpChannel::Msg_DivertOnStopRequest();

    Write(statusCode, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendDivertOnStopRequest", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_DivertOnStopRequest__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelChild::SendDivertComplete() -> bool
{
    PHttpChannel::Msg_DivertComplete* __msg = new PHttpChannel::Msg_DivertComplete();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendDivertComplete", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_DivertComplete__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelChild::Send__delete__(PHttpChannelChild* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    if ((!(actor))) {
        return false;
    }

    PHttpChannel::Msg___delete__* __msg = new PHttpChannel::Msg___delete__();

    (actor)->Write(actor, __msg, false);

    (__msg)->set_routing_id((actor)->mId);
    (__msg)->set_priority(1);


    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelChild] Sending ", (actor)->OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition((actor)->mState, Trigger(Trigger::Recv, PHttpChannel::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = ((actor)->mChannel)->Send(__msg);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PHttpChannelMsgStart, actor);
    return __sendok;
}

auto PHttpChannelChild::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PHttpChannelChild::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PHttpChannelChild::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PHttpChannelChild::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PHttpChannelChild::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PHttpChannelChild::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PHttpChannelChild::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PHttpChannelChild::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PHttpChannelChild::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PHttpChannelChild::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PHttpChannelChild::OtherProcess() const -> ProcessHandle
{
    return (mManager)->OtherProcess();
}

auto PHttpChannelChild::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PHttpChannelChild::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PHttpChannelChild::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PHttpChannel has not yet been implemented");
    return nullptr;
}

auto PHttpChannelChild::OnMessageReceived(const Message& __msg) -> PHttpChannelChild::Result
{
    switch ((__msg).type()) {
    case PHttpChannel::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    case PHttpChannel::Msg_OnStartRequest__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_OnStartRequest");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_OnStartRequest*>((&(__msg))))->Log("[PHttpChannelChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvOnStartRequest", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsresult channelStatus;
            nsHttpResponseHead responseHead;
            bool useResponseHead;
            nsHttpHeaderArray requestHeaders;
            bool isFromCache;
            bool cacheEntryAvailable;
            uint32_t cacheExpirationTime;
            nsCString cachedCharset;
            nsCString securityInfoSerialization;
            NetAddr selfAddr;
            NetAddr peerAddr;
            int16_t redirectCount;

            if ((!(Read((&(channelStatus)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            if ((!(Read((&(responseHead)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsHttpResponseHead'");
                return MsgValueError;
            }
            if ((!(Read((&(useResponseHead)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(Read((&(requestHeaders)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsHttpHeaderArray'");
                return MsgValueError;
            }
            if ((!(Read((&(isFromCache)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(Read((&(cacheEntryAvailable)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(Read((&(cacheExpirationTime)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(Read((&(cachedCharset)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(securityInfoSerialization)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(selfAddr)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'NetAddr'");
                return MsgValueError;
            }
            if ((!(Read((&(peerAddr)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'NetAddr'");
                return MsgValueError;
            }
            if ((!(Read((&(redirectCount)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'int16_t'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnStartRequest__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvOnStartRequest(channelStatus, responseHead, useResponseHead, requestHeaders, isFromCache, cacheEntryAvailable, cacheExpirationTime, cachedCharset, securityInfoSerialization, selfAddr, peerAddr, redirectCount)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for OnStartRequest returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_OnTransportAndData__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_OnTransportAndData");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_OnTransportAndData*>((&(__msg))))->Log("[PHttpChannelChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvOnTransportAndData", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsresult channelStatus;
            nsresult transportStatus;
            uint64_t progress;
            uint64_t progressMax;
            nsCString data;
            uint64_t offset;
            uint32_t count;

            if ((!(Read((&(channelStatus)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            if ((!(Read((&(transportStatus)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            if ((!(Read((&(progress)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(Read((&(progressMax)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(Read((&(data)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(offset)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(Read((&(count)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnTransportAndData__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvOnTransportAndData(channelStatus, transportStatus, progress, progressMax, data, offset, count)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for OnTransportAndData returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_OnStopRequest__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_OnStopRequest");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_OnStopRequest*>((&(__msg))))->Log("[PHttpChannelChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvOnStopRequest", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsresult channelStatus;
            ResourceTimingStruct timing;

            if ((!(Read((&(channelStatus)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            if ((!(Read((&(timing)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'ResourceTimingStruct'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnStopRequest__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvOnStopRequest(channelStatus, timing)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for OnStopRequest returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_OnProgress__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_OnProgress");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_OnProgress*>((&(__msg))))->Log("[PHttpChannelChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvOnProgress", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            uint64_t progress;
            uint64_t progressMax;

            if ((!(Read((&(progress)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(Read((&(progressMax)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnProgress__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvOnProgress(progress, progressMax)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for OnProgress returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_OnStatus__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_OnStatus");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_OnStatus*>((&(__msg))))->Log("[PHttpChannelChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvOnStatus", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsresult status;

            if ((!(Read((&(status)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnStatus__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvOnStatus(status)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for OnStatus returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_FailedAsyncOpen__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_FailedAsyncOpen");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_FailedAsyncOpen*>((&(__msg))))->Log("[PHttpChannelChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvFailedAsyncOpen", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsresult status;

            if ((!(Read((&(status)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_FailedAsyncOpen__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvFailedAsyncOpen(status)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for FailedAsyncOpen returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_Redirect1Begin__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_Redirect1Begin");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_Redirect1Begin*>((&(__msg))))->Log("[PHttpChannelChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvRedirect1Begin", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            uint32_t newChannelId;
            URIParams newUri;
            uint32_t redirectFlags;
            nsHttpResponseHead responseHead;

            if ((!(Read((&(newChannelId)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(Read((&(newUri)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'URIParams'");
                return MsgValueError;
            }
            if ((!(Read((&(redirectFlags)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(Read((&(responseHead)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsHttpResponseHead'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_Redirect1Begin__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvRedirect1Begin(newChannelId, newUri, redirectFlags, responseHead)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Redirect1Begin returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_Redirect3Complete__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_Redirect3Complete");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_Redirect3Complete*>((&(__msg))))->Log("[PHttpChannelChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvRedirect3Complete", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_Redirect3Complete__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvRedirect3Complete()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Redirect3Complete returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_AssociateApplicationCache__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_AssociateApplicationCache");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_AssociateApplicationCache*>((&(__msg))))->Log("[PHttpChannelChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvAssociateApplicationCache", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString groupID;
            nsCString clientID;

            if ((!(Read((&(groupID)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(clientID)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_AssociateApplicationCache__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvAssociateApplicationCache(groupID, clientID)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for AssociateApplicationCache returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_FlushedForDiversion__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_FlushedForDiversion");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_FlushedForDiversion*>((&(__msg))))->Log("[PHttpChannelChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvFlushedForDiversion", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_FlushedForDiversion__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvFlushedForDiversion()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for FlushedForDiversion returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_DivertMessages__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_DivertMessages");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_DivertMessages*>((&(__msg))))->Log("[PHttpChannelChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvDivertMessages", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_DivertMessages__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDivertMessages()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DivertMessages returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_DeleteSelf__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_DeleteSelf");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_DeleteSelf*>((&(__msg))))->Log("[PHttpChannelChild] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvDeleteSelf", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_DeleteSelf__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDeleteSelf()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DeleteSelf returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PHttpChannelChild::OnMessageReceived(
        const Message& __msg,
        Message*& __reply) -> PHttpChannelChild::Result
{
    return MsgNotKnown;
}

auto PHttpChannelChild::OnCallReceived(
        const Message& __msg,
        Message*& __reply) -> PHttpChannelChild::Result
{
    return MsgNotKnown;
}

auto PHttpChannelChild::OnProcessingError(Result aCode) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PHttpChannelChild::GetProtocolTypeId() -> int32_t
{
    return PHttpChannelMsgStart;
}

auto PHttpChannelChild::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PHttpChannelChild::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PHttpChannelChild::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PHttpChannelChild::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PHttpChannelChild::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PHttpChannelChild::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PHttpChannelChild::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PHttpChannelChild::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_RUNTIMEABORT("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PHttpChannelChild::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PHttpChannelChild", aMsg, 0, false);
}

auto PHttpChannelChild::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PHttpChannelChild::DeallocSubtree() -> void
{
}

auto PHttpChannelChild::Write(
        PHttpChannelChild* __v,
        Message* __msg,
        bool __nullable) -> void
{
    int32_t id;
    if ((!(__v))) {
        if ((!(__nullable))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (__v)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, __msg);
}

auto PHttpChannelChild::Read(
        PHttpChannelChild** __v,
        const Message* __msg,
        void** __iter,
        bool __nullable) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), __msg, __iter)))) {
        FatalError("Error deserializing 'id' for 'PHttpChannelChild'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(__nullable))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PHttpChannel");
        return false;
    }

    if ((0) == (id)) {
        (*(__v)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PHttpChannel");
        return false;
    }

    if ((PHttpChannelMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PHttpChannel has different type");
        return false;
    }

    (*(__v)) = static_cast<PHttpChannelChild*>(listener);
    return true;
}

auto PHttpChannelChild::Write(
        const JARURIParams& __v,
        Message* __msg) -> void
{
    Write((__v).jarFile(), __msg);
    Write((__v).jarEntry(), __msg);
    Write((__v).charset(), __msg);
}

auto PHttpChannelChild::Read(
        JARURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->jarFile())), __msg, __iter)))) {
        FatalError("Error deserializing 'jarFile' (URIParams) member of 'JARURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->jarEntry())), __msg, __iter)))) {
        FatalError("Error deserializing 'jarEntry' (URIParams) member of 'JARURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->charset())), __msg, __iter)))) {
        FatalError("Error deserializing 'charset' (nsCString) member of 'JARURIParams'");
        return false;
    }
    return true;
}

auto PHttpChannelChild::Write(
        const OptionalURIParams& __v,
        Message* __msg) -> void
{
    typedef OptionalURIParams __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::Tvoid_t:
        {
            Write((__v).get_void_t(), __msg);
            return;
        }
    case __type::TURIParams:
        {
            Write((__v).get_URIParams(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PHttpChannelChild::Read(
        OptionalURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef OptionalURIParams __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalURIParams'");
        return false;
    }

    switch (type) {
    case __type::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(__v)) = tmp;
            return Read((&((__v)->get_void_t())), __msg, __iter);
        }
    case __type::TURIParams:
        {
            URIParams tmp = URIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_URIParams())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PHttpChannelChild::Write(
        const StandardURLParams& __v,
        Message* __msg) -> void
{
    Write((__v).urlType(), __msg);
    Write((__v).port(), __msg);
    Write((__v).defaultPort(), __msg);
    Write((__v).spec(), __msg);
    Write((__v).scheme(), __msg);
    Write((__v).authority(), __msg);
    Write((__v).username(), __msg);
    Write((__v).password(), __msg);
    Write((__v).host(), __msg);
    Write((__v).path(), __msg);
    Write((__v).filePath(), __msg);
    Write((__v).directory(), __msg);
    Write((__v).baseName(), __msg);
    Write((__v).extension(), __msg);
    Write((__v).query(), __msg);
    Write((__v).ref(), __msg);
    Write((__v).originCharset(), __msg);
    Write((__v).isMutable(), __msg);
    Write((__v).supportsFileURL(), __msg);
    Write((__v).hostEncoding(), __msg);
}

auto PHttpChannelChild::Read(
        StandardURLParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->urlType())), __msg, __iter)))) {
        FatalError("Error deserializing 'urlType' (uint32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->port())), __msg, __iter)))) {
        FatalError("Error deserializing 'port' (int32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->defaultPort())), __msg, __iter)))) {
        FatalError("Error deserializing 'defaultPort' (int32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->spec())), __msg, __iter)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->scheme())), __msg, __iter)))) {
        FatalError("Error deserializing 'scheme' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->authority())), __msg, __iter)))) {
        FatalError("Error deserializing 'authority' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->username())), __msg, __iter)))) {
        FatalError("Error deserializing 'username' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->password())), __msg, __iter)))) {
        FatalError("Error deserializing 'password' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->host())), __msg, __iter)))) {
        FatalError("Error deserializing 'host' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->path())), __msg, __iter)))) {
        FatalError("Error deserializing 'path' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->filePath())), __msg, __iter)))) {
        FatalError("Error deserializing 'filePath' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->directory())), __msg, __iter)))) {
        FatalError("Error deserializing 'directory' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->baseName())), __msg, __iter)))) {
        FatalError("Error deserializing 'baseName' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->extension())), __msg, __iter)))) {
        FatalError("Error deserializing 'extension' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->query())), __msg, __iter)))) {
        FatalError("Error deserializing 'query' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->ref())), __msg, __iter)))) {
        FatalError("Error deserializing 'ref' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->originCharset())), __msg, __iter)))) {
        FatalError("Error deserializing 'originCharset' (nsCString) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->isMutable())), __msg, __iter)))) {
        FatalError("Error deserializing 'isMutable' (bool) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->supportsFileURL())), __msg, __iter)))) {
        FatalError("Error deserializing 'supportsFileURL' (bool) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->hostEncoding())), __msg, __iter)))) {
        FatalError("Error deserializing 'hostEncoding' (uint32_t) member of 'StandardURLParams'");
        return false;
    }
    return true;
}

auto PHttpChannelChild::Write(
        const GenericURIParams& __v,
        Message* __msg) -> void
{
    Write((__v).spec(), __msg);
    Write((__v).charset(), __msg);
}

auto PHttpChannelChild::Read(
        GenericURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->spec())), __msg, __iter)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'GenericURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->charset())), __msg, __iter)))) {
        FatalError("Error deserializing 'charset' (nsCString) member of 'GenericURIParams'");
        return false;
    }
    return true;
}

auto PHttpChannelChild::Write(
        const StandardURLSegment& __v,
        Message* __msg) -> void
{
    Write((__v).position(), __msg);
    Write((__v).length(), __msg);
}

auto PHttpChannelChild::Read(
        StandardURLSegment* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->position())), __msg, __iter)))) {
        FatalError("Error deserializing 'position' (uint32_t) member of 'StandardURLSegment'");
        return false;
    }
    if ((!(Read((&((__v)->length())), __msg, __iter)))) {
        FatalError("Error deserializing 'length' (int32_t) member of 'StandardURLSegment'");
        return false;
    }
    return true;
}

auto PHttpChannelChild::Write(
        const URIParams& __v,
        Message* __msg) -> void
{
    typedef URIParams __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::TSimpleURIParams:
        {
            Write((__v).get_SimpleURIParams(), __msg);
            return;
        }
    case __type::TStandardURLParams:
        {
            Write((__v).get_StandardURLParams(), __msg);
            return;
        }
    case __type::TJARURIParams:
        {
            Write((__v).get_JARURIParams(), __msg);
            return;
        }
    case __type::TGenericURIParams:
        {
            Write((__v).get_GenericURIParams(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PHttpChannelChild::Read(
        URIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef URIParams __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'URIParams'");
        return false;
    }

    switch (type) {
    case __type::TSimpleURIParams:
        {
            SimpleURIParams tmp = SimpleURIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_SimpleURIParams())), __msg, __iter);
        }
    case __type::TStandardURLParams:
        {
            StandardURLParams tmp = StandardURLParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_StandardURLParams())), __msg, __iter);
        }
    case __type::TJARURIParams:
        {
            JARURIParams tmp = JARURIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_JARURIParams())), __msg, __iter);
        }
    case __type::TGenericURIParams:
        {
            GenericURIParams tmp = GenericURIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_GenericURIParams())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PHttpChannelChild::Write(
        const SimpleURIParams& __v,
        Message* __msg) -> void
{
    Write((__v).scheme(), __msg);
    Write((__v).path(), __msg);
    Write((__v).ref(), __msg);
    Write((__v).isMutable(), __msg);
}

auto PHttpChannelChild::Read(
        SimpleURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->scheme())), __msg, __iter)))) {
        FatalError("Error deserializing 'scheme' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->path())), __msg, __iter)))) {
        FatalError("Error deserializing 'path' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->ref())), __msg, __iter)))) {
        FatalError("Error deserializing 'ref' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->isMutable())), __msg, __iter)))) {
        FatalError("Error deserializing 'isMutable' (bool) member of 'SimpleURIParams'");
        return false;
    }
    return true;
}



} // namespace net
} // namespace mozilla
