//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PHttpChannelParent.h"
#include "mozilla/net/TimingStruct.h"
#include "nsHttp.h"
#include "nsHttpHeaderArray.h"
#include "nsHttpResponseHead.h"

#include "mozilla/net/PNeckoParent.h"
#include "mozilla/dom/PBlobParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace net {


auto PHttpChannelParent::Recv__delete__() -> bool
{
    return true;
}


MOZ_IMPLICIT PHttpChannelParent::PHttpChannelParent() :
    mId(0),
    mState(PHttpChannel::__Dead)
{
    MOZ_COUNT_CTOR(PHttpChannelParent);
}

PHttpChannelParent::~PHttpChannelParent()
{
    MOZ_COUNT_DTOR(PHttpChannelParent);
}

auto PHttpChannelParent::Manager() const -> PNeckoParent*
{
    return static_cast<PNeckoParent*>(mManager);
}

auto PHttpChannelParent::state() -> PHttpChannel::State
{
    return mState;
}

auto PHttpChannelParent::SendOnStartRequest(
        const nsresult& channelStatus,
        const nsHttpResponseHead& responseHead,
        const bool& useResponseHead,
        const nsHttpHeaderArray& requestHeaders,
        const bool& isFromCache,
        const bool& cacheEntryAvailable,
        const uint32_t& cacheExpirationTime,
        const nsCString& cachedCharset,
        const nsCString& securityInfoSerialization,
        const NetAddr& selfAddr,
        const NetAddr& peerAddr,
        const int16_t& redirectCount) -> bool
{
    PHttpChannel::Msg_OnStartRequest* __msg = new PHttpChannel::Msg_OnStartRequest();

    Write(channelStatus, __msg);
    Write(responseHead, __msg);
    Write(useResponseHead, __msg);
    Write(requestHeaders, __msg);
    Write(isFromCache, __msg);
    Write(cacheEntryAvailable, __msg);
    Write(cacheExpirationTime, __msg);
    Write(cachedCharset, __msg);
    Write(securityInfoSerialization, __msg);
    Write(selfAddr, __msg);
    Write(peerAddr, __msg);
    Write(redirectCount, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendOnStartRequest", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnStartRequest__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelParent::SendOnTransportAndData(
        const nsresult& channelStatus,
        const nsresult& transportStatus,
        const uint64_t& progress,
        const uint64_t& progressMax,
        const nsCString& data,
        const uint64_t& offset,
        const uint32_t& count) -> bool
{
    PHttpChannel::Msg_OnTransportAndData* __msg = new PHttpChannel::Msg_OnTransportAndData();

    Write(channelStatus, __msg);
    Write(transportStatus, __msg);
    Write(progress, __msg);
    Write(progressMax, __msg);
    Write(data, __msg);
    Write(offset, __msg);
    Write(count, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendOnTransportAndData", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnTransportAndData__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelParent::SendOnStopRequest(
        const nsresult& channelStatus,
        const ResourceTimingStruct& timing) -> bool
{
    PHttpChannel::Msg_OnStopRequest* __msg = new PHttpChannel::Msg_OnStopRequest();

    Write(channelStatus, __msg);
    Write(timing, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendOnStopRequest", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnStopRequest__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelParent::SendOnProgress(
        const uint64_t& progress,
        const uint64_t& progressMax) -> bool
{
    PHttpChannel::Msg_OnProgress* __msg = new PHttpChannel::Msg_OnProgress();

    Write(progress, __msg);
    Write(progressMax, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendOnProgress", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnProgress__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelParent::SendOnStatus(const nsresult& status) -> bool
{
    PHttpChannel::Msg_OnStatus* __msg = new PHttpChannel::Msg_OnStatus();

    Write(status, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendOnStatus", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_OnStatus__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelParent::SendFailedAsyncOpen(const nsresult& status) -> bool
{
    PHttpChannel::Msg_FailedAsyncOpen* __msg = new PHttpChannel::Msg_FailedAsyncOpen();

    Write(status, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendFailedAsyncOpen", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_FailedAsyncOpen__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelParent::SendRedirect1Begin(
        const uint32_t& newChannelId,
        const URIParams& newUri,
        const uint32_t& redirectFlags,
        const nsHttpResponseHead& responseHead) -> bool
{
    PHttpChannel::Msg_Redirect1Begin* __msg = new PHttpChannel::Msg_Redirect1Begin();

    Write(newChannelId, __msg);
    Write(newUri, __msg);
    Write(redirectFlags, __msg);
    Write(responseHead, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendRedirect1Begin", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_Redirect1Begin__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelParent::SendRedirect3Complete() -> bool
{
    PHttpChannel::Msg_Redirect3Complete* __msg = new PHttpChannel::Msg_Redirect3Complete();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendRedirect3Complete", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_Redirect3Complete__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelParent::SendAssociateApplicationCache(
        const nsCString& groupID,
        const nsCString& clientID) -> bool
{
    PHttpChannel::Msg_AssociateApplicationCache* __msg = new PHttpChannel::Msg_AssociateApplicationCache();

    Write(groupID, __msg);
    Write(clientID, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendAssociateApplicationCache", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_AssociateApplicationCache__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelParent::SendFlushedForDiversion() -> bool
{
    PHttpChannel::Msg_FlushedForDiversion* __msg = new PHttpChannel::Msg_FlushedForDiversion();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendFlushedForDiversion", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_FlushedForDiversion__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelParent::SendDivertMessages() -> bool
{
    PHttpChannel::Msg_DivertMessages* __msg = new PHttpChannel::Msg_DivertMessages();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendDivertMessages", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_DivertMessages__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelParent::SendDeleteSelf() -> bool
{
    PHttpChannel::Msg_DeleteSelf* __msg = new PHttpChannel::Msg_DeleteSelf();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PHttpChannelParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PHttpChannel", "AsyncSendDeleteSelf", js::ProfileEntry::Category::OTHER);
    if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Send, PHttpChannel::Msg_DeleteSelf__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PHttpChannelParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PHttpChannelParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PHttpChannelParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PHttpChannelParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PHttpChannelParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PHttpChannelParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PHttpChannelParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PHttpChannelParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PHttpChannelParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PHttpChannelParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PHttpChannelParent::OtherProcess() const -> ProcessHandle
{
    return (mManager)->OtherProcess();
}

auto PHttpChannelParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PHttpChannelParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PHttpChannelParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PHttpChannel has not yet been implemented");
    return nullptr;
}

auto PHttpChannelParent::OnMessageReceived(const Message& __msg) -> PHttpChannelParent::Result
{
    switch ((__msg).type()) {
    case PHttpChannel::Msg_SetPriority__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_SetPriority");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_SetPriority*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvSetPriority", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            uint16_t priority;

            if ((!(Read((&(priority)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint16_t'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_SetPriority__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSetPriority(priority)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SetPriority returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_SetCacheTokenCachedCharset__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_SetCacheTokenCachedCharset");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_SetCacheTokenCachedCharset*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvSetCacheTokenCachedCharset", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString charset;

            if ((!(Read((&(charset)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_SetCacheTokenCachedCharset__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSetCacheTokenCachedCharset(charset)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SetCacheTokenCachedCharset returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_UpdateAssociatedContentSecurity__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_UpdateAssociatedContentSecurity");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_UpdateAssociatedContentSecurity*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvUpdateAssociatedContentSecurity", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            int32_t broken;
            int32_t no;

            if ((!(Read((&(broken)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'int32_t'");
                return MsgValueError;
            }
            if ((!(Read((&(no)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'int32_t'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_UpdateAssociatedContentSecurity__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvUpdateAssociatedContentSecurity(broken, no)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for UpdateAssociatedContentSecurity returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_Suspend__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_Suspend");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_Suspend*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvSuspend", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_Suspend__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSuspend()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Suspend returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_Resume__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_Resume");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_Resume*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvResume", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_Resume__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvResume()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Resume returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_Cancel__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_Cancel");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_Cancel*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvCancel", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsresult status;

            if ((!(Read((&(status)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_Cancel__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvCancel(status)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Cancel returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_Redirect2Verify__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_Redirect2Verify");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_Redirect2Verify*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvRedirect2Verify", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsresult result;
            RequestHeaderTuples changedHeaders;
            OptionalURIParams apiRedirectTo;

            if ((!(Read((&(result)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            if ((!(Read((&(changedHeaders)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'RequestHeaderTuples'");
                return MsgValueError;
            }
            if ((!(Read((&(apiRedirectTo)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'OptionalURIParams'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_Redirect2Verify__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvRedirect2Verify(result, changedHeaders, apiRedirectTo)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Redirect2Verify returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_DocumentChannelCleanup__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_DocumentChannelCleanup");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_DocumentChannelCleanup*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvDocumentChannelCleanup", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_DocumentChannelCleanup__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDocumentChannelCleanup()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DocumentChannelCleanup returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_MarkOfflineCacheEntryAsForeign__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_MarkOfflineCacheEntryAsForeign");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_MarkOfflineCacheEntryAsForeign*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvMarkOfflineCacheEntryAsForeign", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_MarkOfflineCacheEntryAsForeign__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvMarkOfflineCacheEntryAsForeign()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for MarkOfflineCacheEntryAsForeign returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_DivertOnDataAvailable__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_DivertOnDataAvailable");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_DivertOnDataAvailable*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvDivertOnDataAvailable", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString data;
            uint64_t offset;
            uint32_t count;

            if ((!(Read((&(data)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(offset)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(Read((&(count)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_DivertOnDataAvailable__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDivertOnDataAvailable(data, offset, count)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DivertOnDataAvailable returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_DivertOnStopRequest__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_DivertOnStopRequest");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_DivertOnStopRequest*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvDivertOnStopRequest", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsresult statusCode;

            if ((!(Read((&(statusCode)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_DivertOnStopRequest__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDivertOnStopRequest(statusCode)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DivertOnStopRequest returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg_DivertComplete__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg_DivertComplete");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg_DivertComplete*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "RecvDivertComplete", js::ProfileEntry::Category::OTHER);

            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg_DivertComplete__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDivertComplete()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DivertComplete returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpChannel::Msg___delete____ID:
        {
            (const_cast<Message&>(__msg)).set_name("PHttpChannel::Msg___delete__");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PHttpChannel::Msg___delete__*>((&(__msg))))->Log("[PHttpChannelParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PHttpChannel", "Recv__delete__", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            PHttpChannelParent* actor;

            if ((!(Read((&(actor)), (&(__msg)), (&(__iter)), false)))) {
                FatalError("Error deserializing 'PHttpChannelParent'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PHttpChannel::Transition(mState, Trigger(Trigger::Recv, PHttpChannel::Msg___delete____ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(Recv__delete__()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for __delete__ returned error code");
                return MsgProcessingError;
            }

            (actor)->DestroySubtree(Deletion);
            (actor)->DeallocSubtree();
            ((actor)->mManager)->RemoveManagee(PHttpChannelMsgStart, actor);


            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PHttpChannelParent::OnMessageReceived(
        const Message& __msg,
        Message*& __reply) -> PHttpChannelParent::Result
{
    return MsgNotKnown;
}

auto PHttpChannelParent::OnCallReceived(
        const Message& __msg,
        Message*& __reply) -> PHttpChannelParent::Result
{
    return MsgNotKnown;
}

auto PHttpChannelParent::OnProcessingError(Result aCode) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PHttpChannelParent::GetProtocolTypeId() -> int32_t
{
    return PHttpChannelMsgStart;
}

auto PHttpChannelParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PHttpChannelParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PHttpChannelParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PHttpChannelParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PHttpChannelParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PHttpChannelParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PHttpChannelParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PHttpChannelParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PHttpChannelParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PHttpChannelParent", aMsg, OtherProcess(), true);
}

auto PHttpChannelParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PHttpChannelParent::DeallocSubtree() -> void
{
}

auto PHttpChannelParent::Write(
        PHttpChannelParent* __v,
        Message* __msg,
        bool __nullable) -> void
{
    int32_t id;
    if ((!(__v))) {
        if ((!(__nullable))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (__v)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, __msg);
}

auto PHttpChannelParent::Read(
        PHttpChannelParent** __v,
        const Message* __msg,
        void** __iter,
        bool __nullable) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), __msg, __iter)))) {
        FatalError("Error deserializing 'id' for 'PHttpChannelParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(__nullable))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PHttpChannel");
        return false;
    }

    if ((0) == (id)) {
        (*(__v)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PHttpChannel");
        return false;
    }

    if ((PHttpChannelMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PHttpChannel has different type");
        return false;
    }

    (*(__v)) = static_cast<PHttpChannelParent*>(listener);
    return true;
}

auto PHttpChannelParent::Write(
        const JARURIParams& __v,
        Message* __msg) -> void
{
    Write((__v).jarFile(), __msg);
    Write((__v).jarEntry(), __msg);
    Write((__v).charset(), __msg);
}

auto PHttpChannelParent::Read(
        JARURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->jarFile())), __msg, __iter)))) {
        FatalError("Error deserializing 'jarFile' (URIParams) member of 'JARURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->jarEntry())), __msg, __iter)))) {
        FatalError("Error deserializing 'jarEntry' (URIParams) member of 'JARURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->charset())), __msg, __iter)))) {
        FatalError("Error deserializing 'charset' (nsCString) member of 'JARURIParams'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const OptionalURIParams& __v,
        Message* __msg) -> void
{
    typedef OptionalURIParams __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::Tvoid_t:
        {
            Write((__v).get_void_t(), __msg);
            return;
        }
    case __type::TURIParams:
        {
            Write((__v).get_URIParams(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PHttpChannelParent::Read(
        OptionalURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef OptionalURIParams __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalURIParams'");
        return false;
    }

    switch (type) {
    case __type::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(__v)) = tmp;
            return Read((&((__v)->get_void_t())), __msg, __iter);
        }
    case __type::TURIParams:
        {
            URIParams tmp = URIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_URIParams())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PHttpChannelParent::Write(
        const StandardURLParams& __v,
        Message* __msg) -> void
{
    Write((__v).urlType(), __msg);
    Write((__v).port(), __msg);
    Write((__v).defaultPort(), __msg);
    Write((__v).spec(), __msg);
    Write((__v).scheme(), __msg);
    Write((__v).authority(), __msg);
    Write((__v).username(), __msg);
    Write((__v).password(), __msg);
    Write((__v).host(), __msg);
    Write((__v).path(), __msg);
    Write((__v).filePath(), __msg);
    Write((__v).directory(), __msg);
    Write((__v).baseName(), __msg);
    Write((__v).extension(), __msg);
    Write((__v).query(), __msg);
    Write((__v).ref(), __msg);
    Write((__v).originCharset(), __msg);
    Write((__v).isMutable(), __msg);
    Write((__v).supportsFileURL(), __msg);
    Write((__v).hostEncoding(), __msg);
}

auto PHttpChannelParent::Read(
        StandardURLParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->urlType())), __msg, __iter)))) {
        FatalError("Error deserializing 'urlType' (uint32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->port())), __msg, __iter)))) {
        FatalError("Error deserializing 'port' (int32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->defaultPort())), __msg, __iter)))) {
        FatalError("Error deserializing 'defaultPort' (int32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->spec())), __msg, __iter)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->scheme())), __msg, __iter)))) {
        FatalError("Error deserializing 'scheme' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->authority())), __msg, __iter)))) {
        FatalError("Error deserializing 'authority' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->username())), __msg, __iter)))) {
        FatalError("Error deserializing 'username' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->password())), __msg, __iter)))) {
        FatalError("Error deserializing 'password' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->host())), __msg, __iter)))) {
        FatalError("Error deserializing 'host' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->path())), __msg, __iter)))) {
        FatalError("Error deserializing 'path' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->filePath())), __msg, __iter)))) {
        FatalError("Error deserializing 'filePath' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->directory())), __msg, __iter)))) {
        FatalError("Error deserializing 'directory' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->baseName())), __msg, __iter)))) {
        FatalError("Error deserializing 'baseName' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->extension())), __msg, __iter)))) {
        FatalError("Error deserializing 'extension' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->query())), __msg, __iter)))) {
        FatalError("Error deserializing 'query' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->ref())), __msg, __iter)))) {
        FatalError("Error deserializing 'ref' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->originCharset())), __msg, __iter)))) {
        FatalError("Error deserializing 'originCharset' (nsCString) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->isMutable())), __msg, __iter)))) {
        FatalError("Error deserializing 'isMutable' (bool) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->supportsFileURL())), __msg, __iter)))) {
        FatalError("Error deserializing 'supportsFileURL' (bool) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->hostEncoding())), __msg, __iter)))) {
        FatalError("Error deserializing 'hostEncoding' (uint32_t) member of 'StandardURLParams'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const GenericURIParams& __v,
        Message* __msg) -> void
{
    Write((__v).spec(), __msg);
    Write((__v).charset(), __msg);
}

auto PHttpChannelParent::Read(
        GenericURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->spec())), __msg, __iter)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'GenericURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->charset())), __msg, __iter)))) {
        FatalError("Error deserializing 'charset' (nsCString) member of 'GenericURIParams'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const StandardURLSegment& __v,
        Message* __msg) -> void
{
    Write((__v).position(), __msg);
    Write((__v).length(), __msg);
}

auto PHttpChannelParent::Read(
        StandardURLSegment* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->position())), __msg, __iter)))) {
        FatalError("Error deserializing 'position' (uint32_t) member of 'StandardURLSegment'");
        return false;
    }
    if ((!(Read((&((__v)->length())), __msg, __iter)))) {
        FatalError("Error deserializing 'length' (int32_t) member of 'StandardURLSegment'");
        return false;
    }
    return true;
}

auto PHttpChannelParent::Write(
        const URIParams& __v,
        Message* __msg) -> void
{
    typedef URIParams __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::TSimpleURIParams:
        {
            Write((__v).get_SimpleURIParams(), __msg);
            return;
        }
    case __type::TStandardURLParams:
        {
            Write((__v).get_StandardURLParams(), __msg);
            return;
        }
    case __type::TJARURIParams:
        {
            Write((__v).get_JARURIParams(), __msg);
            return;
        }
    case __type::TGenericURIParams:
        {
            Write((__v).get_GenericURIParams(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PHttpChannelParent::Read(
        URIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef URIParams __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'URIParams'");
        return false;
    }

    switch (type) {
    case __type::TSimpleURIParams:
        {
            SimpleURIParams tmp = SimpleURIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_SimpleURIParams())), __msg, __iter);
        }
    case __type::TStandardURLParams:
        {
            StandardURLParams tmp = StandardURLParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_StandardURLParams())), __msg, __iter);
        }
    case __type::TJARURIParams:
        {
            JARURIParams tmp = JARURIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_JARURIParams())), __msg, __iter);
        }
    case __type::TGenericURIParams:
        {
            GenericURIParams tmp = GenericURIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_GenericURIParams())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PHttpChannelParent::Write(
        const SimpleURIParams& __v,
        Message* __msg) -> void
{
    Write((__v).scheme(), __msg);
    Write((__v).path(), __msg);
    Write((__v).ref(), __msg);
    Write((__v).isMutable(), __msg);
}

auto PHttpChannelParent::Read(
        SimpleURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->scheme())), __msg, __iter)))) {
        FatalError("Error deserializing 'scheme' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->path())), __msg, __iter)))) {
        FatalError("Error deserializing 'path' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->ref())), __msg, __iter)))) {
        FatalError("Error deserializing 'ref' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->isMutable())), __msg, __iter)))) {
        FatalError("Error deserializing 'isMutable' (bool) member of 'SimpleURIParams'");
        return false;
    }
    return true;
}



} // namespace net
} // namespace mozilla
