//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PUDPSocketParent.h"
#include "ipc/IPCMessageUtils.h"

#include "mozilla/net/PNeckoParent.h"
#include "mozilla/dom/PBlobParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace net {



MOZ_IMPLICIT PUDPSocketParent::PUDPSocketParent() :
    mId(0),
    mState(PUDPSocket::__Dead)
{
    MOZ_COUNT_CTOR(PUDPSocketParent);
}

PUDPSocketParent::~PUDPSocketParent()
{
    MOZ_COUNT_DTOR(PUDPSocketParent);
}

auto PUDPSocketParent::Manager() const -> PNeckoParent*
{
    return static_cast<PNeckoParent*>(mManager);
}

auto PUDPSocketParent::state() -> PUDPSocket::State
{
    return mState;
}

auto PUDPSocketParent::SendCallbackOpened(const UDPAddressInfo& addressInfo) -> bool
{
    PUDPSocket::Msg_CallbackOpened* __msg = new PUDPSocket::Msg_CallbackOpened();

    Write(addressInfo, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PUDPSocketParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PUDPSocket", "AsyncSendCallbackOpened", js::ProfileEntry::Category::OTHER);
    if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Send, PUDPSocket::Msg_CallbackOpened__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PUDPSocketParent::SendCallbackClosed() -> bool
{
    PUDPSocket::Msg_CallbackClosed* __msg = new PUDPSocket::Msg_CallbackClosed();


    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PUDPSocketParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PUDPSocket", "AsyncSendCallbackClosed", js::ProfileEntry::Category::OTHER);
    if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Send, PUDPSocket::Msg_CallbackClosed__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PUDPSocketParent::SendCallbackReceivedData(
        const UDPAddressInfo& addressInfo,
        const nsTArray<uint8_t>& data) -> bool
{
    PUDPSocket::Msg_CallbackReceivedData* __msg = new PUDPSocket::Msg_CallbackReceivedData();

    Write(addressInfo, __msg);
    Write(data, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PUDPSocketParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PUDPSocket", "AsyncSendCallbackReceivedData", js::ProfileEntry::Category::OTHER);
    if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Send, PUDPSocket::Msg_CallbackReceivedData__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PUDPSocketParent::SendCallbackError(
        const nsCString& message,
        const nsCString& filename,
        const uint32_t& lineNumber) -> bool
{
    PUDPSocket::Msg_CallbackError* __msg = new PUDPSocket::Msg_CallbackError();

    Write(message, __msg);
    Write(filename, __msg);
    Write(lineNumber, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PUDPSocketParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PUDPSocket", "AsyncSendCallbackError", js::ProfileEntry::Category::OTHER);
    if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Send, PUDPSocket::Msg_CallbackError__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PUDPSocketParent::Send__delete__(PUDPSocketParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    if ((!(actor))) {
        return false;
    }

    PUDPSocket::Msg___delete__* __msg = new PUDPSocket::Msg___delete__();

    (actor)->Write(actor, __msg, false);

    (__msg)->set_routing_id((actor)->mId);
    (__msg)->set_priority(1);


    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PUDPSocketParent] Sending ", (actor)->OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PUDPSocket", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PUDPSocket::Transition((actor)->mState, Trigger(Trigger::Send, PUDPSocket::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = ((actor)->mChannel)->Send(__msg);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PUDPSocketMsgStart, actor);
    return __sendok;
}

auto PUDPSocketParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PUDPSocketParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PUDPSocketParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PUDPSocketParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PUDPSocketParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PUDPSocketParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PUDPSocketParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PUDPSocketParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PUDPSocketParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PUDPSocketParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PUDPSocketParent::OtherProcess() const -> ProcessHandle
{
    return (mManager)->OtherProcess();
}

auto PUDPSocketParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PUDPSocketParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PUDPSocketParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PUDPSocket has not yet been implemented");
    return nullptr;
}

auto PUDPSocketParent::OnMessageReceived(const Message& __msg) -> PUDPSocketParent::Result
{
    switch ((__msg).type()) {
    case PUDPSocket::Msg_Bind__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PUDPSocket::Msg_Bind");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PUDPSocket::Msg_Bind*>((&(__msg))))->Log("[PUDPSocketParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PUDPSocket", "RecvBind", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            UDPAddressInfo addressInfo;
            bool addressReuse;
            bool loopback;

            if ((!(Read((&(addressInfo)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'UDPAddressInfo'");
                return MsgValueError;
            }
            if ((!(Read((&(addressReuse)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(Read((&(loopback)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Recv, PUDPSocket::Msg_Bind__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvBind(addressInfo, addressReuse, loopback)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Bind returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_OutgoingData__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PUDPSocket::Msg_OutgoingData");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PUDPSocket::Msg_OutgoingData*>((&(__msg))))->Log("[PUDPSocketParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PUDPSocket", "RecvOutgoingData", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            UDPData data;
            UDPSocketAddr addr;

            if ((!(Read((&(data)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'UDPData'");
                return MsgValueError;
            }
            if ((!(Read((&(addr)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'UDPSocketAddr'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Recv, PUDPSocket::Msg_OutgoingData__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvOutgoingData(data, addr)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for OutgoingData returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_JoinMulticast__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PUDPSocket::Msg_JoinMulticast");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PUDPSocket::Msg_JoinMulticast*>((&(__msg))))->Log("[PUDPSocketParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PUDPSocket", "RecvJoinMulticast", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString multicastAddress;
            nsCString iface;

            if ((!(Read((&(multicastAddress)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(iface)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Recv, PUDPSocket::Msg_JoinMulticast__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvJoinMulticast(multicastAddress, iface)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for JoinMulticast returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_LeaveMulticast__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PUDPSocket::Msg_LeaveMulticast");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PUDPSocket::Msg_LeaveMulticast*>((&(__msg))))->Log("[PUDPSocketParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PUDPSocket", "RecvLeaveMulticast", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString multicastAddress;
            nsCString iface;

            if ((!(Read((&(multicastAddress)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(iface)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Recv, PUDPSocket::Msg_LeaveMulticast__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvLeaveMulticast(multicastAddress, iface)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for LeaveMulticast returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_Close__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PUDPSocket::Msg_Close");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PUDPSocket::Msg_Close*>((&(__msg))))->Log("[PUDPSocketParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PUDPSocket", "RecvClose", js::ProfileEntry::Category::OTHER);

            if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Recv, PUDPSocket::Msg_Close__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvClose()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Close returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_RequestDelete__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PUDPSocket::Msg_RequestDelete");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PUDPSocket::Msg_RequestDelete*>((&(__msg))))->Log("[PUDPSocketParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PUDPSocket", "RecvRequestDelete", js::ProfileEntry::Category::OTHER);

            if ((!(PUDPSocket::Transition(mState, Trigger(Trigger::Recv, PUDPSocket::Msg_RequestDelete__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvRequestDelete()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for RequestDelete returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PUDPSocketParent::OnMessageReceived(
        const Message& __msg,
        Message*& __reply) -> PUDPSocketParent::Result
{
    return MsgNotKnown;
}

auto PUDPSocketParent::OnCallReceived(
        const Message& __msg,
        Message*& __reply) -> PUDPSocketParent::Result
{
    return MsgNotKnown;
}

auto PUDPSocketParent::OnProcessingError(Result aCode) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PUDPSocketParent::GetProtocolTypeId() -> int32_t
{
    return PUDPSocketMsgStart;
}

auto PUDPSocketParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PUDPSocketParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PUDPSocketParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PUDPSocketParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PUDPSocketParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PUDPSocketParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PUDPSocketParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PUDPSocketParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PUDPSocketParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PUDPSocketParent", aMsg, OtherProcess(), true);
}

auto PUDPSocketParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PUDPSocketParent::DeallocSubtree() -> void
{
}

auto PUDPSocketParent::Write(
        const StringInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).data(), __msg);
}

auto PUDPSocketParent::Read(
        StringInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->data())), __msg, __iter)))) {
        FatalError("Error deserializing 'data' (nsCString) member of 'StringInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const FileInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).fileDescriptorIndex(), __msg);
    Write((__v).behaviorFlags(), __msg);
    Write((__v).ioFlags(), __msg);
}

auto PUDPSocketParent::Read(
        FileInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->fileDescriptorIndex())), __msg, __iter)))) {
        FatalError("Error deserializing 'fileDescriptorIndex' (uint32_t) member of 'FileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->behaviorFlags())), __msg, __iter)))) {
        FatalError("Error deserializing 'behaviorFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->ioFlags())), __msg, __iter)))) {
        FatalError("Error deserializing 'ioFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        PUDPSocketParent* __v,
        Message* __msg,
        bool __nullable) -> void
{
    int32_t id;
    if ((!(__v))) {
        if ((!(__nullable))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (__v)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, __msg);
}

auto PUDPSocketParent::Read(
        PUDPSocketParent** __v,
        const Message* __msg,
        void** __iter,
        bool __nullable) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), __msg, __iter)))) {
        FatalError("Error deserializing 'id' for 'PUDPSocketParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(__nullable))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PUDPSocket");
        return false;
    }

    if ((0) == (id)) {
        (*(__v)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PUDPSocket");
        return false;
    }

    if ((PUDPSocketMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PUDPSocket has different type");
        return false;
    }

    (*(__v)) = static_cast<PUDPSocketParent*>(listener);
    return true;
}

auto PUDPSocketParent::Write(
        const MultiplexInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).streams(), __msg);
    Write((__v).currentStream(), __msg);
    Write((__v).status(), __msg);
    Write((__v).startedReadingCurrent(), __msg);
}

auto PUDPSocketParent::Read(
        MultiplexInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->streams())), __msg, __iter)))) {
        FatalError("Error deserializing 'streams' (InputStreamParams[]) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->currentStream())), __msg, __iter)))) {
        FatalError("Error deserializing 'currentStream' (uint32_t) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->status())), __msg, __iter)))) {
        FatalError("Error deserializing 'status' (nsresult) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->startedReadingCurrent())), __msg, __iter)))) {
        FatalError("Error deserializing 'startedReadingCurrent' (bool) member of 'MultiplexInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const nsTArray<InputStreamParams>& __v,
        Message* __msg) -> void
{
    uint32_t length = (__v).Length();
    Write(length, __msg);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(__v[i], __msg);
    }
}

auto PUDPSocketParent::Read(
        nsTArray<InputStreamParams>* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    FallibleTArray<InputStreamParams> fa;
    uint32_t length;
    if ((!(Read((&(length)), __msg, __iter)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'InputStreamParams[]'");
        return false;
    }

    if ((!((fa).SetLength(length)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), __msg, __iter)))) {
            FatalError("Error deserializing 'InputStreamParams[i]'");
            return false;
        }
    }
    (__v)->SwapElements(fa);
    return true;
}

auto PUDPSocketParent::Write(
        const OptionalInputStreamParams& __v,
        Message* __msg) -> void
{
    typedef OptionalInputStreamParams __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::Tvoid_t:
        {
            Write((__v).get_void_t(), __msg);
            return;
        }
    case __type::TInputStreamParams:
        {
            Write((__v).get_InputStreamParams(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PUDPSocketParent::Read(
        OptionalInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef OptionalInputStreamParams __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalInputStreamParams'");
        return false;
    }

    switch (type) {
    case __type::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(__v)) = tmp;
            return Read((&((__v)->get_void_t())), __msg, __iter);
        }
    case __type::TInputStreamParams:
        {
            InputStreamParams tmp = InputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_InputStreamParams())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PUDPSocketParent::Write(
        const MIMEInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).optionalStream(), __msg);
    Write((__v).headers(), __msg);
    Write((__v).contentLength(), __msg);
    Write((__v).startedReading(), __msg);
    Write((__v).addContentLength(), __msg);
}

auto PUDPSocketParent::Read(
        MIMEInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->optionalStream())), __msg, __iter)))) {
        FatalError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->headers())), __msg, __iter)))) {
        FatalError("Error deserializing 'headers' (nsCString) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->contentLength())), __msg, __iter)))) {
        FatalError("Error deserializing 'contentLength' (nsCString) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->startedReading())), __msg, __iter)))) {
        FatalError("Error deserializing 'startedReading' (bool) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->addContentLength())), __msg, __iter)))) {
        FatalError("Error deserializing 'addContentLength' (bool) member of 'MIMEInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const InputStreamParams& __v,
        Message* __msg) -> void
{
    typedef InputStreamParams __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::TStringInputStreamParams:
        {
            Write((__v).get_StringInputStreamParams(), __msg);
            return;
        }
    case __type::TFileInputStreamParams:
        {
            Write((__v).get_FileInputStreamParams(), __msg);
            return;
        }
    case __type::TPartialFileInputStreamParams:
        {
            Write((__v).get_PartialFileInputStreamParams(), __msg);
            return;
        }
    case __type::TBufferedInputStreamParams:
        {
            Write((__v).get_BufferedInputStreamParams(), __msg);
            return;
        }
    case __type::TMIMEInputStreamParams:
        {
            Write((__v).get_MIMEInputStreamParams(), __msg);
            return;
        }
    case __type::TMultiplexInputStreamParams:
        {
            Write((__v).get_MultiplexInputStreamParams(), __msg);
            return;
        }
    case __type::TRemoteInputStreamParams:
        {
            Write((__v).get_RemoteInputStreamParams(), __msg);
            return;
        }
    case __type::TSameProcessInputStreamParams:
        {
            Write((__v).get_SameProcessInputStreamParams(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PUDPSocketParent::Read(
        InputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef InputStreamParams __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'InputStreamParams'");
        return false;
    }

    switch (type) {
    case __type::TStringInputStreamParams:
        {
            StringInputStreamParams tmp = StringInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_StringInputStreamParams())), __msg, __iter);
        }
    case __type::TFileInputStreamParams:
        {
            FileInputStreamParams tmp = FileInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_FileInputStreamParams())), __msg, __iter);
        }
    case __type::TPartialFileInputStreamParams:
        {
            PartialFileInputStreamParams tmp = PartialFileInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_PartialFileInputStreamParams())), __msg, __iter);
        }
    case __type::TBufferedInputStreamParams:
        {
            BufferedInputStreamParams tmp = BufferedInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_BufferedInputStreamParams())), __msg, __iter);
        }
    case __type::TMIMEInputStreamParams:
        {
            MIMEInputStreamParams tmp = MIMEInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_MIMEInputStreamParams())), __msg, __iter);
        }
    case __type::TMultiplexInputStreamParams:
        {
            MultiplexInputStreamParams tmp = MultiplexInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_MultiplexInputStreamParams())), __msg, __iter);
        }
    case __type::TRemoteInputStreamParams:
        {
            RemoteInputStreamParams tmp = RemoteInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_RemoteInputStreamParams())), __msg, __iter);
        }
    case __type::TSameProcessInputStreamParams:
        {
            SameProcessInputStreamParams tmp = SameProcessInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_SameProcessInputStreamParams())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PUDPSocketParent::Write(
        const BufferedInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).optionalStream(), __msg);
    Write((__v).bufferSize(), __msg);
}

auto PUDPSocketParent::Read(
        BufferedInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->optionalStream())), __msg, __iter)))) {
        FatalError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'BufferedInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->bufferSize())), __msg, __iter)))) {
        FatalError("Error deserializing 'bufferSize' (uint32_t) member of 'BufferedInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const SameProcessInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).addRefedInputStream(), __msg);
}

auto PUDPSocketParent::Read(
        SameProcessInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->addRefedInputStream())), __msg, __iter)))) {
        FatalError("Error deserializing 'addRefedInputStream' (intptr_t) member of 'SameProcessInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const UDPSocketAddr& __v,
        Message* __msg) -> void
{
    typedef UDPSocketAddr __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::TUDPAddressInfo:
        {
            Write((__v).get_UDPAddressInfo(), __msg);
            return;
        }
    case __type::TNetAddr:
        {
            Write((__v).get_NetAddr(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PUDPSocketParent::Read(
        UDPSocketAddr* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef UDPSocketAddr __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'UDPSocketAddr'");
        return false;
    }

    switch (type) {
    case __type::TUDPAddressInfo:
        {
            UDPAddressInfo tmp = UDPAddressInfo();
            (*(__v)) = tmp;
            return Read((&((__v)->get_UDPAddressInfo())), __msg, __iter);
        }
    case __type::TNetAddr:
        {
            NetAddr tmp = NetAddr();
            (*(__v)) = tmp;
            return Read((&((__v)->get_NetAddr())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PUDPSocketParent::Write(
        const PartialFileInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).fileStreamParams(), __msg);
    Write((__v).begin(), __msg);
    Write((__v).length(), __msg);
}

auto PUDPSocketParent::Read(
        PartialFileInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->fileStreamParams())), __msg, __iter)))) {
        FatalError("Error deserializing 'fileStreamParams' (FileInputStreamParams) member of 'PartialFileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->begin())), __msg, __iter)))) {
        FatalError("Error deserializing 'begin' (uint64_t) member of 'PartialFileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->length())), __msg, __iter)))) {
        FatalError("Error deserializing 'length' (uint64_t) member of 'PartialFileInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const RemoteInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).id(), __msg);
}

auto PUDPSocketParent::Read(
        RemoteInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->id())), __msg, __iter)))) {
        FatalError("Error deserializing 'id' (nsID) member of 'RemoteInputStreamParams'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const UDPAddressInfo& __v,
        Message* __msg) -> void
{
    Write((__v).addr(), __msg);
    Write((__v).port(), __msg);
}

auto PUDPSocketParent::Read(
        UDPAddressInfo* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->addr())), __msg, __iter)))) {
        FatalError("Error deserializing 'addr' (nsCString) member of 'UDPAddressInfo'");
        return false;
    }
    if ((!(Read((&((__v)->port())), __msg, __iter)))) {
        FatalError("Error deserializing 'port' (uint16_t) member of 'UDPAddressInfo'");
        return false;
    }
    return true;
}

auto PUDPSocketParent::Write(
        const UDPData& __v,
        Message* __msg) -> void
{
    typedef UDPData __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::TArrayOfuint8_t:
        {
            Write((__v).get_ArrayOfuint8_t(), __msg);
            return;
        }
    case __type::TInputStreamParams:
        {
            Write((__v).get_InputStreamParams(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PUDPSocketParent::Read(
        UDPData* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef UDPData __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'UDPData'");
        return false;
    }

    switch (type) {
    case __type::TArrayOfuint8_t:
        {
            nsTArray<uint8_t> tmp;
            (*(__v)) = tmp;
            return Read((&((__v)->get_ArrayOfuint8_t())), __msg, __iter);
        }
    case __type::TInputStreamParams:
        {
            InputStreamParams tmp = InputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_InputStreamParams())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}



} // namespace net
} // namespace mozilla
