//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PWebSocketParent.h"
#include "SerializedLoadContext.h"

#include "mozilla/net/PNeckoParent.h"
#include "mozilla/dom/PBrowserParent.h"
#include "mozilla/dom/PBlobParent.h"

#include "nsIFile.h"
#include "GeckoProfiler.h"

namespace mozilla {
namespace net {



MOZ_IMPLICIT PWebSocketParent::PWebSocketParent() :
    mId(0),
    mState(PWebSocket::__Dead)
{
    MOZ_COUNT_CTOR(PWebSocketParent);
}

PWebSocketParent::~PWebSocketParent()
{
    MOZ_COUNT_DTOR(PWebSocketParent);
}

auto PWebSocketParent::Manager() const -> PNeckoParent*
{
    return static_cast<PNeckoParent*>(mManager);
}

auto PWebSocketParent::state() -> PWebSocket::State
{
    return mState;
}

auto PWebSocketParent::SendOnStart(
        const nsCString& aProtocol,
        const nsCString& aExtensions,
        const nsString& aEffectiveURL,
        const bool& aEncrypted) -> bool
{
    PWebSocket::Msg_OnStart* __msg = new PWebSocket::Msg_OnStart();

    Write(aProtocol, __msg);
    Write(aExtensions, __msg);
    Write(aEffectiveURL, __msg);
    Write(aEncrypted, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PWebSocketParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSendOnStart", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Send, PWebSocket::Msg_OnStart__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PWebSocketParent::SendOnStop(const nsresult& aStatusCode) -> bool
{
    PWebSocket::Msg_OnStop* __msg = new PWebSocket::Msg_OnStop();

    Write(aStatusCode, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PWebSocketParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSendOnStop", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Send, PWebSocket::Msg_OnStop__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PWebSocketParent::SendOnMessageAvailable(const nsCString& aMsg) -> bool
{
    PWebSocket::Msg_OnMessageAvailable* __msg = new PWebSocket::Msg_OnMessageAvailable();

    Write(aMsg, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PWebSocketParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSendOnMessageAvailable", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Send, PWebSocket::Msg_OnMessageAvailable__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PWebSocketParent::SendOnBinaryMessageAvailable(const nsCString& aMsg) -> bool
{
    PWebSocket::Msg_OnBinaryMessageAvailable* __msg = new PWebSocket::Msg_OnBinaryMessageAvailable();

    Write(aMsg, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PWebSocketParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSendOnBinaryMessageAvailable", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Send, PWebSocket::Msg_OnBinaryMessageAvailable__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PWebSocketParent::SendOnAcknowledge(const uint32_t& aSize) -> bool
{
    PWebSocket::Msg_OnAcknowledge* __msg = new PWebSocket::Msg_OnAcknowledge();

    Write(aSize, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PWebSocketParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSendOnAcknowledge", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Send, PWebSocket::Msg_OnAcknowledge__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PWebSocketParent::SendOnServerClose(
        const uint16_t& code,
        const nsCString& aReason) -> bool
{
    PWebSocket::Msg_OnServerClose* __msg = new PWebSocket::Msg_OnServerClose();

    Write(code, __msg);
    Write(aReason, __msg);

    (__msg)->set_routing_id(mId);
    (__msg)->set_priority(1);



    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PWebSocketParent] Sending ", OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSendOnServerClose", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Send, PWebSocket::Msg_OnServerClose__ID), (&(mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = (mChannel)->Send(__msg);
    return __sendok;
}

auto PWebSocketParent::Send__delete__(PWebSocketParent* actor) -> bool
{
    if ((!(actor))) {
        return false;
    }

    if ((!(actor))) {
        return false;
    }

    PWebSocket::Msg___delete__* __msg = new PWebSocket::Msg___delete__();

    (actor)->Write(actor, __msg, false);

    (__msg)->set_routing_id((actor)->mId);
    (__msg)->set_priority(1);


    if (mozilla::ipc::LoggingEnabledFor("PContent")) {
        (__msg)->Log("[PWebSocketParent] Sending ", (actor)->OtherProcess(), false);
    }
    PROFILER_LABEL("IPDL::PWebSocket", "AsyncSend__delete__", js::ProfileEntry::Category::OTHER);
    if ((!(PWebSocket::Transition((actor)->mState, Trigger(Trigger::Send, PWebSocket::Msg___delete____ID), (&((actor)->mState)))))) {
        NS_WARNING("bad state transition!");
    }

    bool __sendok = ((actor)->mChannel)->Send(__msg);

    (actor)->DestroySubtree(Deletion);
    (actor)->DeallocSubtree();
    ((actor)->mManager)->RemoveManagee(PWebSocketMsgStart, actor);
    return __sendok;
}

auto PWebSocketParent::Register(ProtocolBase* aRouted) -> int32_t
{
    return (mManager)->Register(aRouted);
}

auto PWebSocketParent::RegisterID(
        ProtocolBase* aRouted,
        int32_t aId) -> int32_t
{
    return (mManager)->RegisterID(aRouted, aId);
}

auto PWebSocketParent::Lookup(int32_t aId) -> ProtocolBase*
{
    return (mManager)->Lookup(aId);
}

auto PWebSocketParent::Unregister(int32_t aId) -> void
{
    return (mManager)->Unregister(aId);
}

auto PWebSocketParent::RemoveManagee(
        int32_t aProtocolId,
        ProtocolBase* aListener) -> void
{
    NS_RUNTIMEABORT("unreached");
    return;
}

auto PWebSocketParent::CreateSharedMemory(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        bool aUnsafe,
        Shmem::id_t* aId) -> Shmem::SharedMemory*
{
    return (mManager)->CreateSharedMemory(aSize, aType, aUnsafe, aId);
}

auto PWebSocketParent::AdoptSharedMemory(
        Shmem::SharedMemory* segment,
        Shmem::id_t* aId) -> bool
{
    return (mManager)->AdoptSharedMemory(segment, aId);
}

auto PWebSocketParent::LookupSharedMemory(Shmem::id_t aId) -> Shmem::SharedMemory*
{
    return (mManager)->LookupSharedMemory(aId);
}

auto PWebSocketParent::IsTrackingSharedMemory(Shmem::SharedMemory* segment) -> bool
{
    return (mManager)->IsTrackingSharedMemory(segment);
}

auto PWebSocketParent::DestroySharedMemory(Shmem& shmem) -> bool
{
    return (mManager)->DestroySharedMemory(shmem);
}

auto PWebSocketParent::OtherProcess() const -> ProcessHandle
{
    return (mManager)->OtherProcess();
}

auto PWebSocketParent::GetIPCChannel() -> MessageChannel*
{
    return mChannel;
}

auto PWebSocketParent::CloneManagees(
        ProtocolBase* aSource,
        ProtocolCloneContext* aCtx) -> void
{
}

auto PWebSocketParent::CloneProtocol(
        Channel* aChannel,
        ProtocolCloneContext* aCtx) -> mozilla::ipc::IProtocol*
{
    NS_RUNTIMEABORT("Clone() for PWebSocket has not yet been implemented");
    return nullptr;
}

auto PWebSocketParent::OnMessageReceived(const Message& __msg) -> PWebSocketParent::Result
{
    switch ((__msg).type()) {
    case PWebSocket::Msg_AsyncOpen__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PWebSocket::Msg_AsyncOpen");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PWebSocket::Msg_AsyncOpen*>((&(__msg))))->Log("[PWebSocketParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PWebSocket", "RecvAsyncOpen", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            URIParams aURI;
            nsCString aOrigin;
            nsCString aProtocol;
            bool aSecure;
            uint32_t aPingInterval;
            bool aClientSetPingInterval;
            uint32_t aPingTimeout;
            bool aClientSetPingTimeout;

            if ((!(Read((&(aURI)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'URIParams'");
                return MsgValueError;
            }
            if ((!(Read((&(aOrigin)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aProtocol)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(Read((&(aSecure)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(Read((&(aPingInterval)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(Read((&(aClientSetPingInterval)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(Read((&(aPingTimeout)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(Read((&(aClientSetPingTimeout)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Recv, PWebSocket::Msg_AsyncOpen__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvAsyncOpen(aURI, aOrigin, aProtocol, aSecure, aPingInterval, aClientSetPingInterval, aPingTimeout, aClientSetPingTimeout)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for AsyncOpen returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebSocket::Msg_Close__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PWebSocket::Msg_Close");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PWebSocket::Msg_Close*>((&(__msg))))->Log("[PWebSocketParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PWebSocket", "RecvClose", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            uint16_t code;
            nsCString reason;

            if ((!(Read((&(code)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint16_t'");
                return MsgValueError;
            }
            if ((!(Read((&(reason)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Recv, PWebSocket::Msg_Close__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvClose(code, reason)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for Close returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebSocket::Msg_SendMsg__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PWebSocket::Msg_SendMsg");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PWebSocket::Msg_SendMsg*>((&(__msg))))->Log("[PWebSocketParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PWebSocket", "RecvSendMsg", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString aMsg;

            if ((!(Read((&(aMsg)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Recv, PWebSocket::Msg_SendMsg__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSendMsg(aMsg)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SendMsg returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebSocket::Msg_SendBinaryMsg__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PWebSocket::Msg_SendBinaryMsg");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PWebSocket::Msg_SendBinaryMsg*>((&(__msg))))->Log("[PWebSocketParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PWebSocket", "RecvSendBinaryMsg", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            nsCString aMsg;

            if ((!(Read((&(aMsg)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Recv, PWebSocket::Msg_SendBinaryMsg__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSendBinaryMsg(aMsg)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SendBinaryMsg returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebSocket::Msg_SendBinaryStream__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PWebSocket::Msg_SendBinaryStream");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PWebSocket::Msg_SendBinaryStream*>((&(__msg))))->Log("[PWebSocketParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PWebSocket", "RecvSendBinaryStream", js::ProfileEntry::Category::OTHER);

            void* __iter = nullptr;
            InputStreamParams aStream;
            uint32_t aLength;

            if ((!(Read((&(aStream)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'InputStreamParams'");
                return MsgValueError;
            }
            if ((!(Read((&(aLength)), (&(__msg)), (&(__iter)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            (__msg).EndRead(__iter);
            if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Recv, PWebSocket::Msg_SendBinaryStream__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvSendBinaryStream(aStream, aLength)))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for SendBinaryStream returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebSocket::Msg_DeleteSelf__ID:
        {
            (const_cast<Message&>(__msg)).set_name("PWebSocket::Msg_DeleteSelf");
            if (mozilla::ipc::LoggingEnabledFor("PContent")) {
                (static_cast<const PWebSocket::Msg_DeleteSelf*>((&(__msg))))->Log("[PWebSocketParent] Received ", OtherProcess(), true);
            }
            PROFILER_LABEL("IPDL::PWebSocket", "RecvDeleteSelf", js::ProfileEntry::Category::OTHER);

            if ((!(PWebSocket::Transition(mState, Trigger(Trigger::Recv, PWebSocket::Msg_DeleteSelf__ID), (&(mState)))))) {
                NS_WARNING("bad state transition!");
            }
            if ((!(RecvDeleteSelf()))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler for DeleteSelf returned error code");
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PWebSocket::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        {
            return MsgNotKnown;
        }
    }
}

auto PWebSocketParent::OnMessageReceived(
        const Message& __msg,
        Message*& __reply) -> PWebSocketParent::Result
{
    return MsgNotKnown;
}

auto PWebSocketParent::OnCallReceived(
        const Message& __msg,
        Message*& __reply) -> PWebSocketParent::Result
{
    return MsgNotKnown;
}

auto PWebSocketParent::OnProcessingError(Result aCode) -> void
{
    NS_RUNTIMEABORT("`OnProcessingError' called on non-toplevel actor");
}

auto PWebSocketParent::GetProtocolTypeId() -> int32_t
{
    return PWebSocketMsgStart;
}

auto PWebSocketParent::OnReplyTimeout() -> bool
{
    NS_RUNTIMEABORT("`OnReplyTimeout' called on non-toplevel actor");
    return false;
}

auto PWebSocketParent::OnChannelClose() -> void
{
    NS_RUNTIMEABORT("`OnClose' called on non-toplevel actor");
}

auto PWebSocketParent::OnChannelError() -> void
{
    NS_RUNTIMEABORT("`OnError' called on non-toplevel actor");
}

auto PWebSocketParent::OnChannelConnected(int32_t aPid) -> void
{
    NS_RUNTIMEABORT("'OnConnected' called on non-toplevel actor");
}

auto PWebSocketParent::AllocShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, false, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PWebSocketParent::AllocUnsafeShmem(
        size_t aSize,
        Shmem::SharedMemory::SharedMemoryType aType,
        Shmem* aOutMem) -> bool
{
    Shmem::id_t id;
    Shmem::SharedMemory* rawmem(CreateSharedMemory(aSize, aType, true, (&(id))));
    if ((!(rawmem))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PWebSocketParent::AdoptShmem(
        Shmem& aMem,
        Shmem* aOutMem) -> bool
{
    Shmem::SharedMemory* rawmem = (aMem).Segment(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    if (((!(rawmem))) || (IsTrackingSharedMemory(rawmem))) {
        NS_WARNING("bad Shmem");
        return false;
    }

    Shmem::id_t id;
    if ((!(AdoptSharedMemory(rawmem, (&(id)))))) {
        return false;
    }

    (*(aOutMem)) = Shmem(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead(), rawmem, id);
    return true;
}

auto PWebSocketParent::DeallocShmem(Shmem& aMem) -> bool
{
    bool ok = DestroySharedMemory(aMem);
#ifdef DEBUG
    if ((!(ok))) {
        NS_WARNING("bad Shmem");
        return false;
    }
#endif // DEBUG
    (aMem).forget(Shmem::IHadBetterBeIPDLCodeCallingThis_OtherwiseIAmADoodyhead());
    return ok;
}

auto PWebSocketParent::FatalError(const char* const aMsg) const -> void
{
    mozilla::ipc::FatalError("PWebSocketParent", aMsg, OtherProcess(), true);
}

auto PWebSocketParent::DestroySubtree(ActorDestroyReason why) -> void
{
    // Unregister from our manager.
    Unregister(mId);
    mId = 1;

    // Finally, destroy "us".
    ActorDestroy(why);
}

auto PWebSocketParent::DeallocSubtree() -> void
{
}

auto PWebSocketParent::Write(
        const StringInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).data(), __msg);
}

auto PWebSocketParent::Read(
        StringInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->data())), __msg, __iter)))) {
        FatalError("Error deserializing 'data' (nsCString) member of 'StringInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const FileInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).fileDescriptorIndex(), __msg);
    Write((__v).behaviorFlags(), __msg);
    Write((__v).ioFlags(), __msg);
}

auto PWebSocketParent::Read(
        FileInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->fileDescriptorIndex())), __msg, __iter)))) {
        FatalError("Error deserializing 'fileDescriptorIndex' (uint32_t) member of 'FileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->behaviorFlags())), __msg, __iter)))) {
        FatalError("Error deserializing 'behaviorFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->ioFlags())), __msg, __iter)))) {
        FatalError("Error deserializing 'ioFlags' (int32_t) member of 'FileInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const RemoteInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).id(), __msg);
}

auto PWebSocketParent::Read(
        RemoteInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->id())), __msg, __iter)))) {
        FatalError("Error deserializing 'id' (nsID) member of 'RemoteInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const MultiplexInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).streams(), __msg);
    Write((__v).currentStream(), __msg);
    Write((__v).status(), __msg);
    Write((__v).startedReadingCurrent(), __msg);
}

auto PWebSocketParent::Read(
        MultiplexInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->streams())), __msg, __iter)))) {
        FatalError("Error deserializing 'streams' (InputStreamParams[]) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->currentStream())), __msg, __iter)))) {
        FatalError("Error deserializing 'currentStream' (uint32_t) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->status())), __msg, __iter)))) {
        FatalError("Error deserializing 'status' (nsresult) member of 'MultiplexInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->startedReadingCurrent())), __msg, __iter)))) {
        FatalError("Error deserializing 'startedReadingCurrent' (bool) member of 'MultiplexInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const StandardURLParams& __v,
        Message* __msg) -> void
{
    Write((__v).urlType(), __msg);
    Write((__v).port(), __msg);
    Write((__v).defaultPort(), __msg);
    Write((__v).spec(), __msg);
    Write((__v).scheme(), __msg);
    Write((__v).authority(), __msg);
    Write((__v).username(), __msg);
    Write((__v).password(), __msg);
    Write((__v).host(), __msg);
    Write((__v).path(), __msg);
    Write((__v).filePath(), __msg);
    Write((__v).directory(), __msg);
    Write((__v).baseName(), __msg);
    Write((__v).extension(), __msg);
    Write((__v).query(), __msg);
    Write((__v).ref(), __msg);
    Write((__v).originCharset(), __msg);
    Write((__v).isMutable(), __msg);
    Write((__v).supportsFileURL(), __msg);
    Write((__v).hostEncoding(), __msg);
}

auto PWebSocketParent::Read(
        StandardURLParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->urlType())), __msg, __iter)))) {
        FatalError("Error deserializing 'urlType' (uint32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->port())), __msg, __iter)))) {
        FatalError("Error deserializing 'port' (int32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->defaultPort())), __msg, __iter)))) {
        FatalError("Error deserializing 'defaultPort' (int32_t) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->spec())), __msg, __iter)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->scheme())), __msg, __iter)))) {
        FatalError("Error deserializing 'scheme' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->authority())), __msg, __iter)))) {
        FatalError("Error deserializing 'authority' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->username())), __msg, __iter)))) {
        FatalError("Error deserializing 'username' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->password())), __msg, __iter)))) {
        FatalError("Error deserializing 'password' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->host())), __msg, __iter)))) {
        FatalError("Error deserializing 'host' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->path())), __msg, __iter)))) {
        FatalError("Error deserializing 'path' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->filePath())), __msg, __iter)))) {
        FatalError("Error deserializing 'filePath' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->directory())), __msg, __iter)))) {
        FatalError("Error deserializing 'directory' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->baseName())), __msg, __iter)))) {
        FatalError("Error deserializing 'baseName' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->extension())), __msg, __iter)))) {
        FatalError("Error deserializing 'extension' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->query())), __msg, __iter)))) {
        FatalError("Error deserializing 'query' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->ref())), __msg, __iter)))) {
        FatalError("Error deserializing 'ref' (StandardURLSegment) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->originCharset())), __msg, __iter)))) {
        FatalError("Error deserializing 'originCharset' (nsCString) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->isMutable())), __msg, __iter)))) {
        FatalError("Error deserializing 'isMutable' (bool) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->supportsFileURL())), __msg, __iter)))) {
        FatalError("Error deserializing 'supportsFileURL' (bool) member of 'StandardURLParams'");
        return false;
    }
    if ((!(Read((&((__v)->hostEncoding())), __msg, __iter)))) {
        FatalError("Error deserializing 'hostEncoding' (uint32_t) member of 'StandardURLParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const OptionalInputStreamParams& __v,
        Message* __msg) -> void
{
    typedef OptionalInputStreamParams __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::Tvoid_t:
        {
            Write((__v).get_void_t(), __msg);
            return;
        }
    case __type::TInputStreamParams:
        {
            Write((__v).get_InputStreamParams(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PWebSocketParent::Read(
        OptionalInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef OptionalInputStreamParams __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'OptionalInputStreamParams'");
        return false;
    }

    switch (type) {
    case __type::Tvoid_t:
        {
            void_t tmp = void_t();
            (*(__v)) = tmp;
            return Read((&((__v)->get_void_t())), __msg, __iter);
        }
    case __type::TInputStreamParams:
        {
            InputStreamParams tmp = InputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_InputStreamParams())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PWebSocketParent::Write(
        const MIMEInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).optionalStream(), __msg);
    Write((__v).headers(), __msg);
    Write((__v).contentLength(), __msg);
    Write((__v).startedReading(), __msg);
    Write((__v).addContentLength(), __msg);
}

auto PWebSocketParent::Read(
        MIMEInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->optionalStream())), __msg, __iter)))) {
        FatalError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->headers())), __msg, __iter)))) {
        FatalError("Error deserializing 'headers' (nsCString) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->contentLength())), __msg, __iter)))) {
        FatalError("Error deserializing 'contentLength' (nsCString) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->startedReading())), __msg, __iter)))) {
        FatalError("Error deserializing 'startedReading' (bool) member of 'MIMEInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->addContentLength())), __msg, __iter)))) {
        FatalError("Error deserializing 'addContentLength' (bool) member of 'MIMEInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const JARURIParams& __v,
        Message* __msg) -> void
{
    Write((__v).jarFile(), __msg);
    Write((__v).jarEntry(), __msg);
    Write((__v).charset(), __msg);
}

auto PWebSocketParent::Read(
        JARURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->jarFile())), __msg, __iter)))) {
        FatalError("Error deserializing 'jarFile' (URIParams) member of 'JARURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->jarEntry())), __msg, __iter)))) {
        FatalError("Error deserializing 'jarEntry' (URIParams) member of 'JARURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->charset())), __msg, __iter)))) {
        FatalError("Error deserializing 'charset' (nsCString) member of 'JARURIParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const InputStreamParams& __v,
        Message* __msg) -> void
{
    typedef InputStreamParams __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::TStringInputStreamParams:
        {
            Write((__v).get_StringInputStreamParams(), __msg);
            return;
        }
    case __type::TFileInputStreamParams:
        {
            Write((__v).get_FileInputStreamParams(), __msg);
            return;
        }
    case __type::TPartialFileInputStreamParams:
        {
            Write((__v).get_PartialFileInputStreamParams(), __msg);
            return;
        }
    case __type::TBufferedInputStreamParams:
        {
            Write((__v).get_BufferedInputStreamParams(), __msg);
            return;
        }
    case __type::TMIMEInputStreamParams:
        {
            Write((__v).get_MIMEInputStreamParams(), __msg);
            return;
        }
    case __type::TMultiplexInputStreamParams:
        {
            Write((__v).get_MultiplexInputStreamParams(), __msg);
            return;
        }
    case __type::TRemoteInputStreamParams:
        {
            Write((__v).get_RemoteInputStreamParams(), __msg);
            return;
        }
    case __type::TSameProcessInputStreamParams:
        {
            Write((__v).get_SameProcessInputStreamParams(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PWebSocketParent::Read(
        InputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef InputStreamParams __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'InputStreamParams'");
        return false;
    }

    switch (type) {
    case __type::TStringInputStreamParams:
        {
            StringInputStreamParams tmp = StringInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_StringInputStreamParams())), __msg, __iter);
        }
    case __type::TFileInputStreamParams:
        {
            FileInputStreamParams tmp = FileInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_FileInputStreamParams())), __msg, __iter);
        }
    case __type::TPartialFileInputStreamParams:
        {
            PartialFileInputStreamParams tmp = PartialFileInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_PartialFileInputStreamParams())), __msg, __iter);
        }
    case __type::TBufferedInputStreamParams:
        {
            BufferedInputStreamParams tmp = BufferedInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_BufferedInputStreamParams())), __msg, __iter);
        }
    case __type::TMIMEInputStreamParams:
        {
            MIMEInputStreamParams tmp = MIMEInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_MIMEInputStreamParams())), __msg, __iter);
        }
    case __type::TMultiplexInputStreamParams:
        {
            MultiplexInputStreamParams tmp = MultiplexInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_MultiplexInputStreamParams())), __msg, __iter);
        }
    case __type::TRemoteInputStreamParams:
        {
            RemoteInputStreamParams tmp = RemoteInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_RemoteInputStreamParams())), __msg, __iter);
        }
    case __type::TSameProcessInputStreamParams:
        {
            SameProcessInputStreamParams tmp = SameProcessInputStreamParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_SameProcessInputStreamParams())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PWebSocketParent::Write(
        const BufferedInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).optionalStream(), __msg);
    Write((__v).bufferSize(), __msg);
}

auto PWebSocketParent::Read(
        BufferedInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->optionalStream())), __msg, __iter)))) {
        FatalError("Error deserializing 'optionalStream' (OptionalInputStreamParams) member of 'BufferedInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->bufferSize())), __msg, __iter)))) {
        FatalError("Error deserializing 'bufferSize' (uint32_t) member of 'BufferedInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const GenericURIParams& __v,
        Message* __msg) -> void
{
    Write((__v).spec(), __msg);
    Write((__v).charset(), __msg);
}

auto PWebSocketParent::Read(
        GenericURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->spec())), __msg, __iter)))) {
        FatalError("Error deserializing 'spec' (nsCString) member of 'GenericURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->charset())), __msg, __iter)))) {
        FatalError("Error deserializing 'charset' (nsCString) member of 'GenericURIParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const StandardURLSegment& __v,
        Message* __msg) -> void
{
    Write((__v).position(), __msg);
    Write((__v).length(), __msg);
}

auto PWebSocketParent::Read(
        StandardURLSegment* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->position())), __msg, __iter)))) {
        FatalError("Error deserializing 'position' (uint32_t) member of 'StandardURLSegment'");
        return false;
    }
    if ((!(Read((&((__v)->length())), __msg, __iter)))) {
        FatalError("Error deserializing 'length' (int32_t) member of 'StandardURLSegment'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const nsTArray<InputStreamParams>& __v,
        Message* __msg) -> void
{
    uint32_t length = (__v).Length();
    Write(length, __msg);

    for (uint32_t i = 0; (i) < (length); (++(i))) {
        Write(__v[i], __msg);
    }
}

auto PWebSocketParent::Read(
        nsTArray<InputStreamParams>* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    FallibleTArray<InputStreamParams> fa;
    uint32_t length;
    if ((!(Read((&(length)), __msg, __iter)))) {
        FatalError("Error deserializing 'length' (uint32_t) of 'InputStreamParams[]'");
        return false;
    }

    if ((!((fa).SetLength(length)))) {
        FatalError("Error setting the array length");
        return false;
    }
    for (uint32_t i = 0; (i) < (length); (++(i))) {
        if ((!(Read((&(fa[i])), __msg, __iter)))) {
            FatalError("Error deserializing 'InputStreamParams[i]'");
            return false;
        }
    }
    (__v)->SwapElements(fa);
    return true;
}

auto PWebSocketParent::Write(
        const URIParams& __v,
        Message* __msg) -> void
{
    typedef URIParams __type;
    Write(int((__v).type()), __msg);

    switch ((__v).type()) {
    case __type::TSimpleURIParams:
        {
            Write((__v).get_SimpleURIParams(), __msg);
            return;
        }
    case __type::TStandardURLParams:
        {
            Write((__v).get_StandardURLParams(), __msg);
            return;
        }
    case __type::TJARURIParams:
        {
            Write((__v).get_JARURIParams(), __msg);
            return;
        }
    case __type::TGenericURIParams:
        {
            Write((__v).get_GenericURIParams(), __msg);
            return;
        }
    default:
        {
            NS_RUNTIMEABORT("unknown union type");
            return;
        }
    }
}

auto PWebSocketParent::Read(
        URIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    typedef URIParams __type;
    int type;
    if ((!(Read((&(type)), __msg, __iter)))) {
        FatalError("Error deserializing 'type' (int) of union 'URIParams'");
        return false;
    }

    switch (type) {
    case __type::TSimpleURIParams:
        {
            SimpleURIParams tmp = SimpleURIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_SimpleURIParams())), __msg, __iter);
        }
    case __type::TStandardURLParams:
        {
            StandardURLParams tmp = StandardURLParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_StandardURLParams())), __msg, __iter);
        }
    case __type::TJARURIParams:
        {
            JARURIParams tmp = JARURIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_JARURIParams())), __msg, __iter);
        }
    case __type::TGenericURIParams:
        {
            GenericURIParams tmp = GenericURIParams();
            (*(__v)) = tmp;
            return Read((&((__v)->get_GenericURIParams())), __msg, __iter);
        }
    default:
        {
            FatalError("unknown union type");
            return false;
        }
    }
}

auto PWebSocketParent::Write(
        const PartialFileInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).fileStreamParams(), __msg);
    Write((__v).begin(), __msg);
    Write((__v).length(), __msg);
}

auto PWebSocketParent::Read(
        PartialFileInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->fileStreamParams())), __msg, __iter)))) {
        FatalError("Error deserializing 'fileStreamParams' (FileInputStreamParams) member of 'PartialFileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->begin())), __msg, __iter)))) {
        FatalError("Error deserializing 'begin' (uint64_t) member of 'PartialFileInputStreamParams'");
        return false;
    }
    if ((!(Read((&((__v)->length())), __msg, __iter)))) {
        FatalError("Error deserializing 'length' (uint64_t) member of 'PartialFileInputStreamParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        PWebSocketParent* __v,
        Message* __msg,
        bool __nullable) -> void
{
    int32_t id;
    if ((!(__v))) {
        if ((!(__nullable))) {
            NS_RUNTIMEABORT("NULL actor value passed to non-nullable param");
        }
        id = 0;
    }
    else {
        id = (__v)->mId;
        if ((1) == (id)) {
            NS_RUNTIMEABORT("actor has been |delete|d");
        }
    }

    Write(id, __msg);
}

auto PWebSocketParent::Read(
        PWebSocketParent** __v,
        const Message* __msg,
        void** __iter,
        bool __nullable) -> bool
{
    int32_t id;
    if ((!(Read((&(id)), __msg, __iter)))) {
        FatalError("Error deserializing 'id' for 'PWebSocketParent'");
        return false;
    }
    if (((1) == (id)) || (((0) == (id)) && ((!(__nullable))))) {
        mozilla::ipc::ProtocolErrorBreakpoint("bad ID for PWebSocket");
        return false;
    }

    if ((0) == (id)) {
        (*(__v)) = nullptr;
        return true;
    }

    ChannelListener* listener = Lookup(id);
    if ((!(listener))) {
        mozilla::ipc::ProtocolErrorBreakpoint("could not look up PWebSocket");
        return false;
    }

    if ((PWebSocketMsgStart) != ((listener)->GetProtocolTypeId())) {
        mozilla::ipc::ProtocolErrorBreakpoint("actor that should be of type PWebSocket has different type");
        return false;
    }

    (*(__v)) = static_cast<PWebSocketParent*>(listener);
    return true;
}

auto PWebSocketParent::Write(
        const SimpleURIParams& __v,
        Message* __msg) -> void
{
    Write((__v).scheme(), __msg);
    Write((__v).path(), __msg);
    Write((__v).ref(), __msg);
    Write((__v).isMutable(), __msg);
}

auto PWebSocketParent::Read(
        SimpleURIParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->scheme())), __msg, __iter)))) {
        FatalError("Error deserializing 'scheme' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->path())), __msg, __iter)))) {
        FatalError("Error deserializing 'path' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->ref())), __msg, __iter)))) {
        FatalError("Error deserializing 'ref' (nsCString) member of 'SimpleURIParams'");
        return false;
    }
    if ((!(Read((&((__v)->isMutable())), __msg, __iter)))) {
        FatalError("Error deserializing 'isMutable' (bool) member of 'SimpleURIParams'");
        return false;
    }
    return true;
}

auto PWebSocketParent::Write(
        const SameProcessInputStreamParams& __v,
        Message* __msg) -> void
{
    Write((__v).addRefedInputStream(), __msg);
}

auto PWebSocketParent::Read(
        SameProcessInputStreamParams* __v,
        const Message* __msg,
        void** __iter) -> bool
{
    if ((!(Read((&((__v)->addRefedInputStream())), __msg, __iter)))) {
        FatalError("Error deserializing 'addRefedInputStream' (intptr_t) member of 'SameProcessInputStreamParams'");
        return false;
    }
    return true;
}



} // namespace net
} // namespace mozilla
