//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef DOMTypes_h
#define DOMTypes_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"
#include "mozilla/ipc/InputStreamParams.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OptionalID|
//
namespace mozilla {
namespace dom {
class OptionalID MOZ_FINAL
{
public:
    enum Type {
        T__None,
        TnsID = 1,
        Tvoid_t,
        T__Last = Tvoid_t
    };

private:
    typedef mozilla::void_t void_t;
    typedef nsID nsID__tdef;
    typedef void_t void_t__tdef;

    union Value {
        char VnsID[sizeof(nsID)];
        char Vvoid_t[sizeof(void_t)];
    };

    nsID*
    ptr_nsID()
    {
        return reinterpret_cast<nsID*>((&((mValue).VnsID)));
    }
    const nsID* const
    constptr_nsID() const
    {
        return reinterpret_cast<const nsID* const>((&((mValue).VnsID)));
    }
    void_t*
    ptr_void_t()
    {
        return reinterpret_cast<void_t*>((&((mValue).Vvoid_t)));
    }
    const void_t* const
    constptr_void_t() const
    {
        return reinterpret_cast<const void_t* const>((&((mValue).Vvoid_t)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__None) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OptionalID() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OptionalID(const nsID& aOther);

    MOZ_IMPLICIT OptionalID(const void_t& aOther);

    MOZ_IMPLICIT OptionalID(const OptionalID& aOther);

    ~OptionalID();

    Type
    type() const
    {
        return mType;
    }

    OptionalID&
    operator=(const nsID& aRhs);

    OptionalID&
    operator=(const void_t& aRhs);

    OptionalID&
    operator=(const OptionalID& aRhs);

    bool
    operator==(const nsID& aRhs) const;

    bool
    operator==(const void_t& aRhs) const;

    bool
    operator==(const OptionalID& aRhs) const;

    nsID&
    get_nsID()
    {
        AssertSanity(TnsID);
        return (*(ptr_nsID()));
    }
    const nsID&
    get_nsID() const
    {
        AssertSanity(TnsID);
        return (*(constptr_nsID()));
    }
    operator nsID&()
    {
        return get_nsID();
    }
    operator const nsID&() const
    {
        return get_nsID();
    }

    void_t&
    get_void_t()
    {
        AssertSanity(Tvoid_t);
        return (*(ptr_void_t()));
    }
    const void_t&
    get_void_t() const
    {
        AssertSanity(Tvoid_t);
        return (*(constptr_void_t()));
    }
    operator void_t&()
    {
        return get_void_t();
    }
    operator const void_t&() const
    {
        return get_void_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ClonedMessageData|
//
namespace mozilla {
namespace dom {
class ClonedMessageData MOZ_FINAL
{
private:
    typedef mozilla::SerializedStructuredCloneBuffer SerializedStructuredCloneBuffer;
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;

public:
    MOZ_IMPLICIT ClonedMessageData();

    MOZ_IMPLICIT ClonedMessageData(
            const SerializedStructuredCloneBuffer& _data,
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild)
    {
        Init();
        Assign(_data, _blobsParent, _blobsChild);
    }

    MOZ_IMPLICIT ClonedMessageData(const ClonedMessageData& _o)
    {
        Init();
        Assign((_o).data(), (_o).blobsParent(), (_o).blobsChild());
    }

    ~ClonedMessageData();

    void
    operator=(const ClonedMessageData& _o)
    {
        Assign((_o).data(), (_o).blobsParent(), (_o).blobsChild());
    }

    bool
    operator==(const ClonedMessageData& _o) const;

    SerializedStructuredCloneBuffer&
    data()
    {
        return data_;
    }
    const SerializedStructuredCloneBuffer&
    data() const
    {
        return data_;
    }

    nsTArray<PBlobParent*>&
    blobsParent()
    {
        return blobsParent_;
    }
    const nsTArray<PBlobParent*>&
    blobsParent() const
    {
        return blobsParent_;
    }

    nsTArray<PBlobChild*>&
    blobsChild()
    {
        return blobsChild_;
    }
    const nsTArray<PBlobChild*>&
    blobsChild() const
    {
        return blobsChild_;
    }

private:
    void
    Init();

    void
    Assign(
            const SerializedStructuredCloneBuffer& _data,
            const nsTArray<PBlobParent*>& _blobsParent,
            const nsTArray<PBlobChild*>& _blobsChild);

    SerializedStructuredCloneBuffer data_;
    nsTArray<PBlobParent*> blobsParent_;
    nsTArray<PBlobChild*> blobsChild_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct NormalBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class NormalBlobConstructorParams MOZ_FINAL
{
private:

public:
    MOZ_IMPLICIT NormalBlobConstructorParams();

    MOZ_IMPLICIT NormalBlobConstructorParams(
            const nsString& _contentType,
            const uint64_t& _length)
    {
        Init();
        Assign(_contentType, _length);
    }

    MOZ_IMPLICIT NormalBlobConstructorParams(const NormalBlobConstructorParams& _o)
    {
        Init();
        Assign((_o).contentType(), (_o).length());
    }

    ~NormalBlobConstructorParams();

    void
    operator=(const NormalBlobConstructorParams& _o)
    {
        Assign((_o).contentType(), (_o).length());
    }

    bool
    operator==(const NormalBlobConstructorParams& _o) const;

    nsString&
    contentType()
    {
        return contentType_;
    }
    const nsString&
    contentType() const
    {
        return contentType_;
    }

    uint64_t&
    length()
    {
        return length_;
    }
    const uint64_t&
    length() const
    {
        return length_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _contentType,
            const uint64_t& _length);

    nsString contentType_;
    uint64_t length_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class FileBlobConstructorParams MOZ_FINAL
{
private:

public:
    MOZ_IMPLICIT FileBlobConstructorParams();

    MOZ_IMPLICIT FileBlobConstructorParams(
            const nsString& _name,
            const nsString& _contentType,
            const uint64_t& _length,
            const uint64_t& _modDate)
    {
        Init();
        Assign(_name, _contentType, _length, _modDate);
    }

    MOZ_IMPLICIT FileBlobConstructorParams(const FileBlobConstructorParams& _o)
    {
        Init();
        Assign((_o).name(), (_o).contentType(), (_o).length(), (_o).modDate());
    }

    ~FileBlobConstructorParams();

    void
    operator=(const FileBlobConstructorParams& _o)
    {
        Assign((_o).name(), (_o).contentType(), (_o).length(), (_o).modDate());
    }

    bool
    operator==(const FileBlobConstructorParams& _o) const;

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    nsString&
    contentType()
    {
        return contentType_;
    }
    const nsString&
    contentType() const
    {
        return contentType_;
    }

    uint64_t&
    length()
    {
        return length_;
    }
    const uint64_t&
    length() const
    {
        return length_;
    }

    uint64_t&
    modDate()
    {
        return modDate_;
    }
    const uint64_t&
    modDate() const
    {
        return modDate_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _name,
            const nsString& _contentType,
            const uint64_t& _length,
            const uint64_t& _modDate);

    nsString name_;
    nsString contentType_;
    uint64_t length_;
    uint64_t modDate_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SlicedBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class SlicedBlobConstructorParams MOZ_FINAL
{
private:
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef mozilla::dom::PBlobChild PBlobChild;

public:
    MOZ_IMPLICIT SlicedBlobConstructorParams();

    MOZ_IMPLICIT SlicedBlobConstructorParams(
            PBlobParent* _sourceParent,
            PBlobChild* _sourceChild,
            const nsID& _id,
            const uint64_t& _begin,
            const uint64_t& _end,
            const nsString& _contentType)
    {
        Init();
        Assign(_sourceParent, _sourceChild, _id, _begin, _end, _contentType);
    }

    MOZ_IMPLICIT SlicedBlobConstructorParams(const SlicedBlobConstructorParams& _o)
    {
        Init();
        Assign(const_cast<PBlobParent*>((_o).sourceParent()), const_cast<PBlobChild*>((_o).sourceChild()), (_o).id(), (_o).begin(), (_o).end(), (_o).contentType());
    }

    ~SlicedBlobConstructorParams();

    void
    operator=(const SlicedBlobConstructorParams& _o)
    {
        Assign(const_cast<PBlobParent*>((_o).sourceParent()), const_cast<PBlobChild*>((_o).sourceChild()), (_o).id(), (_o).begin(), (_o).end(), (_o).contentType());
    }

    bool
    operator==(const SlicedBlobConstructorParams& _o) const;

    PBlobParent*&
    sourceParent()
    {
        return sourceParent_;
    }
    PBlobParent*
    sourceParent() const
    {
        return sourceParent_;
    }

    PBlobChild*&
    sourceChild()
    {
        return sourceChild_;
    }
    PBlobChild*
    sourceChild() const
    {
        return sourceChild_;
    }

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

    uint64_t&
    begin()
    {
        return begin_;
    }
    const uint64_t&
    begin() const
    {
        return begin_;
    }

    uint64_t&
    end()
    {
        return end_;
    }
    const uint64_t&
    end() const
    {
        return end_;
    }

    nsString&
    contentType()
    {
        return contentType_;
    }
    const nsString&
    contentType() const
    {
        return contentType_;
    }

private:
    void
    Init();

    void
    Assign(
            PBlobParent* _sourceParent,
            PBlobChild* _sourceChild,
            const nsID& _id,
            const uint64_t& _begin,
            const uint64_t& _end,
            const nsString& _contentType);

    PBlobParent* sourceParent_;
    PBlobChild* sourceChild_;
    nsID id_;
    uint64_t begin_;
    uint64_t end_;
    nsString contentType_;
};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MysteryBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class MysteryBlobConstructorParams MOZ_FINAL
{
private:

public:
    MOZ_IMPLICIT MysteryBlobConstructorParams()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT MysteryBlobConstructorParams(const MysteryBlobConstructorParams& _o)
    {
        Init();
        Assign();
    }

    ~MysteryBlobConstructorParams();

    void
    operator=(const MysteryBlobConstructorParams& _o)
    {
        Assign();
    }

    bool
    operator==(const MysteryBlobConstructorParams& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct KnownBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class KnownBlobConstructorParams MOZ_FINAL
{
private:

public:
    MOZ_IMPLICIT KnownBlobConstructorParams();

    MOZ_IMPLICIT KnownBlobConstructorParams(const nsID& _id)
    {
        Init();
        Assign(_id);
    }

    MOZ_IMPLICIT KnownBlobConstructorParams(const KnownBlobConstructorParams& _o)
    {
        Init();
        Assign((_o).id());
    }

    ~KnownBlobConstructorParams();

    void
    operator=(const KnownBlobConstructorParams& _o)
    {
        Assign((_o).id());
    }

    bool
    operator==(const KnownBlobConstructorParams& _o) const;

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

private:
    void
    Init();

    void
    Assign(const nsID& _id);

    nsID id_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class NormalBlobConstructorParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class FileBlobConstructorParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class MysteryBlobConstructorParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class SlicedBlobConstructorParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class KnownBlobConstructorParams;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union AnyBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class AnyBlobConstructorParams MOZ_FINAL
{
public:
    enum Type {
        T__None,
        TNormalBlobConstructorParams = 1,
        TFileBlobConstructorParams,
        TMysteryBlobConstructorParams,
        TSlicedBlobConstructorParams,
        TKnownBlobConstructorParams,
        T__Last = TKnownBlobConstructorParams
    };

private:
    typedef mozilla::dom::NormalBlobConstructorParams NormalBlobConstructorParams;
    typedef mozilla::dom::FileBlobConstructorParams FileBlobConstructorParams;
    typedef mozilla::dom::MysteryBlobConstructorParams MysteryBlobConstructorParams;
    typedef mozilla::dom::SlicedBlobConstructorParams SlicedBlobConstructorParams;
    typedef mozilla::dom::KnownBlobConstructorParams KnownBlobConstructorParams;
    typedef NormalBlobConstructorParams NormalBlobConstructorParams__tdef;
    typedef FileBlobConstructorParams FileBlobConstructorParams__tdef;
    typedef MysteryBlobConstructorParams MysteryBlobConstructorParams__tdef;
    typedef SlicedBlobConstructorParams SlicedBlobConstructorParams__tdef;
    typedef KnownBlobConstructorParams KnownBlobConstructorParams__tdef;

    union Value {
        char VNormalBlobConstructorParams[sizeof(NormalBlobConstructorParams)];
        char VFileBlobConstructorParams[sizeof(FileBlobConstructorParams)];
        char VMysteryBlobConstructorParams[sizeof(MysteryBlobConstructorParams)];
        char VSlicedBlobConstructorParams[sizeof(SlicedBlobConstructorParams)];
        char VKnownBlobConstructorParams[sizeof(KnownBlobConstructorParams)];
    };

    NormalBlobConstructorParams*
    ptr_NormalBlobConstructorParams()
    {
        return reinterpret_cast<NormalBlobConstructorParams*>((&((mValue).VNormalBlobConstructorParams)));
    }
    const NormalBlobConstructorParams* const
    constptr_NormalBlobConstructorParams() const
    {
        return reinterpret_cast<const NormalBlobConstructorParams* const>((&((mValue).VNormalBlobConstructorParams)));
    }
    FileBlobConstructorParams*
    ptr_FileBlobConstructorParams()
    {
        return reinterpret_cast<FileBlobConstructorParams*>((&((mValue).VFileBlobConstructorParams)));
    }
    const FileBlobConstructorParams* const
    constptr_FileBlobConstructorParams() const
    {
        return reinterpret_cast<const FileBlobConstructorParams* const>((&((mValue).VFileBlobConstructorParams)));
    }
    MysteryBlobConstructorParams*
    ptr_MysteryBlobConstructorParams()
    {
        return reinterpret_cast<MysteryBlobConstructorParams*>((&((mValue).VMysteryBlobConstructorParams)));
    }
    const MysteryBlobConstructorParams* const
    constptr_MysteryBlobConstructorParams() const
    {
        return reinterpret_cast<const MysteryBlobConstructorParams* const>((&((mValue).VMysteryBlobConstructorParams)));
    }
    SlicedBlobConstructorParams*
    ptr_SlicedBlobConstructorParams()
    {
        return reinterpret_cast<SlicedBlobConstructorParams*>((&((mValue).VSlicedBlobConstructorParams)));
    }
    const SlicedBlobConstructorParams* const
    constptr_SlicedBlobConstructorParams() const
    {
        return reinterpret_cast<const SlicedBlobConstructorParams* const>((&((mValue).VSlicedBlobConstructorParams)));
    }
    KnownBlobConstructorParams*
    ptr_KnownBlobConstructorParams()
    {
        return reinterpret_cast<KnownBlobConstructorParams*>((&((mValue).VKnownBlobConstructorParams)));
    }
    const KnownBlobConstructorParams* const
    constptr_KnownBlobConstructorParams() const
    {
        return reinterpret_cast<const KnownBlobConstructorParams* const>((&((mValue).VKnownBlobConstructorParams)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__None) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT AnyBlobConstructorParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT AnyBlobConstructorParams(const NormalBlobConstructorParams& aOther);

    MOZ_IMPLICIT AnyBlobConstructorParams(const FileBlobConstructorParams& aOther);

    MOZ_IMPLICIT AnyBlobConstructorParams(const MysteryBlobConstructorParams& aOther);

    MOZ_IMPLICIT AnyBlobConstructorParams(const SlicedBlobConstructorParams& aOther);

    MOZ_IMPLICIT AnyBlobConstructorParams(const KnownBlobConstructorParams& aOther);

    MOZ_IMPLICIT AnyBlobConstructorParams(const AnyBlobConstructorParams& aOther);

    ~AnyBlobConstructorParams();

    Type
    type() const
    {
        return mType;
    }

    AnyBlobConstructorParams&
    operator=(const NormalBlobConstructorParams& aRhs);

    AnyBlobConstructorParams&
    operator=(const FileBlobConstructorParams& aRhs);

    AnyBlobConstructorParams&
    operator=(const MysteryBlobConstructorParams& aRhs);

    AnyBlobConstructorParams&
    operator=(const SlicedBlobConstructorParams& aRhs);

    AnyBlobConstructorParams&
    operator=(const KnownBlobConstructorParams& aRhs);

    AnyBlobConstructorParams&
    operator=(const AnyBlobConstructorParams& aRhs);

    bool
    operator==(const NormalBlobConstructorParams& aRhs) const;

    bool
    operator==(const FileBlobConstructorParams& aRhs) const;

    bool
    operator==(const MysteryBlobConstructorParams& aRhs) const;

    bool
    operator==(const SlicedBlobConstructorParams& aRhs) const;

    bool
    operator==(const KnownBlobConstructorParams& aRhs) const;

    bool
    operator==(const AnyBlobConstructorParams& aRhs) const;

    NormalBlobConstructorParams&
    get_NormalBlobConstructorParams()
    {
        AssertSanity(TNormalBlobConstructorParams);
        return (*(ptr_NormalBlobConstructorParams()));
    }
    const NormalBlobConstructorParams&
    get_NormalBlobConstructorParams() const
    {
        AssertSanity(TNormalBlobConstructorParams);
        return (*(constptr_NormalBlobConstructorParams()));
    }
    operator NormalBlobConstructorParams&()
    {
        return get_NormalBlobConstructorParams();
    }
    operator const NormalBlobConstructorParams&() const
    {
        return get_NormalBlobConstructorParams();
    }

    FileBlobConstructorParams&
    get_FileBlobConstructorParams()
    {
        AssertSanity(TFileBlobConstructorParams);
        return (*(ptr_FileBlobConstructorParams()));
    }
    const FileBlobConstructorParams&
    get_FileBlobConstructorParams() const
    {
        AssertSanity(TFileBlobConstructorParams);
        return (*(constptr_FileBlobConstructorParams()));
    }
    operator FileBlobConstructorParams&()
    {
        return get_FileBlobConstructorParams();
    }
    operator const FileBlobConstructorParams&() const
    {
        return get_FileBlobConstructorParams();
    }

    MysteryBlobConstructorParams&
    get_MysteryBlobConstructorParams()
    {
        AssertSanity(TMysteryBlobConstructorParams);
        return (*(ptr_MysteryBlobConstructorParams()));
    }
    const MysteryBlobConstructorParams&
    get_MysteryBlobConstructorParams() const
    {
        AssertSanity(TMysteryBlobConstructorParams);
        return (*(constptr_MysteryBlobConstructorParams()));
    }
    operator MysteryBlobConstructorParams&()
    {
        return get_MysteryBlobConstructorParams();
    }
    operator const MysteryBlobConstructorParams&() const
    {
        return get_MysteryBlobConstructorParams();
    }

    SlicedBlobConstructorParams&
    get_SlicedBlobConstructorParams()
    {
        AssertSanity(TSlicedBlobConstructorParams);
        return (*(ptr_SlicedBlobConstructorParams()));
    }
    const SlicedBlobConstructorParams&
    get_SlicedBlobConstructorParams() const
    {
        AssertSanity(TSlicedBlobConstructorParams);
        return (*(constptr_SlicedBlobConstructorParams()));
    }
    operator SlicedBlobConstructorParams&()
    {
        return get_SlicedBlobConstructorParams();
    }
    operator const SlicedBlobConstructorParams&() const
    {
        return get_SlicedBlobConstructorParams();
    }

    KnownBlobConstructorParams&
    get_KnownBlobConstructorParams()
    {
        AssertSanity(TKnownBlobConstructorParams);
        return (*(ptr_KnownBlobConstructorParams()));
    }
    const KnownBlobConstructorParams&
    get_KnownBlobConstructorParams() const
    {
        AssertSanity(TKnownBlobConstructorParams);
        return (*(constptr_KnownBlobConstructorParams()));
    }
    operator KnownBlobConstructorParams&()
    {
        return get_KnownBlobConstructorParams();
    }
    operator const KnownBlobConstructorParams&() const
    {
        return get_KnownBlobConstructorParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class AnyBlobConstructorParams;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ChildBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class ChildBlobConstructorParams MOZ_FINAL
{
private:
    typedef mozilla::dom::AnyBlobConstructorParams AnyBlobConstructorParams;

public:
    MOZ_IMPLICIT ChildBlobConstructorParams();

    MOZ_IMPLICIT ChildBlobConstructorParams(
            const nsID& _id,
            const AnyBlobConstructorParams& _blobParams)
    {
        Init();
        Assign(_id, _blobParams);
    }

    MOZ_IMPLICIT ChildBlobConstructorParams(const ChildBlobConstructorParams& _o)
    {
        Init();
        Assign((_o).id(), (_o).blobParams());
    }

    ~ChildBlobConstructorParams();

    void
    operator=(const ChildBlobConstructorParams& _o)
    {
        Assign((_o).id(), (_o).blobParams());
    }

    bool
    operator==(const ChildBlobConstructorParams& _o) const;

    nsID&
    id()
    {
        return id_;
    }
    const nsID&
    id() const
    {
        return id_;
    }

    AnyBlobConstructorParams&
    blobParams()
    {
        return blobParams_;
    }
    const AnyBlobConstructorParams&
    blobParams() const
    {
        return blobParams_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsID& _id,
            const AnyBlobConstructorParams& _blobParams);

    nsID id_;
    AnyBlobConstructorParams blobParams_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class AnyBlobConstructorParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalInputStreamParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ParentBlobConstructorParams|
//
namespace mozilla {
namespace dom {
class ParentBlobConstructorParams MOZ_FINAL
{
private:
    typedef mozilla::dom::AnyBlobConstructorParams AnyBlobConstructorParams;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;

public:
    MOZ_IMPLICIT ParentBlobConstructorParams();

    MOZ_IMPLICIT ParentBlobConstructorParams(
            const AnyBlobConstructorParams& _blobParams,
            const OptionalInputStreamParams& _optionalInputStreamParams)
    {
        Init();
        Assign(_blobParams, _optionalInputStreamParams);
    }

    MOZ_IMPLICIT ParentBlobConstructorParams(const ParentBlobConstructorParams& _o)
    {
        Init();
        Assign((_o).blobParams(), (_o).optionalInputStreamParams());
    }

    ~ParentBlobConstructorParams();

    void
    operator=(const ParentBlobConstructorParams& _o)
    {
        Assign((_o).blobParams(), (_o).optionalInputStreamParams());
    }

    bool
    operator==(const ParentBlobConstructorParams& _o) const;

    AnyBlobConstructorParams&
    blobParams()
    {
        return blobParams_;
    }
    const AnyBlobConstructorParams&
    blobParams() const
    {
        return blobParams_;
    }

    OptionalInputStreamParams&
    optionalInputStreamParams()
    {
        return optionalInputStreamParams_;
    }
    const OptionalInputStreamParams&
    optionalInputStreamParams() const
    {
        return optionalInputStreamParams_;
    }

private:
    void
    Init();

    void
    Assign(
            const AnyBlobConstructorParams& _blobParams,
            const OptionalInputStreamParams& _optionalInputStreamParams);

    AnyBlobConstructorParams blobParams_;
    OptionalInputStreamParams optionalInputStreamParams_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class ChildBlobConstructorParams;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class ParentBlobConstructorParams;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union BlobConstructorParams|
//
namespace mozilla {
namespace dom {
class BlobConstructorParams MOZ_FINAL
{
public:
    enum Type {
        T__None,
        TChildBlobConstructorParams = 1,
        TParentBlobConstructorParams,
        T__Last = TParentBlobConstructorParams
    };

private:
    typedef mozilla::dom::ChildBlobConstructorParams ChildBlobConstructorParams;
    typedef mozilla::dom::ParentBlobConstructorParams ParentBlobConstructorParams;
    typedef ChildBlobConstructorParams ChildBlobConstructorParams__tdef;
    typedef ParentBlobConstructorParams ParentBlobConstructorParams__tdef;

    union Value {
        char VChildBlobConstructorParams[sizeof(ChildBlobConstructorParams)];
        char VParentBlobConstructorParams[sizeof(ParentBlobConstructorParams)];
    };

    ChildBlobConstructorParams*
    ptr_ChildBlobConstructorParams()
    {
        return reinterpret_cast<ChildBlobConstructorParams*>((&((mValue).VChildBlobConstructorParams)));
    }
    const ChildBlobConstructorParams* const
    constptr_ChildBlobConstructorParams() const
    {
        return reinterpret_cast<const ChildBlobConstructorParams* const>((&((mValue).VChildBlobConstructorParams)));
    }
    ParentBlobConstructorParams*
    ptr_ParentBlobConstructorParams()
    {
        return reinterpret_cast<ParentBlobConstructorParams*>((&((mValue).VParentBlobConstructorParams)));
    }
    const ParentBlobConstructorParams* const
    constptr_ParentBlobConstructorParams() const
    {
        return reinterpret_cast<const ParentBlobConstructorParams* const>((&((mValue).VParentBlobConstructorParams)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__None) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT BlobConstructorParams() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT BlobConstructorParams(const ChildBlobConstructorParams& aOther);

    MOZ_IMPLICIT BlobConstructorParams(const ParentBlobConstructorParams& aOther);

    MOZ_IMPLICIT BlobConstructorParams(const BlobConstructorParams& aOther);

    ~BlobConstructorParams();

    Type
    type() const
    {
        return mType;
    }

    BlobConstructorParams&
    operator=(const ChildBlobConstructorParams& aRhs);

    BlobConstructorParams&
    operator=(const ParentBlobConstructorParams& aRhs);

    BlobConstructorParams&
    operator=(const BlobConstructorParams& aRhs);

    bool
    operator==(const ChildBlobConstructorParams& aRhs) const;

    bool
    operator==(const ParentBlobConstructorParams& aRhs) const;

    bool
    operator==(const BlobConstructorParams& aRhs) const;

    ChildBlobConstructorParams&
    get_ChildBlobConstructorParams()
    {
        AssertSanity(TChildBlobConstructorParams);
        return (*(ptr_ChildBlobConstructorParams()));
    }
    const ChildBlobConstructorParams&
    get_ChildBlobConstructorParams() const
    {
        AssertSanity(TChildBlobConstructorParams);
        return (*(constptr_ChildBlobConstructorParams()));
    }
    operator ChildBlobConstructorParams&()
    {
        return get_ChildBlobConstructorParams();
    }
    operator const ChildBlobConstructorParams&() const
    {
        return get_ChildBlobConstructorParams();
    }

    ParentBlobConstructorParams&
    get_ParentBlobConstructorParams()
    {
        AssertSanity(TParentBlobConstructorParams);
        return (*(ptr_ParentBlobConstructorParams()));
    }
    const ParentBlobConstructorParams&
    get_ParentBlobConstructorParams() const
    {
        AssertSanity(TParentBlobConstructorParams);
        return (*(constptr_ParentBlobConstructorParams()));
    }
    operator ParentBlobConstructorParams&()
    {
        return get_ParentBlobConstructorParams();
    }
    operator const ParentBlobConstructorParams&() const
    {
        return get_ParentBlobConstructorParams();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

#endif // ifndef DOMTypes_h
