//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFMRadioChild_h
#define PFMRadioChild_h

#include "mozilla/dom/PFMRadio.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/HalTypes.h"

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PFMRadioRequestChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PFMRadioRequestChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {


class /*NS_ABSTRACT_CLASS*/ PFMRadioChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::dom::PContentChild;

    friend class mozilla::dom::PFMRadioRequestChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::dom::CancelSeekRequestArgs CancelSeekRequestArgs;
    typedef mozilla::dom::DisableRDSArgs DisableRDSArgs;
    typedef mozilla::dom::DisableRequestArgs DisableRequestArgs;
    typedef mozilla::dom::EnableRDSArgs EnableRDSArgs;
    typedef mozilla::dom::EnableRequestArgs EnableRequestArgs;
    typedef mozilla::dom::FMRadioRequestArgs FMRadioRequestArgs;
    typedef mozilla::hal::FMRadioSeekDirection FMRadioSeekDirection;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::dom::SeekRequestArgs SeekRequestArgs;
    typedef mozilla::dom::SetFrequencyRequestArgs SetFrequencyRequestArgs;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::dom::StatusInfo StatusInfo;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PFMRadioRequestChild PFMRadioRequestChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PFMRadio::State State;

    virtual bool
    RecvNotifyFrequencyChanged(const double& frequency) = 0;
    virtual bool
    RecvNotifyEnabledChanged(
            const bool& enabled,
            const double& frequency) = 0;
    virtual bool
    RecvNotifyRDSEnabledChanged(const bool& enabled) = 0;
    virtual bool
    RecvNotifyPIChanged(
            const bool& valid,
            const uint16_t& code) = 0;
    virtual bool
    RecvNotifyPTYChanged(
            const bool& valid,
            const uint8_t& pty) = 0;
    virtual bool
    RecvNotifyPSChanged(const nsString& psname) = 0;
    virtual bool
    RecvNotifyRadiotextChanged(const nsString& radiotext) = 0;
    virtual bool
    RecvNotifyNewRDSGroup(const uint64_t& data) = 0;
    virtual bool
    Recv__delete__();
    virtual PFMRadioRequestChild*
    AllocPFMRadioRequestChild(const FMRadioRequestArgs& requestType) = 0;
    virtual bool
    DeallocPFMRadioRequestChild(PFMRadioRequestChild* aActor) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PFMRadioChild();

    virtual ~PFMRadioChild();

    PContentChild*
    Manager() const;

    void
    ManagedPFMRadioRequestChild(nsTArray<PFMRadioRequestChild*>& aArr) const;
    const nsTArray<PFMRadioRequestChild*>&
    ManagedPFMRadioRequestChild() const;

    PFMRadio::State
    state();

    bool
    SendGetStatusInfo(StatusInfo* info);

    PFMRadioRequestChild*
    SendPFMRadioRequestConstructor(const FMRadioRequestArgs& requestType);

    PFMRadioRequestChild*
    SendPFMRadioRequestConstructor(
            PFMRadioRequestChild* actor,
            const FMRadioRequestArgs& requestType);

    bool
    SendEnableAudio(const bool& audioEnabled);

    bool
    SendSetRDSGroupMask(const uint32_t& groupMask);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PFMRadioRequestChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PFMRadioRequestChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const EnableRequestArgs& __v,
            Message* __msg);

    bool
    Read(
            EnableRequestArgs* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const FMRadioRequestArgs& __v,
            Message* __msg);

    bool
    Read(
            FMRadioRequestArgs* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const DisableRDSArgs& __v,
            Message* __msg);

    bool
    Read(
            DisableRDSArgs* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const EnableRDSArgs& __v,
            Message* __msg);

    bool
    Read(
            EnableRDSArgs* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SetFrequencyRequestArgs& __v,
            Message* __msg);

    bool
    Read(
            SetFrequencyRequestArgs* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const CancelSeekRequestArgs& __v,
            Message* __msg);

    bool
    Read(
            CancelSeekRequestArgs* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PFMRadioChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PFMRadioChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const DisableRequestArgs& __v,
            Message* __msg);

    bool
    Read(
            DisableRequestArgs* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SeekRequestArgs& __v,
            Message* __msg);

    bool
    Read(
            SeekRequestArgs* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StatusInfo& __v,
            Message* __msg);

    bool
    Read(
            StatusInfo* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
    // Sorted by pointer value
    nsTArray<PFMRadioRequestChild*> mManagedPFMRadioRequestChild;
};


} // namespace dom
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class FMRadioChild :
    public PFMRadioChild
{
    virtual bool
    RecvNotifyFrequencyChanged(const double& frequency);

    virtual bool
    RecvNotifyEnabledChanged(
            const bool& enabled,
            const double& frequency);

    virtual bool
    RecvNotifyRDSEnabledChanged(const bool& enabled);

    virtual bool
    RecvNotifyPIChanged(
            const bool& valid,
            const uint16_t& code);

    virtual bool
    RecvNotifyPTYChanged(
            const bool& valid,
            const uint8_t& pty);

    virtual bool
    RecvNotifyPSChanged(const nsString& psname);

    virtual bool
    RecvNotifyRadiotextChanged(const nsString& radiotext);

    virtual bool
    RecvNotifyNewRDSGroup(const uint64_t& data);

    virtual PFMRadioRequestChild*
    AllocPFMRadioRequestChild(const FMRadioRequestArgs& requestType);

    virtual bool
    DeallocPFMRadioRequestChild(PFMRadioRequestChild* aActor);

    MOZ_IMPLICIT FMRadioChild();
    virtual ~FMRadioChild();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
bool
FMRadioChild::RecvNotifyFrequencyChanged(const double& frequency)
{
    return false;
}

bool
FMRadioChild::RecvNotifyEnabledChanged(
        const bool& enabled,
        const double& frequency)
{
    return false;
}

bool
FMRadioChild::RecvNotifyRDSEnabledChanged(const bool& enabled)
{
    return false;
}

bool
FMRadioChild::RecvNotifyPIChanged(
        const bool& valid,
        const uint16_t& code)
{
    return false;
}

bool
FMRadioChild::RecvNotifyPTYChanged(
        const bool& valid,
        const uint8_t& pty)
{
    return false;
}

bool
FMRadioChild::RecvNotifyPSChanged(const nsString& psname)
{
    return false;
}

bool
FMRadioChild::RecvNotifyRadiotextChanged(const nsString& radiotext)
{
    return false;
}

bool
FMRadioChild::RecvNotifyNewRDSGroup(const uint64_t& data)
{
    return false;
}

PFMRadioRequestChild*
FMRadioChild::AllocPFMRadioRequestChild(const FMRadioRequestArgs& requestType)
{
    return 0;
}

bool
FMRadioChild::DeallocPFMRadioRequestChild(PFMRadioRequestChild* aActor)
{
    return false;
}

MOZ_IMPLICIT FMRadioChild::FMRadioChild()
{
    MOZ_COUNT_CTOR(FMRadioChild);
}

MOZ_IMPLICIT FMRadioChild::~FMRadioChild()
{
    MOZ_COUNT_DTOR(FMRadioChild);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PFMRadioChild_h
