//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PScreenManager_h
#define PScreenManager_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"

// Headers for typedefs
#include "nsRect.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ScreenDetails|
//
namespace mozilla {
namespace dom {
class ScreenDetails MOZ_FINAL
{
private:

public:
    MOZ_IMPLICIT ScreenDetails();

    MOZ_IMPLICIT ScreenDetails(
            const uint32_t& _id,
            const nsIntRect& _rect,
            const nsIntRect& _rectDisplayPix,
            const nsIntRect& _availRect,
            const nsIntRect& _availRectDisplayPix,
            const int32_t& _pixelDepth,
            const int32_t& _colorDepth,
            const double& _contentsScaleFactor)
    {
        Init();
        Assign(_id, _rect, _rectDisplayPix, _availRect, _availRectDisplayPix, _pixelDepth, _colorDepth, _contentsScaleFactor);
    }

    MOZ_IMPLICIT ScreenDetails(const ScreenDetails& _o)
    {
        Init();
        Assign((_o).id(), (_o).rect(), (_o).rectDisplayPix(), (_o).availRect(), (_o).availRectDisplayPix(), (_o).pixelDepth(), (_o).colorDepth(), (_o).contentsScaleFactor());
    }

    ~ScreenDetails();

    void
    operator=(const ScreenDetails& _o)
    {
        Assign((_o).id(), (_o).rect(), (_o).rectDisplayPix(), (_o).availRect(), (_o).availRectDisplayPix(), (_o).pixelDepth(), (_o).colorDepth(), (_o).contentsScaleFactor());
    }

    bool
    operator==(const ScreenDetails& _o) const;

    uint32_t&
    id()
    {
        return id_;
    }
    const uint32_t&
    id() const
    {
        return id_;
    }

    nsIntRect&
    rect()
    {
        return rect_;
    }
    const nsIntRect&
    rect() const
    {
        return rect_;
    }

    nsIntRect&
    rectDisplayPix()
    {
        return rectDisplayPix_;
    }
    const nsIntRect&
    rectDisplayPix() const
    {
        return rectDisplayPix_;
    }

    nsIntRect&
    availRect()
    {
        return availRect_;
    }
    const nsIntRect&
    availRect() const
    {
        return availRect_;
    }

    nsIntRect&
    availRectDisplayPix()
    {
        return availRectDisplayPix_;
    }
    const nsIntRect&
    availRectDisplayPix() const
    {
        return availRectDisplayPix_;
    }

    int32_t&
    pixelDepth()
    {
        return pixelDepth_;
    }
    const int32_t&
    pixelDepth() const
    {
        return pixelDepth_;
    }

    int32_t&
    colorDepth()
    {
        return colorDepth_;
    }
    const int32_t&
    colorDepth() const
    {
        return colorDepth_;
    }

    double&
    contentsScaleFactor()
    {
        return contentsScaleFactor_;
    }
    const double&
    contentsScaleFactor() const
    {
        return contentsScaleFactor_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _id,
            const nsIntRect& _rect,
            const nsIntRect& _rectDisplayPix,
            const nsIntRect& _availRect,
            const nsIntRect& _availRectDisplayPix,
            const int32_t& _pixelDepth,
            const int32_t& _colorDepth,
            const double& _contentsScaleFactor);

    uint32_t id_;
    nsIntRect rect_;
    nsIntRect rectDisplayPix_;
    nsIntRect availRect_;
    nsIntRect availRectDisplayPix_;
    int32_t pixelDepth_;
    int32_t colorDepth_;
    double contentsScaleFactor_;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PScreenManagerChild and PScreenManagerParent
//
namespace mozilla {
namespace dom {
namespace PScreenManager {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PScreenManagerStart = PScreenManagerMsgStart << 16,
    Msg_Refresh__ID,
    Reply_Refresh__ID,
    Msg_ScreenRefresh__ID,
    Reply_ScreenRefresh__ID,
    Msg_GetPrimaryScreen__ID,
    Reply_GetPrimaryScreen__ID,
    Msg_ScreenForRect__ID,
    Reply_ScreenForRect__ID,
    Msg_ScreenForBrowser__ID,
    Reply_ScreenForBrowser__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    PScreenManagerEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_Refresh :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Refresh__ID
    };
    MOZ_IMPLICIT Msg_Refresh() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PScreenManager::Msg_Refresh")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Refresh(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply_Refresh :
    public IPC::Message
{
public:
    enum {
        ID = Reply_Refresh__ID
    };
    MOZ_IMPLICIT Reply_Refresh() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PScreenManager::Reply_Refresh")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_Refresh(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_ScreenRefresh :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ScreenRefresh__ID
    };
    MOZ_IMPLICIT Msg_ScreenRefresh() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PScreenManager::Msg_ScreenRefresh")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ScreenRefresh(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply_ScreenRefresh :
    public IPC::Message
{
public:
    enum {
        ID = Reply_ScreenRefresh__ID
    };
    MOZ_IMPLICIT Reply_ScreenRefresh() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PScreenManager::Reply_ScreenRefresh")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_ScreenRefresh(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_GetPrimaryScreen :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetPrimaryScreen__ID
    };
    MOZ_IMPLICIT Msg_GetPrimaryScreen() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PScreenManager::Msg_GetPrimaryScreen")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetPrimaryScreen(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply_GetPrimaryScreen :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetPrimaryScreen__ID
    };
    MOZ_IMPLICIT Reply_GetPrimaryScreen() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PScreenManager::Reply_GetPrimaryScreen")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetPrimaryScreen(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_ScreenForRect :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ScreenForRect__ID
    };
    MOZ_IMPLICIT Msg_ScreenForRect() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PScreenManager::Msg_ScreenForRect")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ScreenForRect(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply_ScreenForRect :
    public IPC::Message
{
public:
    enum {
        ID = Reply_ScreenForRect__ID
    };
    MOZ_IMPLICIT Reply_ScreenForRect() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PScreenManager::Reply_ScreenForRect")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_ScreenForRect(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_ScreenForBrowser :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ScreenForBrowser__ID
    };
    MOZ_IMPLICIT Msg_ScreenForBrowser() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PScreenManager::Msg_ScreenForBrowser")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ScreenForBrowser(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply_ScreenForBrowser :
    public IPC::Message
{
public:
    enum {
        ID = Reply_ScreenForBrowser__ID
    };
    MOZ_IMPLICIT Reply_ScreenForBrowser() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PScreenManager::Reply_ScreenForBrowser")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_ScreenForBrowser(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PScreenManager::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PScreenManager::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};



} // namespace PScreenManager
} // namespace dom
} // namespace mozilla

#endif // ifndef PScreenManager_h
