//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PSpeechSynthesis_h
#define PSpeechSynthesis_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RemoteVoice|
//
namespace mozilla {
namespace dom {
class RemoteVoice MOZ_FINAL
{
private:

public:
    MOZ_IMPLICIT RemoteVoice();

    MOZ_IMPLICIT RemoteVoice(
            const nsString& _voiceURI,
            const nsString& _name,
            const nsString& _lang,
            const bool& _localService)
    {
        Init();
        Assign(_voiceURI, _name, _lang, _localService);
    }

    MOZ_IMPLICIT RemoteVoice(const RemoteVoice& _o)
    {
        Init();
        Assign((_o).voiceURI(), (_o).name(), (_o).lang(), (_o).localService());
    }

    ~RemoteVoice();

    void
    operator=(const RemoteVoice& _o)
    {
        Assign((_o).voiceURI(), (_o).name(), (_o).lang(), (_o).localService());
    }

    bool
    operator==(const RemoteVoice& _o) const;

    nsString&
    voiceURI()
    {
        return voiceURI_;
    }
    const nsString&
    voiceURI() const
    {
        return voiceURI_;
    }

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    nsString&
    lang()
    {
        return lang_;
    }
    const nsString&
    lang() const
    {
        return lang_;
    }

    bool&
    localService()
    {
        return localService_;
    }
    const bool&
    localService() const
    {
        return localService_;
    }

private:
    void
    Init();

    void
    Assign(
            const nsString& _voiceURI,
            const nsString& _name,
            const nsString& _lang,
            const bool& _localService);

    nsString voiceURI_;
    nsString name_;
    nsString lang_;
    bool localService_;
};
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PSpeechSynthesisChild and PSpeechSynthesisParent
//
namespace mozilla {
namespace dom {
namespace PSpeechSynthesis {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PSpeechSynthesisStart = PSpeechSynthesisMsgStart << 16,
    Msg_VoiceAdded__ID,
    Msg_VoiceRemoved__ID,
    Msg_SetDefaultVoice__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_PSpeechSynthesisRequestConstructor__ID,
    Reply_PSpeechSynthesisRequestConstructor__ID,
    Msg_ReadVoiceList__ID,
    Reply_ReadVoiceList__ID,
    PSpeechSynthesisEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_VoiceAdded :
    public IPC::Message
{
public:
    enum {
        ID = Msg_VoiceAdded__ID
    };
    MOZ_IMPLICIT Msg_VoiceAdded() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg_VoiceAdded")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_VoiceAdded(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_VoiceRemoved :
    public IPC::Message
{
public:
    enum {
        ID = Msg_VoiceRemoved__ID
    };
    MOZ_IMPLICIT Msg_VoiceRemoved() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg_VoiceRemoved")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_VoiceRemoved(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_SetDefaultVoice :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetDefaultVoice__ID
    };
    MOZ_IMPLICIT Msg_SetDefaultVoice() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg_SetDefaultVoice")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetDefaultVoice(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_PSpeechSynthesisRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PSpeechSynthesisRequestConstructor__ID
    };
    MOZ_IMPLICIT Msg_PSpeechSynthesisRequestConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg_PSpeechSynthesisRequestConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_PSpeechSynthesisRequestConstructor(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply_PSpeechSynthesisRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PSpeechSynthesisRequestConstructor__ID
    };
    MOZ_IMPLICIT Reply_PSpeechSynthesisRequestConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Reply_PSpeechSynthesisRequestConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_PSpeechSynthesisRequestConstructor(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_ReadVoiceList :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ReadVoiceList__ID
    };
    MOZ_IMPLICIT Msg_ReadVoiceList() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Msg_ReadVoiceList")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ReadVoiceList(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply_ReadVoiceList :
    public IPC::Message
{
public:
    enum {
        ID = Reply_ReadVoiceList__ID
    };
    MOZ_IMPLICIT Reply_ReadVoiceList() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PSpeechSynthesis::Reply_ReadVoiceList")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_ReadVoiceList(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};



} // namespace PSpeechSynthesis
} // namespace dom
} // namespace mozilla

#endif // ifndef PSpeechSynthesis_h
