//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PTelephony_h
#define PTelephony_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/dom/telephony/TelephonyTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct EnumerateCallsRequest|
//
namespace mozilla {
namespace dom {
namespace telephony {
class EnumerateCallsRequest MOZ_FINAL
{
private:

public:
    MOZ_IMPLICIT EnumerateCallsRequest()
    {
        Init();
        Assign();
    }

    MOZ_IMPLICIT EnumerateCallsRequest(const EnumerateCallsRequest& _o)
    {
        Init();
        Assign();
    }

    ~EnumerateCallsRequest();

    void
    operator=(const EnumerateCallsRequest& _o)
    {
        Assign();
    }

    bool
    operator==(const EnumerateCallsRequest& _o) const;

private:
    void
    Init();

    void
    Assign();

};
} // namespace telephony
} // namespace dom
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DialRequest|
//
namespace mozilla {
namespace dom {
namespace telephony {
class DialRequest MOZ_FINAL
{
private:

public:
    MOZ_IMPLICIT DialRequest();

    MOZ_IMPLICIT DialRequest(
            const uint32_t& _clientId,
            const nsString& _number,
            const bool& _isEmergency)
    {
        Init();
        Assign(_clientId, _number, _isEmergency);
    }

    MOZ_IMPLICIT DialRequest(const DialRequest& _o)
    {
        Init();
        Assign((_o).clientId(), (_o).number(), (_o).isEmergency());
    }

    ~DialRequest();

    void
    operator=(const DialRequest& _o)
    {
        Assign((_o).clientId(), (_o).number(), (_o).isEmergency());
    }

    bool
    operator==(const DialRequest& _o) const;

    uint32_t&
    clientId()
    {
        return clientId_;
    }
    const uint32_t&
    clientId() const
    {
        return clientId_;
    }

    nsString&
    number()
    {
        return number_;
    }
    const nsString&
    number() const
    {
        return number_;
    }

    bool&
    isEmergency()
    {
        return isEmergency_;
    }
    const bool&
    isEmergency() const
    {
        return isEmergency_;
    }

private:
    void
    Init();

    void
    Assign(
            const uint32_t& _clientId,
            const nsString& _number,
            const bool& _isEmergency);

    uint32_t clientId_;
    nsString number_;
    bool isEmergency_;
};
} // namespace telephony
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
namespace telephony {
class EnumerateCallsRequest;
} // namespace telephony
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
namespace telephony {
class DialRequest;
} // namespace telephony
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union IPCTelephonyRequest|
//
namespace mozilla {
namespace dom {
namespace telephony {
class IPCTelephonyRequest MOZ_FINAL
{
public:
    enum Type {
        T__None,
        TEnumerateCallsRequest = 1,
        TDialRequest,
        T__Last = TDialRequest
    };

private:
    typedef mozilla::dom::telephony::EnumerateCallsRequest EnumerateCallsRequest;
    typedef mozilla::dom::telephony::DialRequest DialRequest;
    typedef EnumerateCallsRequest EnumerateCallsRequest__tdef;
    typedef DialRequest DialRequest__tdef;

    union Value {
        char VEnumerateCallsRequest[sizeof(EnumerateCallsRequest)];
        char VDialRequest[sizeof(DialRequest)];
    };

    EnumerateCallsRequest*
    ptr_EnumerateCallsRequest()
    {
        return reinterpret_cast<EnumerateCallsRequest*>((&((mValue).VEnumerateCallsRequest)));
    }
    const EnumerateCallsRequest* const
    constptr_EnumerateCallsRequest() const
    {
        return reinterpret_cast<const EnumerateCallsRequest* const>((&((mValue).VEnumerateCallsRequest)));
    }
    DialRequest*
    ptr_DialRequest()
    {
        return reinterpret_cast<DialRequest*>((&((mValue).VDialRequest)));
    }
    const DialRequest* const
    constptr_DialRequest() const
    {
        return reinterpret_cast<const DialRequest* const>((&((mValue).VDialRequest)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__None) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT IPCTelephonyRequest() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT IPCTelephonyRequest(const EnumerateCallsRequest& aOther);

    MOZ_IMPLICIT IPCTelephonyRequest(const DialRequest& aOther);

    MOZ_IMPLICIT IPCTelephonyRequest(const IPCTelephonyRequest& aOther);

    ~IPCTelephonyRequest();

    Type
    type() const
    {
        return mType;
    }

    IPCTelephonyRequest&
    operator=(const EnumerateCallsRequest& aRhs);

    IPCTelephonyRequest&
    operator=(const DialRequest& aRhs);

    IPCTelephonyRequest&
    operator=(const IPCTelephonyRequest& aRhs);

    bool
    operator==(const EnumerateCallsRequest& aRhs) const;

    bool
    operator==(const DialRequest& aRhs) const;

    bool
    operator==(const IPCTelephonyRequest& aRhs) const;

    EnumerateCallsRequest&
    get_EnumerateCallsRequest()
    {
        AssertSanity(TEnumerateCallsRequest);
        return (*(ptr_EnumerateCallsRequest()));
    }
    const EnumerateCallsRequest&
    get_EnumerateCallsRequest() const
    {
        AssertSanity(TEnumerateCallsRequest);
        return (*(constptr_EnumerateCallsRequest()));
    }
    operator EnumerateCallsRequest&()
    {
        return get_EnumerateCallsRequest();
    }
    operator const EnumerateCallsRequest&() const
    {
        return get_EnumerateCallsRequest();
    }

    DialRequest&
    get_DialRequest()
    {
        AssertSanity(TDialRequest);
        return (*(ptr_DialRequest()));
    }
    const DialRequest&
    get_DialRequest() const
    {
        AssertSanity(TDialRequest);
        return (*(constptr_DialRequest()));
    }
    operator DialRequest&()
    {
        return get_DialRequest();
    }
    operator const DialRequest&() const
    {
        return get_DialRequest();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace telephony
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PTelephonyChild and PTelephonyParent
//
namespace mozilla {
namespace dom {
namespace telephony {
namespace PTelephony {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PTelephonyStart = PTelephonyMsgStart << 16,
    Msg_NotifyCallError__ID,
    Msg_NotifyCallStateChanged__ID,
    Msg_NotifyCdmaCallWaiting__ID,
    Msg_NotifyConferenceCallStateChanged__ID,
    Msg_NotifyConferenceError__ID,
    Msg_NotifySupplementaryService__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_PTelephonyRequestConstructor__ID,
    Reply_PTelephonyRequestConstructor__ID,
    Msg_RegisterListener__ID,
    Msg_UnregisterListener__ID,
    Msg_HangUpCall__ID,
    Msg_AnswerCall__ID,
    Msg_RejectCall__ID,
    Msg_HoldCall__ID,
    Msg_ResumeCall__ID,
    Msg_ConferenceCall__ID,
    Msg_SeparateCall__ID,
    Msg_HoldConference__ID,
    Msg_ResumeConference__ID,
    Msg_StartTone__ID,
    Msg_StopTone__ID,
    Msg_GetMicrophoneMuted__ID,
    Reply_GetMicrophoneMuted__ID,
    Msg_SetMicrophoneMuted__ID,
    Msg_GetSpeakerEnabled__ID,
    Reply_GetSpeakerEnabled__ID,
    Msg_SetSpeakerEnabled__ID,
    PTelephonyEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_NotifyCallError :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyCallError__ID
    };
    MOZ_IMPLICIT Msg_NotifyCallError() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_NotifyCallError")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyCallError(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_NotifyCallStateChanged :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyCallStateChanged__ID
    };
    MOZ_IMPLICIT Msg_NotifyCallStateChanged() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_NotifyCallStateChanged")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyCallStateChanged(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_NotifyCdmaCallWaiting :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyCdmaCallWaiting__ID
    };
    MOZ_IMPLICIT Msg_NotifyCdmaCallWaiting() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_NotifyCdmaCallWaiting")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyCdmaCallWaiting(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_NotifyConferenceCallStateChanged :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyConferenceCallStateChanged__ID
    };
    MOZ_IMPLICIT Msg_NotifyConferenceCallStateChanged() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_NotifyConferenceCallStateChanged")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyConferenceCallStateChanged(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_NotifyConferenceError :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifyConferenceError__ID
    };
    MOZ_IMPLICIT Msg_NotifyConferenceError() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_NotifyConferenceError")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifyConferenceError(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_NotifySupplementaryService :
    public IPC::Message
{
public:
    enum {
        ID = Msg_NotifySupplementaryService__ID
    };
    MOZ_IMPLICIT Msg_NotifySupplementaryService() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_NotifySupplementaryService")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_NotifySupplementaryService(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_PTelephonyRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Msg_PTelephonyRequestConstructor__ID
    };
    MOZ_IMPLICIT Msg_PTelephonyRequestConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_PTelephonyRequestConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_PTelephonyRequestConstructor(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply_PTelephonyRequestConstructor :
    public IPC::Message
{
public:
    enum {
        ID = Reply_PTelephonyRequestConstructor__ID
    };
    MOZ_IMPLICIT Reply_PTelephonyRequestConstructor() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Reply_PTelephonyRequestConstructor")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_PTelephonyRequestConstructor(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_RegisterListener :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RegisterListener__ID
    };
    MOZ_IMPLICIT Msg_RegisterListener() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_RegisterListener")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_RegisterListener(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_UnregisterListener :
    public IPC::Message
{
public:
    enum {
        ID = Msg_UnregisterListener__ID
    };
    MOZ_IMPLICIT Msg_UnregisterListener() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_UnregisterListener")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_UnregisterListener(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_HangUpCall :
    public IPC::Message
{
public:
    enum {
        ID = Msg_HangUpCall__ID
    };
    MOZ_IMPLICIT Msg_HangUpCall() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_HangUpCall")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_HangUpCall(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_AnswerCall :
    public IPC::Message
{
public:
    enum {
        ID = Msg_AnswerCall__ID
    };
    MOZ_IMPLICIT Msg_AnswerCall() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_AnswerCall")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_AnswerCall(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_RejectCall :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RejectCall__ID
    };
    MOZ_IMPLICIT Msg_RejectCall() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_RejectCall")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_RejectCall(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_HoldCall :
    public IPC::Message
{
public:
    enum {
        ID = Msg_HoldCall__ID
    };
    MOZ_IMPLICIT Msg_HoldCall() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_HoldCall")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_HoldCall(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_ResumeCall :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ResumeCall__ID
    };
    MOZ_IMPLICIT Msg_ResumeCall() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_ResumeCall")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ResumeCall(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_ConferenceCall :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ConferenceCall__ID
    };
    MOZ_IMPLICIT Msg_ConferenceCall() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_ConferenceCall")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ConferenceCall(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_SeparateCall :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SeparateCall__ID
    };
    MOZ_IMPLICIT Msg_SeparateCall() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_SeparateCall")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SeparateCall(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_HoldConference :
    public IPC::Message
{
public:
    enum {
        ID = Msg_HoldConference__ID
    };
    MOZ_IMPLICIT Msg_HoldConference() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_HoldConference")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_HoldConference(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_ResumeConference :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ResumeConference__ID
    };
    MOZ_IMPLICIT Msg_ResumeConference() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_ResumeConference")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ResumeConference(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_StartTone :
    public IPC::Message
{
public:
    enum {
        ID = Msg_StartTone__ID
    };
    MOZ_IMPLICIT Msg_StartTone() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_StartTone")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_StartTone(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_StopTone :
    public IPC::Message
{
public:
    enum {
        ID = Msg_StopTone__ID
    };
    MOZ_IMPLICIT Msg_StopTone() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_StopTone")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_StopTone(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_GetMicrophoneMuted :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetMicrophoneMuted__ID
    };
    MOZ_IMPLICIT Msg_GetMicrophoneMuted() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_GetMicrophoneMuted")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetMicrophoneMuted(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply_GetMicrophoneMuted :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetMicrophoneMuted__ID
    };
    MOZ_IMPLICIT Reply_GetMicrophoneMuted() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Reply_GetMicrophoneMuted")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetMicrophoneMuted(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_SetMicrophoneMuted :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetMicrophoneMuted__ID
    };
    MOZ_IMPLICIT Msg_SetMicrophoneMuted() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_SetMicrophoneMuted")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetMicrophoneMuted(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_GetSpeakerEnabled :
    public IPC::Message
{
public:
    enum {
        ID = Msg_GetSpeakerEnabled__ID
    };
    MOZ_IMPLICIT Msg_GetSpeakerEnabled() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_GetSpeakerEnabled")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_GetSpeakerEnabled(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply_GetSpeakerEnabled :
    public IPC::Message
{
public:
    enum {
        ID = Reply_GetSpeakerEnabled__ID
    };
    MOZ_IMPLICIT Reply_GetSpeakerEnabled() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Reply_GetSpeakerEnabled")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply_GetSpeakerEnabled(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_SetSpeakerEnabled :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetSpeakerEnabled__ID
    };
    MOZ_IMPLICIT Msg_SetSpeakerEnabled() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PTelephony::Msg_SetSpeakerEnabled")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetSpeakerEnabled(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};



} // namespace PTelephony
} // namespace telephony
} // namespace dom
} // namespace mozilla

#endif // ifndef PTelephony_h
