//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPAudioDecoderChild_h
#define PGMPAudioDecoderChild_h

#include "mozilla/gmp/PGMPAudioDecoder.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "GMPMessageUtils.h"
#include "gmp-audio-codec.h"
#include "gmp-errors.h"

namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class /*NS_ABSTRACT_CLASS*/ PGMPAudioDecoderChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::gmp::PGMPChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPAudioCodecData GMPAudioCodecData;
    typedef mozilla::gmp::GMPAudioDecodedSampleData GMPAudioDecodedSampleData;
    typedef mozilla::gmp::GMPAudioEncodedSampleData GMPAudioEncodedSampleData;
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::gmp::PGMPChild PGMPChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PGMPAudioDecoder::State State;

    virtual bool
    RecvInitDecode(const GMPAudioCodecData& aCodecSettings) = 0;
    virtual bool
    RecvDecode(const GMPAudioEncodedSampleData& aInput) = 0;
    virtual bool
    RecvReset() = 0;
    virtual bool
    RecvDrain() = 0;
    virtual bool
    RecvDecodingComplete() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PGMPAudioDecoderChild();

    virtual ~PGMPAudioDecoderChild();

    PGMPChild*
    Manager() const;

    PGMPAudioDecoder::State
    state();

    static bool
    Send__delete__(PGMPAudioDecoderChild* actor);

    bool
    SendDecoded(const GMPAudioDecodedSampleData& aDecoded);

    bool
    SendInputDataExhausted();

    bool
    SendDrainComplete();

    bool
    SendResetComplete();

    bool
    SendError(const GMPErr& aErr);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const GMPDecryptionData& __v,
            Message* __msg);

    bool
    Read(
            GMPDecryptionData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GMPAudioEncodedSampleData& __v,
            Message* __msg);

    bool
    Read(
            GMPAudioEncodedSampleData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PGMPAudioDecoderChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PGMPAudioDecoderChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GMPAudioDecodedSampleData& __v,
            Message* __msg);

    bool
    Read(
            GMPAudioDecodedSampleData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GMPAudioCodecData& __v,
            Message* __msg);

    bool
    Read(
            GMPAudioCodecData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPAudioDecoderChild :
    public PGMPAudioDecoderChild
{
    virtual bool
    RecvInitDecode(const GMPAudioCodecData& aCodecSettings);

    virtual bool
    RecvDecode(const GMPAudioEncodedSampleData& aInput);

    virtual bool
    RecvReset();

    virtual bool
    RecvDrain();

    virtual bool
    RecvDecodingComplete();

    MOZ_IMPLICIT GMPAudioDecoderChild();
    virtual ~GMPAudioDecoderChild();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
bool
GMPAudioDecoderChild::RecvInitDecode(const GMPAudioCodecData& aCodecSettings)
{
    return false;
}

bool
GMPAudioDecoderChild::RecvDecode(const GMPAudioEncodedSampleData& aInput)
{
    return false;
}

bool
GMPAudioDecoderChild::RecvReset()
{
    return false;
}

bool
GMPAudioDecoderChild::RecvDrain()
{
    return false;
}

bool
GMPAudioDecoderChild::RecvDecodingComplete()
{
    return false;
}

MOZ_IMPLICIT GMPAudioDecoderChild::GMPAudioDecoderChild()
{
    MOZ_COUNT_CTOR(GMPAudioDecoderChild);
}

MOZ_IMPLICIT GMPAudioDecoderChild::~GMPAudioDecoderChild()
{
    MOZ_COUNT_DTOR(GMPAudioDecoderChild);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPAudioDecoderChild_h
