//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPDecryptor_h
#define PGMPDecryptor_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/gmp/GMPTypes.h"

//-----------------------------------------------------------------------------
// Code common to PGMPDecryptorChild and PGMPDecryptorParent
//
namespace mozilla {
namespace gmp {
namespace PGMPDecryptor {

enum State {
    __Dead,
    __Null,
    __Error,
    __Dying,
    __Start = __Null
};

enum MessageType {
    PGMPDecryptorStart = PGMPDecryptorMsgStart << 16,
    Msg_Init__ID,
    Msg_CreateSession__ID,
    Msg_LoadSession__ID,
    Msg_UpdateSession__ID,
    Msg_CloseSession__ID,
    Msg_RemoveSession__ID,
    Msg_SetServerCertificate__ID,
    Msg_Decrypt__ID,
    Msg_DecryptingComplete__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_ResolveNewSessionPromise__ID,
    Msg_ResolveLoadSessionPromise__ID,
    Msg_ResolvePromise__ID,
    Msg_RejectPromise__ID,
    Msg_SessionMessage__ID,
    Msg_ExpirationChange__ID,
    Msg_SessionClosed__ID,
    Msg_SessionError__ID,
    Msg_KeyIdUsable__ID,
    Msg_SetCaps__ID,
    Msg_KeyIdNotUsable__ID,
    Msg_Decrypted__ID,
    PGMPDecryptorEnd
};

bool
Transition(
        State from,
        mozilla::ipc::Trigger trigger,
        State* next);

class Msg_Init :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Init__ID
    };
    MOZ_IMPLICIT Msg_Init() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_Init")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Init(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_CreateSession :
    public IPC::Message
{
public:
    enum {
        ID = Msg_CreateSession__ID
    };
    MOZ_IMPLICIT Msg_CreateSession() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_CreateSession")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_CreateSession(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_LoadSession :
    public IPC::Message
{
public:
    enum {
        ID = Msg_LoadSession__ID
    };
    MOZ_IMPLICIT Msg_LoadSession() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_LoadSession")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_LoadSession(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_UpdateSession :
    public IPC::Message
{
public:
    enum {
        ID = Msg_UpdateSession__ID
    };
    MOZ_IMPLICIT Msg_UpdateSession() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_UpdateSession")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_UpdateSession(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_CloseSession :
    public IPC::Message
{
public:
    enum {
        ID = Msg_CloseSession__ID
    };
    MOZ_IMPLICIT Msg_CloseSession() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_CloseSession")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_CloseSession(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_RemoveSession :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RemoveSession__ID
    };
    MOZ_IMPLICIT Msg_RemoveSession() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_RemoveSession")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_RemoveSession(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_SetServerCertificate :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetServerCertificate__ID
    };
    MOZ_IMPLICIT Msg_SetServerCertificate() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_SetServerCertificate")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetServerCertificate(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_Decrypt :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Decrypt__ID
    };
    MOZ_IMPLICIT Msg_Decrypt() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_Decrypt")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Decrypt(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_DecryptingComplete :
    public IPC::Message
{
public:
    enum {
        ID = Msg_DecryptingComplete__ID
    };
    MOZ_IMPLICIT Msg_DecryptingComplete() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_DecryptingComplete")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_DecryptingComplete(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Msg___delete____ID
    };
    MOZ_IMPLICIT Msg___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg___delete__(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Reply___delete__ :
    public IPC::Message
{
public:
    enum {
        ID = Reply___delete____ID
    };
    MOZ_IMPLICIT Reply___delete__() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Reply___delete__")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Reply___delete__(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_ResolveNewSessionPromise :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ResolveNewSessionPromise__ID
    };
    MOZ_IMPLICIT Msg_ResolveNewSessionPromise() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_ResolveNewSessionPromise")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ResolveNewSessionPromise(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_ResolveLoadSessionPromise :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ResolveLoadSessionPromise__ID
    };
    MOZ_IMPLICIT Msg_ResolveLoadSessionPromise() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_ResolveLoadSessionPromise")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ResolveLoadSessionPromise(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_ResolvePromise :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ResolvePromise__ID
    };
    MOZ_IMPLICIT Msg_ResolvePromise() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_ResolvePromise")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ResolvePromise(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_RejectPromise :
    public IPC::Message
{
public:
    enum {
        ID = Msg_RejectPromise__ID
    };
    MOZ_IMPLICIT Msg_RejectPromise() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_RejectPromise")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_RejectPromise(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_SessionMessage :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SessionMessage__ID
    };
    MOZ_IMPLICIT Msg_SessionMessage() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_SessionMessage")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SessionMessage(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_ExpirationChange :
    public IPC::Message
{
public:
    enum {
        ID = Msg_ExpirationChange__ID
    };
    MOZ_IMPLICIT Msg_ExpirationChange() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_ExpirationChange")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_ExpirationChange(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_SessionClosed :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SessionClosed__ID
    };
    MOZ_IMPLICIT Msg_SessionClosed() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_SessionClosed")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SessionClosed(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_SessionError :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SessionError__ID
    };
    MOZ_IMPLICIT Msg_SessionError() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_SessionError")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SessionError(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_KeyIdUsable :
    public IPC::Message
{
public:
    enum {
        ID = Msg_KeyIdUsable__ID
    };
    MOZ_IMPLICIT Msg_KeyIdUsable() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_KeyIdUsable")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_KeyIdUsable(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_SetCaps :
    public IPC::Message
{
public:
    enum {
        ID = Msg_SetCaps__ID
    };
    MOZ_IMPLICIT Msg_SetCaps() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_SetCaps")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_SetCaps(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_KeyIdNotUsable :
    public IPC::Message
{
public:
    enum {
        ID = Msg_KeyIdNotUsable__ID
    };
    MOZ_IMPLICIT Msg_KeyIdNotUsable() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_KeyIdNotUsable")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_KeyIdNotUsable(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};

class Msg_Decrypted :
    public IPC::Message
{
public:
    enum {
        ID = Msg_Decrypted__ID
    };
    MOZ_IMPLICIT Msg_Decrypted() :
        IPC::Message(MSG_ROUTING_NONE, ID, IPC::Message::PRIORITY_NORMAL, COMPRESSION_NONE, "PGMPDecryptor::Msg_Decrypted")
    {
    }

    void
    Log(
            const std::string& __pfx,
            base::ProcessHandle __otherProcess,
            bool __receiving) const
    {
        std::string __logmsg;
        StringAppendF((&(__logmsg)), "[time:%" PRId64 "][%d%s%d]", PR_Now(), base::GetCurrentProcId(), (__receiving ? "<-" : "->"), __otherProcess);
        (__logmsg).append(__pfx);
        (__logmsg).append("Msg_Decrypted(");

        (__logmsg).append("[TODO])\n");
#ifdef ANDROID
        __android_log_write(ANDROID_LOG_INFO, "GeckoIPC", (__logmsg).c_str());
#endif
        fputs((__logmsg).c_str(), stderr);
    }
};



} // namespace PGMPDecryptor
} // namespace gmp
} // namespace mozilla

#endif // ifndef PGMPDecryptor_h
