//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPDecryptorParent_h
#define PGMPDecryptorParent_h

#include "mozilla/gmp/PGMPDecryptor.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "gmp-decryption.h"
#include "gmp-errors.h"

namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPParent;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class /*NS_ABSTRACT_CLASS*/ PGMPDecryptorParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::gmp::PGMPParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPAudioCodecData GMPAudioCodecData;
    typedef mozilla::gmp::GMPAudioDecodedSampleData GMPAudioDecodedSampleData;
    typedef mozilla::gmp::GMPAudioEncodedSampleData GMPAudioEncodedSampleData;
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::gmp::PGMPParent PGMPParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PGMPDecryptor::State State;

    virtual bool
    Recv__delete__();
    virtual bool
    RecvResolveNewSessionPromise(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId) = 0;
    virtual bool
    RecvResolveLoadSessionPromise(
            const uint32_t& aPromiseId,
            const bool& aSuccess) = 0;
    virtual bool
    RecvResolvePromise(const uint32_t& aPromiseId) = 0;
    virtual bool
    RecvRejectPromise(
            const uint32_t& aPromiseId,
            const GMPDOMException& aDOMExceptionCode,
            const nsCString& aMessage) = 0;
    virtual bool
    RecvSessionMessage(
            const nsCString& aSessionId,
            const nsTArray<uint8_t>& aMessage,
            const nsCString& aDestinationURL) = 0;
    virtual bool
    RecvExpirationChange(
            const nsCString& aSessionId,
            const double& aExpiryTime) = 0;
    virtual bool
    RecvSessionClosed(const nsCString& aSessionId) = 0;
    virtual bool
    RecvSessionError(
            const nsCString& aSessionId,
            const GMPDOMException& aDOMExceptionCode,
            const uint32_t& aSystemCode,
            const nsCString& aMessage) = 0;
    virtual bool
    RecvKeyIdUsable(
            const nsCString& aSessionId,
            const nsTArray<uint8_t>& aKey) = 0;
    virtual bool
    RecvSetCaps(const uint64_t& aCaps) = 0;
    virtual bool
    RecvKeyIdNotUsable(
            const nsCString& aSessionId,
            const nsTArray<uint8_t>& aKey) = 0;
    virtual bool
    RecvDecrypted(
            const uint32_t& aId,
            const GMPErr& aResult,
            const nsTArray<uint8_t>& aBuffer) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PGMPDecryptorParent();

    virtual ~PGMPDecryptorParent();

    PGMPParent*
    Manager() const;

    PGMPDecryptor::State
    state();

    bool
    SendInit() NS_WARN_UNUSED_RESULT;

    bool
    SendCreateSession(
            const uint32_t& aPromiseId,
            const nsCString& aInitDataType,
            const nsTArray<uint8_t>& aInitData,
            const GMPSessionType& aSessionType) NS_WARN_UNUSED_RESULT;

    bool
    SendLoadSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId) NS_WARN_UNUSED_RESULT;

    bool
    SendUpdateSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId,
            const nsTArray<uint8_t>& aResponse) NS_WARN_UNUSED_RESULT;

    bool
    SendCloseSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId) NS_WARN_UNUSED_RESULT;

    bool
    SendRemoveSession(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId) NS_WARN_UNUSED_RESULT;

    bool
    SendSetServerCertificate(
            const uint32_t& aPromiseId,
            const nsTArray<uint8_t>& aServerCert) NS_WARN_UNUSED_RESULT;

    bool
    SendDecrypt(
            const uint32_t& aId,
            const nsTArray<uint8_t>& aBuffer,
            const GMPDecryptionData& aMetadata) NS_WARN_UNUSED_RESULT;

    bool
    SendDecryptingComplete() NS_WARN_UNUSED_RESULT;

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const GMPDecryptionData& __v,
            Message* __msg);

    bool
    Read(
            GMPDecryptionData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PGMPDecryptorParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PGMPDecryptorParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPDecryptorParent :
    public PGMPDecryptorParent
{
    virtual bool
    RecvResolveNewSessionPromise(
            const uint32_t& aPromiseId,
            const nsCString& aSessionId);

    virtual bool
    RecvResolveLoadSessionPromise(
            const uint32_t& aPromiseId,
            const bool& aSuccess);

    virtual bool
    RecvResolvePromise(const uint32_t& aPromiseId);

    virtual bool
    RecvRejectPromise(
            const uint32_t& aPromiseId,
            const GMPDOMException& aDOMExceptionCode,
            const nsCString& aMessage);

    virtual bool
    RecvSessionMessage(
            const nsCString& aSessionId,
            const nsTArray<uint8_t>& aMessage,
            const nsCString& aDestinationURL);

    virtual bool
    RecvExpirationChange(
            const nsCString& aSessionId,
            const double& aExpiryTime);

    virtual bool
    RecvSessionClosed(const nsCString& aSessionId);

    virtual bool
    RecvSessionError(
            const nsCString& aSessionId,
            const GMPDOMException& aDOMExceptionCode,
            const uint32_t& aSystemCode,
            const nsCString& aMessage);

    virtual bool
    RecvKeyIdUsable(
            const nsCString& aSessionId,
            const nsTArray<uint8_t>& aKey);

    virtual bool
    RecvSetCaps(const uint64_t& aCaps);

    virtual bool
    RecvKeyIdNotUsable(
            const nsCString& aSessionId,
            const nsTArray<uint8_t>& aKey);

    virtual bool
    RecvDecrypted(
            const uint32_t& aId,
            const GMPErr& aResult,
            const nsTArray<uint8_t>& aBuffer);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT GMPDecryptorParent();
    virtual ~GMPDecryptorParent();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
bool
GMPDecryptorParent::RecvResolveNewSessionPromise(
        const uint32_t& aPromiseId,
        const nsCString& aSessionId)
{
    return false;
}

bool
GMPDecryptorParent::RecvResolveLoadSessionPromise(
        const uint32_t& aPromiseId,
        const bool& aSuccess)
{
    return false;
}

bool
GMPDecryptorParent::RecvResolvePromise(const uint32_t& aPromiseId)
{
    return false;
}

bool
GMPDecryptorParent::RecvRejectPromise(
        const uint32_t& aPromiseId,
        const GMPDOMException& aDOMExceptionCode,
        const nsCString& aMessage)
{
    return false;
}

bool
GMPDecryptorParent::RecvSessionMessage(
        const nsCString& aSessionId,
        const nsTArray<uint8_t>& aMessage,
        const nsCString& aDestinationURL)
{
    return false;
}

bool
GMPDecryptorParent::RecvExpirationChange(
        const nsCString& aSessionId,
        const double& aExpiryTime)
{
    return false;
}

bool
GMPDecryptorParent::RecvSessionClosed(const nsCString& aSessionId)
{
    return false;
}

bool
GMPDecryptorParent::RecvSessionError(
        const nsCString& aSessionId,
        const GMPDOMException& aDOMExceptionCode,
        const uint32_t& aSystemCode,
        const nsCString& aMessage)
{
    return false;
}

bool
GMPDecryptorParent::RecvKeyIdUsable(
        const nsCString& aSessionId,
        const nsTArray<uint8_t>& aKey)
{
    return false;
}

bool
GMPDecryptorParent::RecvSetCaps(const uint64_t& aCaps)
{
    return false;
}

bool
GMPDecryptorParent::RecvKeyIdNotUsable(
        const nsCString& aSessionId,
        const nsTArray<uint8_t>& aKey)
{
    return false;
}

bool
GMPDecryptorParent::RecvDecrypted(
        const uint32_t& aId,
        const GMPErr& aResult,
        const nsTArray<uint8_t>& aBuffer)
{
    return false;
}

void
GMPDecryptorParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT GMPDecryptorParent::GMPDecryptorParent()
{
    MOZ_COUNT_CTOR(GMPDecryptorParent);
}

MOZ_IMPLICIT GMPDecryptorParent::~GMPDecryptorParent()
{
    MOZ_COUNT_DTOR(GMPDecryptorParent);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPDecryptorParent_h
