//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PGMPVideoDecoderChild_h
#define PGMPVideoDecoderChild_h

#include "mozilla/gmp/PGMPVideoDecoder.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "GMPMessageUtils.h"
#include "gmp-errors.h"
#include "gmp-video-codec.h"

namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {
class PGMPChild;
} // namespace gmp
} // namespace mozilla

namespace mozilla {
namespace gmp {


class /*NS_ABSTRACT_CLASS*/ PGMPVideoDecoderChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::gmp::PGMPChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gmp::GMPAudioCodecData GMPAudioCodecData;
    typedef mozilla::gmp::GMPAudioDecodedSampleData GMPAudioDecodedSampleData;
    typedef mozilla::gmp::GMPAudioEncodedSampleData GMPAudioEncodedSampleData;
    typedef mozilla::gmp::GMPDecryptionData GMPDecryptionData;
    typedef mozilla::gmp::GMPPlaneData GMPPlaneData;
    typedef mozilla::gmp::GMPVideoEncodedFrameData GMPVideoEncodedFrameData;
    typedef mozilla::gmp::GMPVideoi420FrameData GMPVideoi420FrameData;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::gmp::PGMPChild PGMPChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PGMPVideoDecoder::State State;

    virtual bool
    RecvInitDecode(
            const GMPVideoCodec& aCodecSettings,
            const nsTArray<uint8_t>& aCodecSpecific,
            const int32_t& aCoreCount) = 0;
    virtual bool
    RecvDecode(
            const GMPVideoEncodedFrameData& aInputFrame,
            const bool& aMissingFrames,
            const nsTArray<uint8_t>& aCodecSpecificInfo,
            const int64_t& aRenderTimeMs) = 0;
    virtual bool
    RecvReset() = 0;
    virtual bool
    RecvDrain() = 0;
    virtual bool
    RecvDecodingComplete() = 0;
    virtual bool
    RecvChildShmemForPool(Shmem& aFrameBuffer) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PGMPVideoDecoderChild();

    virtual ~PGMPVideoDecoderChild();

    PGMPChild*
    Manager() const;

    PGMPVideoDecoder::State
    state();

    static bool
    Send__delete__(PGMPVideoDecoderChild* actor);

    bool
    SendDecoded(const GMPVideoi420FrameData& aDecodedFrame);

    bool
    SendReceivedDecodedReferenceFrame(const uint64_t& aPictureId);

    bool
    SendReceivedDecodedFrame(const uint64_t& aPictureId);

    bool
    SendInputDataExhausted();

    bool
    SendDrainComplete();

    bool
    SendResetComplete();

    bool
    SendError(const GMPErr& aErr);

    bool
    SendParentShmemForPool(Shmem& aEncodedBuffer);

    bool
    CallNeedShmem(
            const uint32_t& aFrameBufferSize,
            Shmem* aMem);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const GMPDecryptionData& __v,
            Message* __msg);

    bool
    Read(
            GMPDecryptionData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            Shmem& __v,
            Message* __msg);

    bool
    Read(
            Shmem* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GMPVideoi420FrameData& __v,
            Message* __msg);

    bool
    Read(
            GMPVideoi420FrameData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GMPVideoEncodedFrameData& __v,
            Message* __msg);

    bool
    Read(
            GMPVideoEncodedFrameData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GMPPlaneData& __v,
            Message* __msg);

    bool
    Read(
            GMPPlaneData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PGMPVideoDecoderChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PGMPVideoDecoderChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace gmp
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gmp {
class GMPVideoDecoderChild :
    public PGMPVideoDecoderChild
{
    virtual bool
    RecvInitDecode(
            const GMPVideoCodec& aCodecSettings,
            const nsTArray<uint8_t>& aCodecSpecific,
            const int32_t& aCoreCount);

    virtual bool
    RecvDecode(
            const GMPVideoEncodedFrameData& aInputFrame,
            const bool& aMissingFrames,
            const nsTArray<uint8_t>& aCodecSpecificInfo,
            const int64_t& aRenderTimeMs);

    virtual bool
    RecvReset();

    virtual bool
    RecvDrain();

    virtual bool
    RecvDecodingComplete();

    virtual bool
    RecvChildShmemForPool(Shmem& aFrameBuffer);

    MOZ_IMPLICIT GMPVideoDecoderChild();
    virtual ~GMPVideoDecoderChild();
};
} // namespace gmp
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gmp {
bool
GMPVideoDecoderChild::RecvInitDecode(
        const GMPVideoCodec& aCodecSettings,
        const nsTArray<uint8_t>& aCodecSpecific,
        const int32_t& aCoreCount)
{
    return false;
}

bool
GMPVideoDecoderChild::RecvDecode(
        const GMPVideoEncodedFrameData& aInputFrame,
        const bool& aMissingFrames,
        const nsTArray<uint8_t>& aCodecSpecificInfo,
        const int64_t& aRenderTimeMs)
{
    return false;
}

bool
GMPVideoDecoderChild::RecvReset()
{
    return false;
}

bool
GMPVideoDecoderChild::RecvDrain()
{
    return false;
}

bool
GMPVideoDecoderChild::RecvDecodingComplete()
{
    return false;
}

bool
GMPVideoDecoderChild::RecvChildShmemForPool(Shmem& aFrameBuffer)
{
    return false;
}

MOZ_IMPLICIT GMPVideoDecoderChild::GMPVideoDecoderChild()
{
    MOZ_COUNT_CTOR(GMPVideoDecoderChild);
}

MOZ_IMPLICIT GMPVideoDecoderChild::~GMPVideoDecoderChild()
{
    MOZ_COUNT_DTOR(GMPVideoDecoderChild);
}

} // namespace gmp
} // namespace mozilla
#endif // if 0

#endif // ifndef PGMPVideoDecoderChild_h
