//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef NeckoChannelParams_h
#define NeckoChannelParams_h

#include "mozilla/Attributes.h"
#include "prtime.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "nsAutoPtr.h"
#include "nsStringGlue.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"

// Headers for typedefs
#include "mozilla/net/PHttpChannelParams.h"
#include "mozilla/ipc/URIParams.h"
#include "mozilla/ipc/InputStreamParams.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"

namespace mozilla {
namespace ipc {
class URIParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalURIParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalFileDescriptorSet;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelOpenArgs|
//
namespace mozilla {
namespace net {
class HttpChannelOpenArgs MOZ_FINAL
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::ipc::OptionalFileDescriptorSet OptionalFileDescriptorSet;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT HttpChannelOpenArgs();

    MOZ_IMPLICIT HttpChannelOpenArgs(
            const URIParams& _uri,
            const OptionalURIParams& _original,
            const OptionalURIParams& _doc,
            const OptionalURIParams& _referrer,
            const OptionalURIParams& _apiRedirectTo,
            const uint32_t& _loadFlags,
            const RequestHeaderTuples& _requestHeaders,
            const nsCString& _requestMethod,
            const OptionalInputStreamParams& _uploadStream,
            const bool& _uploadStreamHasHeaders,
            const uint16_t& _priority,
            const uint8_t& _redirectionLimit,
            const bool& _allowPipelining,
            const bool& _allowSTS,
            const bool& _forceAllowThirdPartyCookie,
            const bool& _resumeAt,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const bool& _chooseApplicationCache,
            const nsCString& _appCacheClientID,
            const bool& _allowSpdy,
            const OptionalFileDescriptorSet& _fds,
            const PrincipalInfo& _requestingPrincipalInfo,
            const uint32_t& _securityFlags,
            const uint32_t& _contentPolicyType)
    {
        Init();
        Assign(_uri, _original, _doc, _referrer, _apiRedirectTo, _loadFlags, _requestHeaders, _requestMethod, _uploadStream, _uploadStreamHasHeaders, _priority, _redirectionLimit, _allowPipelining, _allowSTS, _forceAllowThirdPartyCookie, _resumeAt, _startPos, _entityID, _chooseApplicationCache, _appCacheClientID, _allowSpdy, _fds, _requestingPrincipalInfo, _securityFlags, _contentPolicyType);
    }

    MOZ_IMPLICIT HttpChannelOpenArgs(const HttpChannelOpenArgs& _o)
    {
        Init();
        Assign((_o).uri(), (_o).original(), (_o).doc(), (_o).referrer(), (_o).apiRedirectTo(), (_o).loadFlags(), (_o).requestHeaders(), (_o).requestMethod(), (_o).uploadStream(), (_o).uploadStreamHasHeaders(), (_o).priority(), (_o).redirectionLimit(), (_o).allowPipelining(), (_o).allowSTS(), (_o).forceAllowThirdPartyCookie(), (_o).resumeAt(), (_o).startPos(), (_o).entityID(), (_o).chooseApplicationCache(), (_o).appCacheClientID(), (_o).allowSpdy(), (_o).fds(), (_o).requestingPrincipalInfo(), (_o).securityFlags(), (_o).contentPolicyType());
    }

    ~HttpChannelOpenArgs();

    void
    operator=(const HttpChannelOpenArgs& _o)
    {
        Assign((_o).uri(), (_o).original(), (_o).doc(), (_o).referrer(), (_o).apiRedirectTo(), (_o).loadFlags(), (_o).requestHeaders(), (_o).requestMethod(), (_o).uploadStream(), (_o).uploadStreamHasHeaders(), (_o).priority(), (_o).redirectionLimit(), (_o).allowPipelining(), (_o).allowSTS(), (_o).forceAllowThirdPartyCookie(), (_o).resumeAt(), (_o).startPos(), (_o).entityID(), (_o).chooseApplicationCache(), (_o).appCacheClientID(), (_o).allowSpdy(), (_o).fds(), (_o).requestingPrincipalInfo(), (_o).securityFlags(), (_o).contentPolicyType());
    }

    bool
    operator==(const HttpChannelOpenArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    OptionalURIParams&
    original()
    {
        return original_;
    }
    const OptionalURIParams&
    original() const
    {
        return original_;
    }

    OptionalURIParams&
    doc()
    {
        return doc_;
    }
    const OptionalURIParams&
    doc() const
    {
        return doc_;
    }

    OptionalURIParams&
    referrer()
    {
        return referrer_;
    }
    const OptionalURIParams&
    referrer() const
    {
        return referrer_;
    }

    OptionalURIParams&
    apiRedirectTo()
    {
        return apiRedirectTo_;
    }
    const OptionalURIParams&
    apiRedirectTo() const
    {
        return apiRedirectTo_;
    }

    uint32_t&
    loadFlags()
    {
        return loadFlags_;
    }
    const uint32_t&
    loadFlags() const
    {
        return loadFlags_;
    }

    RequestHeaderTuples&
    requestHeaders()
    {
        return requestHeaders_;
    }
    const RequestHeaderTuples&
    requestHeaders() const
    {
        return requestHeaders_;
    }

    nsCString&
    requestMethod()
    {
        return requestMethod_;
    }
    const nsCString&
    requestMethod() const
    {
        return requestMethod_;
    }

    OptionalInputStreamParams&
    uploadStream()
    {
        return uploadStream_;
    }
    const OptionalInputStreamParams&
    uploadStream() const
    {
        return uploadStream_;
    }

    bool&
    uploadStreamHasHeaders()
    {
        return uploadStreamHasHeaders_;
    }
    const bool&
    uploadStreamHasHeaders() const
    {
        return uploadStreamHasHeaders_;
    }

    uint16_t&
    priority()
    {
        return priority_;
    }
    const uint16_t&
    priority() const
    {
        return priority_;
    }

    uint8_t&
    redirectionLimit()
    {
        return redirectionLimit_;
    }
    const uint8_t&
    redirectionLimit() const
    {
        return redirectionLimit_;
    }

    bool&
    allowPipelining()
    {
        return allowPipelining_;
    }
    const bool&
    allowPipelining() const
    {
        return allowPipelining_;
    }

    bool&
    allowSTS()
    {
        return allowSTS_;
    }
    const bool&
    allowSTS() const
    {
        return allowSTS_;
    }

    bool&
    forceAllowThirdPartyCookie()
    {
        return forceAllowThirdPartyCookie_;
    }
    const bool&
    forceAllowThirdPartyCookie() const
    {
        return forceAllowThirdPartyCookie_;
    }

    bool&
    resumeAt()
    {
        return resumeAt_;
    }
    const bool&
    resumeAt() const
    {
        return resumeAt_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    nsCString&
    entityID()
    {
        return entityID_;
    }
    const nsCString&
    entityID() const
    {
        return entityID_;
    }

    bool&
    chooseApplicationCache()
    {
        return chooseApplicationCache_;
    }
    const bool&
    chooseApplicationCache() const
    {
        return chooseApplicationCache_;
    }

    nsCString&
    appCacheClientID()
    {
        return appCacheClientID_;
    }
    const nsCString&
    appCacheClientID() const
    {
        return appCacheClientID_;
    }

    bool&
    allowSpdy()
    {
        return allowSpdy_;
    }
    const bool&
    allowSpdy() const
    {
        return allowSpdy_;
    }

    OptionalFileDescriptorSet&
    fds()
    {
        return fds_;
    }
    const OptionalFileDescriptorSet&
    fds() const
    {
        return fds_;
    }

    PrincipalInfo&
    requestingPrincipalInfo()
    {
        return requestingPrincipalInfo_;
    }
    const PrincipalInfo&
    requestingPrincipalInfo() const
    {
        return requestingPrincipalInfo_;
    }

    uint32_t&
    securityFlags()
    {
        return securityFlags_;
    }
    const uint32_t&
    securityFlags() const
    {
        return securityFlags_;
    }

    uint32_t&
    contentPolicyType()
    {
        return contentPolicyType_;
    }
    const uint32_t&
    contentPolicyType() const
    {
        return contentPolicyType_;
    }

private:
    void
    Init();

    void
    Assign(
            const URIParams& _uri,
            const OptionalURIParams& _original,
            const OptionalURIParams& _doc,
            const OptionalURIParams& _referrer,
            const OptionalURIParams& _apiRedirectTo,
            const uint32_t& _loadFlags,
            const RequestHeaderTuples& _requestHeaders,
            const nsCString& _requestMethod,
            const OptionalInputStreamParams& _uploadStream,
            const bool& _uploadStreamHasHeaders,
            const uint16_t& _priority,
            const uint8_t& _redirectionLimit,
            const bool& _allowPipelining,
            const bool& _allowSTS,
            const bool& _forceAllowThirdPartyCookie,
            const bool& _resumeAt,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const bool& _chooseApplicationCache,
            const nsCString& _appCacheClientID,
            const bool& _allowSpdy,
            const OptionalFileDescriptorSet& _fds,
            const PrincipalInfo& _requestingPrincipalInfo,
            const uint32_t& _securityFlags,
            const uint32_t& _contentPolicyType);

    URIParams uri_;
    OptionalURIParams original_;
    OptionalURIParams doc_;
    OptionalURIParams referrer_;
    OptionalURIParams apiRedirectTo_;
    uint32_t loadFlags_;
    RequestHeaderTuples requestHeaders_;
    nsCString requestMethod_;
    OptionalInputStreamParams uploadStream_;
    bool uploadStreamHasHeaders_;
    uint16_t priority_;
    uint8_t redirectionLimit_;
    bool allowPipelining_;
    bool allowSTS_;
    bool forceAllowThirdPartyCookie_;
    bool resumeAt_;
    uint64_t startPos_;
    nsCString entityID_;
    bool chooseApplicationCache_;
    nsCString appCacheClientID_;
    bool allowSpdy_;
    OptionalFileDescriptorSet fds_;
    PrincipalInfo requestingPrincipalInfo_;
    uint32_t securityFlags_;
    uint32_t contentPolicyType_;
};
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HttpChannelConnectArgs|
//
namespace mozilla {
namespace net {
class HttpChannelConnectArgs MOZ_FINAL
{
private:

public:
    MOZ_IMPLICIT HttpChannelConnectArgs();

    MOZ_IMPLICIT HttpChannelConnectArgs(const uint32_t& _channelId)
    {
        Init();
        Assign(_channelId);
    }

    MOZ_IMPLICIT HttpChannelConnectArgs(const HttpChannelConnectArgs& _o)
    {
        Init();
        Assign((_o).channelId());
    }

    ~HttpChannelConnectArgs();

    void
    operator=(const HttpChannelConnectArgs& _o)
    {
        Assign((_o).channelId());
    }

    bool
    operator==(const HttpChannelConnectArgs& _o) const;

    uint32_t&
    channelId()
    {
        return channelId_;
    }
    const uint32_t&
    channelId() const
    {
        return channelId_;
    }

private:
    void
    Init();

    void
    Assign(const uint32_t& _channelId);

    uint32_t channelId_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class HttpChannelOpenArgs;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class HttpChannelConnectArgs;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union HttpChannelCreationArgs|
//
namespace mozilla {
namespace net {
class HttpChannelCreationArgs MOZ_FINAL
{
public:
    enum Type {
        T__None,
        THttpChannelOpenArgs = 1,
        THttpChannelConnectArgs,
        T__Last = THttpChannelConnectArgs
    };

private:
    typedef mozilla::net::HttpChannelOpenArgs HttpChannelOpenArgs;
    typedef mozilla::net::HttpChannelConnectArgs HttpChannelConnectArgs;
    typedef HttpChannelOpenArgs HttpChannelOpenArgs__tdef;
    typedef HttpChannelConnectArgs HttpChannelConnectArgs__tdef;

    union Value {
        char VHttpChannelOpenArgs[sizeof(HttpChannelOpenArgs)];
        char VHttpChannelConnectArgs[sizeof(HttpChannelConnectArgs)];
    };

    HttpChannelOpenArgs*
    ptr_HttpChannelOpenArgs()
    {
        return reinterpret_cast<HttpChannelOpenArgs*>((&((mValue).VHttpChannelOpenArgs)));
    }
    const HttpChannelOpenArgs* const
    constptr_HttpChannelOpenArgs() const
    {
        return reinterpret_cast<const HttpChannelOpenArgs* const>((&((mValue).VHttpChannelOpenArgs)));
    }
    HttpChannelConnectArgs*
    ptr_HttpChannelConnectArgs()
    {
        return reinterpret_cast<HttpChannelConnectArgs*>((&((mValue).VHttpChannelConnectArgs)));
    }
    const HttpChannelConnectArgs* const
    constptr_HttpChannelConnectArgs() const
    {
        return reinterpret_cast<const HttpChannelConnectArgs* const>((&((mValue).VHttpChannelConnectArgs)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__None) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT HttpChannelCreationArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelOpenArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelConnectArgs& aOther);

    MOZ_IMPLICIT HttpChannelCreationArgs(const HttpChannelCreationArgs& aOther);

    ~HttpChannelCreationArgs();

    Type
    type() const
    {
        return mType;
    }

    HttpChannelCreationArgs&
    operator=(const HttpChannelOpenArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(const HttpChannelConnectArgs& aRhs);

    HttpChannelCreationArgs&
    operator=(const HttpChannelCreationArgs& aRhs);

    bool
    operator==(const HttpChannelOpenArgs& aRhs) const;

    bool
    operator==(const HttpChannelConnectArgs& aRhs) const;

    bool
    operator==(const HttpChannelCreationArgs& aRhs) const;

    HttpChannelOpenArgs&
    get_HttpChannelOpenArgs()
    {
        AssertSanity(THttpChannelOpenArgs);
        return (*(ptr_HttpChannelOpenArgs()));
    }
    const HttpChannelOpenArgs&
    get_HttpChannelOpenArgs() const
    {
        AssertSanity(THttpChannelOpenArgs);
        return (*(constptr_HttpChannelOpenArgs()));
    }
    operator HttpChannelOpenArgs&()
    {
        return get_HttpChannelOpenArgs();
    }
    operator const HttpChannelOpenArgs&() const
    {
        return get_HttpChannelOpenArgs();
    }

    HttpChannelConnectArgs&
    get_HttpChannelConnectArgs()
    {
        AssertSanity(THttpChannelConnectArgs);
        return (*(ptr_HttpChannelConnectArgs()));
    }
    const HttpChannelConnectArgs&
    get_HttpChannelConnectArgs() const
    {
        AssertSanity(THttpChannelConnectArgs);
        return (*(constptr_HttpChannelConnectArgs()));
    }
    operator HttpChannelConnectArgs&()
    {
        return get_HttpChannelConnectArgs();
    }
    operator const HttpChannelConnectArgs&() const
    {
        return get_HttpChannelConnectArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
class URIParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class OptionalInputStreamParams;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PrincipalInfo;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FTPChannelOpenArgs|
//
namespace mozilla {
namespace net {
class FTPChannelOpenArgs MOZ_FINAL
{
private:
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT FTPChannelOpenArgs();

    MOZ_IMPLICIT FTPChannelOpenArgs(
            const URIParams& _uri,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const OptionalInputStreamParams& _uploadStream,
            const PrincipalInfo& _requestingPrincipalInfo,
            const uint32_t& _securityFlags,
            const uint32_t& _contentPolicyType)
    {
        Init();
        Assign(_uri, _startPos, _entityID, _uploadStream, _requestingPrincipalInfo, _securityFlags, _contentPolicyType);
    }

    MOZ_IMPLICIT FTPChannelOpenArgs(const FTPChannelOpenArgs& _o)
    {
        Init();
        Assign((_o).uri(), (_o).startPos(), (_o).entityID(), (_o).uploadStream(), (_o).requestingPrincipalInfo(), (_o).securityFlags(), (_o).contentPolicyType());
    }

    ~FTPChannelOpenArgs();

    void
    operator=(const FTPChannelOpenArgs& _o)
    {
        Assign((_o).uri(), (_o).startPos(), (_o).entityID(), (_o).uploadStream(), (_o).requestingPrincipalInfo(), (_o).securityFlags(), (_o).contentPolicyType());
    }

    bool
    operator==(const FTPChannelOpenArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    uint64_t&
    startPos()
    {
        return startPos_;
    }
    const uint64_t&
    startPos() const
    {
        return startPos_;
    }

    nsCString&
    entityID()
    {
        return entityID_;
    }
    const nsCString&
    entityID() const
    {
        return entityID_;
    }

    OptionalInputStreamParams&
    uploadStream()
    {
        return uploadStream_;
    }
    const OptionalInputStreamParams&
    uploadStream() const
    {
        return uploadStream_;
    }

    PrincipalInfo&
    requestingPrincipalInfo()
    {
        return requestingPrincipalInfo_;
    }
    const PrincipalInfo&
    requestingPrincipalInfo() const
    {
        return requestingPrincipalInfo_;
    }

    uint32_t&
    securityFlags()
    {
        return securityFlags_;
    }
    const uint32_t&
    securityFlags() const
    {
        return securityFlags_;
    }

    uint32_t&
    contentPolicyType()
    {
        return contentPolicyType_;
    }
    const uint32_t&
    contentPolicyType() const
    {
        return contentPolicyType_;
    }

private:
    void
    Init();

    void
    Assign(
            const URIParams& _uri,
            const uint64_t& _startPos,
            const nsCString& _entityID,
            const OptionalInputStreamParams& _uploadStream,
            const PrincipalInfo& _requestingPrincipalInfo,
            const uint32_t& _securityFlags,
            const uint32_t& _contentPolicyType);

    URIParams uri_;
    uint64_t startPos_;
    nsCString entityID_;
    OptionalInputStreamParams uploadStream_;
    PrincipalInfo requestingPrincipalInfo_;
    uint32_t securityFlags_;
    uint32_t contentPolicyType_;
};
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FTPChannelConnectArgs|
//
namespace mozilla {
namespace net {
class FTPChannelConnectArgs MOZ_FINAL
{
private:

public:
    MOZ_IMPLICIT FTPChannelConnectArgs();

    MOZ_IMPLICIT FTPChannelConnectArgs(const uint32_t& _channelId)
    {
        Init();
        Assign(_channelId);
    }

    MOZ_IMPLICIT FTPChannelConnectArgs(const FTPChannelConnectArgs& _o)
    {
        Init();
        Assign((_o).channelId());
    }

    ~FTPChannelConnectArgs();

    void
    operator=(const FTPChannelConnectArgs& _o)
    {
        Assign((_o).channelId());
    }

    bool
    operator==(const FTPChannelConnectArgs& _o) const;

    uint32_t&
    channelId()
    {
        return channelId_;
    }
    const uint32_t&
    channelId() const
    {
        return channelId_;
    }

private:
    void
    Init();

    void
    Assign(const uint32_t& _channelId);

    uint32_t channelId_;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class FTPChannelOpenArgs;
} // namespace net
} // namespace mozilla
namespace mozilla {
namespace net {
class FTPChannelConnectArgs;
} // namespace net
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FTPChannelCreationArgs|
//
namespace mozilla {
namespace net {
class FTPChannelCreationArgs MOZ_FINAL
{
public:
    enum Type {
        T__None,
        TFTPChannelOpenArgs = 1,
        TFTPChannelConnectArgs,
        T__Last = TFTPChannelConnectArgs
    };

private:
    typedef mozilla::net::FTPChannelOpenArgs FTPChannelOpenArgs;
    typedef mozilla::net::FTPChannelConnectArgs FTPChannelConnectArgs;
    typedef FTPChannelOpenArgs FTPChannelOpenArgs__tdef;
    typedef FTPChannelConnectArgs FTPChannelConnectArgs__tdef;

    union Value {
        char VFTPChannelOpenArgs[sizeof(FTPChannelOpenArgs)];
        char VFTPChannelConnectArgs[sizeof(FTPChannelConnectArgs)];
    };

    FTPChannelOpenArgs*
    ptr_FTPChannelOpenArgs()
    {
        return reinterpret_cast<FTPChannelOpenArgs*>((&((mValue).VFTPChannelOpenArgs)));
    }
    const FTPChannelOpenArgs* const
    constptr_FTPChannelOpenArgs() const
    {
        return reinterpret_cast<const FTPChannelOpenArgs* const>((&((mValue).VFTPChannelOpenArgs)));
    }
    FTPChannelConnectArgs*
    ptr_FTPChannelConnectArgs()
    {
        return reinterpret_cast<FTPChannelConnectArgs*>((&((mValue).VFTPChannelConnectArgs)));
    }
    const FTPChannelConnectArgs* const
    constptr_FTPChannelConnectArgs() const
    {
        return reinterpret_cast<const FTPChannelConnectArgs* const>((&((mValue).VFTPChannelConnectArgs)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__None) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FTPChannelCreationArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelOpenArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelConnectArgs& aOther);

    MOZ_IMPLICIT FTPChannelCreationArgs(const FTPChannelCreationArgs& aOther);

    ~FTPChannelCreationArgs();

    Type
    type() const
    {
        return mType;
    }

    FTPChannelCreationArgs&
    operator=(const FTPChannelOpenArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(const FTPChannelConnectArgs& aRhs);

    FTPChannelCreationArgs&
    operator=(const FTPChannelCreationArgs& aRhs);

    bool
    operator==(const FTPChannelOpenArgs& aRhs) const;

    bool
    operator==(const FTPChannelConnectArgs& aRhs) const;

    bool
    operator==(const FTPChannelCreationArgs& aRhs) const;

    FTPChannelOpenArgs&
    get_FTPChannelOpenArgs()
    {
        AssertSanity(TFTPChannelOpenArgs);
        return (*(ptr_FTPChannelOpenArgs()));
    }
    const FTPChannelOpenArgs&
    get_FTPChannelOpenArgs() const
    {
        AssertSanity(TFTPChannelOpenArgs);
        return (*(constptr_FTPChannelOpenArgs()));
    }
    operator FTPChannelOpenArgs&()
    {
        return get_FTPChannelOpenArgs();
    }
    operator const FTPChannelOpenArgs&() const
    {
        return get_FTPChannelOpenArgs();
    }

    FTPChannelConnectArgs&
    get_FTPChannelConnectArgs()
    {
        AssertSanity(TFTPChannelConnectArgs);
        return (*(ptr_FTPChannelConnectArgs()));
    }
    const FTPChannelConnectArgs&
    get_FTPChannelConnectArgs() const
    {
        AssertSanity(TFTPChannelConnectArgs);
        return (*(constptr_FTPChannelConnectArgs()));
    }
    operator FTPChannelConnectArgs&()
    {
        return get_FTPChannelConnectArgs();
    }
    operator const FTPChannelConnectArgs&() const
    {
        return get_FTPChannelConnectArgs();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PHttpChannelParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PHttpChannelChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PFTPChannelParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PFTPChannelChild;
} // namespace net
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union ChannelDiverterArgs|
//
namespace mozilla {
namespace net {
class ChannelDiverterArgs MOZ_FINAL
{
public:
    enum Type {
        T__None,
        TPHttpChannelParent = 1,
        TPHttpChannelChild,
        TPFTPChannelParent,
        TPFTPChannelChild,
        T__Last = TPFTPChannelChild
    };

private:
    typedef mozilla::net::PHttpChannelParent PHttpChannelParent;
    typedef mozilla::net::PHttpChannelChild PHttpChannelChild;
    typedef mozilla::net::PFTPChannelParent PFTPChannelParent;
    typedef mozilla::net::PFTPChannelChild PFTPChannelChild;
    typedef PHttpChannelParent* PHttpChannelParent__tdef;
    typedef PHttpChannelChild* PHttpChannelChild__tdef;
    typedef PFTPChannelParent* PFTPChannelParent__tdef;
    typedef PFTPChannelChild* PFTPChannelChild__tdef;

    union Value {
        char VPHttpChannelParent[sizeof(PHttpChannelParent*)];
        char VPHttpChannelChild[sizeof(PHttpChannelChild*)];
        char VPFTPChannelParent[sizeof(PFTPChannelParent*)];
        char VPFTPChannelChild[sizeof(PFTPChannelChild*)];
    };

    PHttpChannelParent**
    ptr_PHttpChannelParent()
    {
        return reinterpret_cast<PHttpChannelParent**>((&((mValue).VPHttpChannelParent)));
    }
    PHttpChannelParent* const*
    constptr_PHttpChannelParent() const
    {
        return reinterpret_cast<PHttpChannelParent* const*>((&((mValue).VPHttpChannelParent)));
    }
    PHttpChannelChild**
    ptr_PHttpChannelChild()
    {
        return reinterpret_cast<PHttpChannelChild**>((&((mValue).VPHttpChannelChild)));
    }
    PHttpChannelChild* const*
    constptr_PHttpChannelChild() const
    {
        return reinterpret_cast<PHttpChannelChild* const*>((&((mValue).VPHttpChannelChild)));
    }
    PFTPChannelParent**
    ptr_PFTPChannelParent()
    {
        return reinterpret_cast<PFTPChannelParent**>((&((mValue).VPFTPChannelParent)));
    }
    PFTPChannelParent* const*
    constptr_PFTPChannelParent() const
    {
        return reinterpret_cast<PFTPChannelParent* const*>((&((mValue).VPFTPChannelParent)));
    }
    PFTPChannelChild**
    ptr_PFTPChannelChild()
    {
        return reinterpret_cast<PFTPChannelChild**>((&((mValue).VPFTPChannelChild)));
    }
    PFTPChannelChild* const*
    constptr_PFTPChannelChild() const
    {
        return reinterpret_cast<PFTPChannelChild* const*>((&((mValue).VPFTPChannelChild)));
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        NS_ABORT_IF_FALSE((T__None) <= (mType), "invalid type tag");
        NS_ABORT_IF_FALSE((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        NS_ABORT_IF_FALSE((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT ChannelDiverterArgs() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT ChannelDiverterArgs(PHttpChannelParent* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PHttpChannelChild* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PFTPChannelParent* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(PFTPChannelChild* aOther);

    MOZ_IMPLICIT ChannelDiverterArgs(const ChannelDiverterArgs& aOther);

    ~ChannelDiverterArgs();

    Type
    type() const
    {
        return mType;
    }

    ChannelDiverterArgs&
    operator=(PHttpChannelParent* aRhs);

    ChannelDiverterArgs&
    operator=(PHttpChannelChild* aRhs);

    ChannelDiverterArgs&
    operator=(PFTPChannelParent* aRhs);

    ChannelDiverterArgs&
    operator=(PFTPChannelChild* aRhs);

    ChannelDiverterArgs&
    operator=(const ChannelDiverterArgs& aRhs);

    bool
    operator==(PHttpChannelParent* aRhs) const;

    bool
    operator==(PHttpChannelChild* aRhs) const;

    bool
    operator==(PFTPChannelParent* aRhs) const;

    bool
    operator==(PFTPChannelChild* aRhs) const;

    bool
    operator==(const ChannelDiverterArgs& aRhs) const;

    PHttpChannelParent*&
    get_PHttpChannelParent()
    {
        AssertSanity(TPHttpChannelParent);
        return (*(ptr_PHttpChannelParent()));
    }
    PHttpChannelParent*
    get_PHttpChannelParent() const
    {
        AssertSanity(TPHttpChannelParent);
        return (*(constptr_PHttpChannelParent()));
    }
    operator PHttpChannelParent*&()
    {
        return get_PHttpChannelParent();
    }
    operator PHttpChannelParent*() const
    {
        return get_PHttpChannelParent();
    }

    PHttpChannelChild*&
    get_PHttpChannelChild()
    {
        AssertSanity(TPHttpChannelChild);
        return (*(ptr_PHttpChannelChild()));
    }
    PHttpChannelChild*
    get_PHttpChannelChild() const
    {
        AssertSanity(TPHttpChannelChild);
        return (*(constptr_PHttpChannelChild()));
    }
    operator PHttpChannelChild*&()
    {
        return get_PHttpChannelChild();
    }
    operator PHttpChannelChild*() const
    {
        return get_PHttpChannelChild();
    }

    PFTPChannelParent*&
    get_PFTPChannelParent()
    {
        AssertSanity(TPFTPChannelParent);
        return (*(ptr_PFTPChannelParent()));
    }
    PFTPChannelParent*
    get_PFTPChannelParent() const
    {
        AssertSanity(TPFTPChannelParent);
        return (*(constptr_PFTPChannelParent()));
    }
    operator PFTPChannelParent*&()
    {
        return get_PFTPChannelParent();
    }
    operator PFTPChannelParent*() const
    {
        return get_PFTPChannelParent();
    }

    PFTPChannelChild*&
    get_PFTPChannelChild()
    {
        AssertSanity(TPFTPChannelChild);
        return (*(ptr_PFTPChannelChild()));
    }
    PFTPChannelChild*
    get_PFTPChannelChild() const
    {
        AssertSanity(TPFTPChannelChild);
        return (*(constptr_PFTPChannelChild()));
    }
    operator PFTPChannelChild*&()
    {
        return get_PFTPChannelChild();
    }
    operator PFTPChannelChild*() const
    {
        return get_PFTPChannelChild();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace ipc {
class URIParams;
} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct RtspChannelConnectArgs|
//
namespace mozilla {
namespace net {
class RtspChannelConnectArgs MOZ_FINAL
{
private:
    typedef mozilla::ipc::URIParams URIParams;

public:
    MOZ_IMPLICIT RtspChannelConnectArgs();

    MOZ_IMPLICIT RtspChannelConnectArgs(
            const URIParams& _uri,
            const uint32_t& _channelId)
    {
        Init();
        Assign(_uri, _channelId);
    }

    MOZ_IMPLICIT RtspChannelConnectArgs(const RtspChannelConnectArgs& _o)
    {
        Init();
        Assign((_o).uri(), (_o).channelId());
    }

    ~RtspChannelConnectArgs();

    void
    operator=(const RtspChannelConnectArgs& _o)
    {
        Assign((_o).uri(), (_o).channelId());
    }

    bool
    operator==(const RtspChannelConnectArgs& _o) const;

    URIParams&
    uri()
    {
        return uri_;
    }
    const URIParams&
    uri() const
    {
        return uri_;
    }

    uint32_t&
    channelId()
    {
        return channelId_;
    }
    const uint32_t&
    channelId() const
    {
        return channelId_;
    }

private:
    void
    Init();

    void
    Assign(
            const URIParams& _uri,
            const uint32_t& _channelId);

    URIParams uri_;
    uint32_t channelId_;
};
} // namespace net
} // namespace mozilla

#endif // ifndef NeckoChannelParams_h
