//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PFTPChannelChild_h
#define PFTPChannelChild_h

#include "mozilla/net/PFTPChannel.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "prtime.h"

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PFTPChannelChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PNeckoChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::BufferedInputStreamParams BufferedInputStreamParams;
    typedef mozilla::net::ChannelDiverterArgs ChannelDiverterArgs;
    typedef mozilla::ipc::ContentPrincipalInfo ContentPrincipalInfo;
    typedef mozilla::net::FTPChannelConnectArgs FTPChannelConnectArgs;
    typedef mozilla::net::FTPChannelCreationArgs FTPChannelCreationArgs;
    typedef mozilla::net::FTPChannelOpenArgs FTPChannelOpenArgs;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;
    typedef mozilla::ipc::GenericURIParams GenericURIParams;
    typedef mozilla::net::HttpChannelConnectArgs HttpChannelConnectArgs;
    typedef mozilla::net::HttpChannelCreationArgs HttpChannelCreationArgs;
    typedef mozilla::net::HttpChannelOpenArgs HttpChannelOpenArgs;
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef mozilla::ipc::JARURIParams JARURIParams;
    typedef mozilla::ipc::MIMEInputStreamParams MIMEInputStreamParams;
    typedef mozilla::ipc::MultiplexInputStreamParams MultiplexInputStreamParams;
    typedef mozilla::ipc::NullPrincipalInfo NullPrincipalInfo;
    typedef mozilla::ipc::OptionalFileDescriptorSet OptionalFileDescriptorSet;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::ipc::PartialFileInputStreamParams PartialFileInputStreamParams;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::ipc::RemoteInputStreamParams RemoteInputStreamParams;
    typedef mozilla::net::RtspChannelConnectArgs RtspChannelConnectArgs;
    typedef mozilla::ipc::SameProcessInputStreamParams SameProcessInputStreamParams;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SimpleURIParams SimpleURIParams;
    typedef mozilla::ipc::StandardURLParams StandardURLParams;
    typedef mozilla::ipc::StandardURLSegment StandardURLSegment;
    typedef mozilla::ipc::StringInputStreamParams StringInputStreamParams;
    typedef mozilla::ipc::SystemPrincipalInfo SystemPrincipalInfo;
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef mozilla::dom::PBlobChild PBlobChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PFTPChannel::State State;

    virtual bool
    RecvOnStartRequest(
            const nsresult& aChannelStatus,
            const int64_t& aContentLength,
            const nsCString& aContentType,
            const PRTime& aLastModified,
            const nsCString& aEntityID,
            const URIParams& aURI) = 0;
    virtual bool
    RecvOnDataAvailable(
            const nsresult& channelStatus,
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count) = 0;
    virtual bool
    RecvOnStopRequest(const nsresult& channelStatus) = 0;
    virtual bool
    RecvFailedAsyncOpen(const nsresult& statusCode) = 0;
    virtual bool
    RecvFlushedForDiversion() = 0;
    virtual bool
    RecvDivertMessages() = 0;
    virtual bool
    RecvDeleteSelf() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PFTPChannelChild();

    virtual ~PFTPChannelChild();

    PNeckoChild*
    Manager() const;

    PFTPChannel::State
    state();

    static bool
    Send__delete__(PFTPChannelChild* actor);

    bool
    SendCancel(const nsresult& status);

    bool
    SendSuspend();

    bool
    SendResume();

    bool
    SendDivertOnDataAvailable(
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count);

    bool
    SendDivertOnStopRequest(const nsresult& statusCode);

    bool
    SendDivertComplete();

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const JARURIParams& __v,
            Message* __msg);

    bool
    Read(
            JARURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLParams& __v,
            Message* __msg);

    bool
    Read(
            StandardURLParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GenericURIParams& __v,
            Message* __msg);

    bool
    Read(
            GenericURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLSegment& __v,
            Message* __msg);

    bool
    Read(
            StandardURLSegment* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PFTPChannelChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PFTPChannelChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const URIParams& __v,
            Message* __msg);

    bool
    Read(
            URIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SimpleURIParams& __v,
            Message* __msg);

    bool
    Read(
            SimpleURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class FTPChannelChild :
    public PFTPChannelChild
{
    virtual bool
    RecvOnStartRequest(
            const nsresult& aChannelStatus,
            const int64_t& aContentLength,
            const nsCString& aContentType,
            const PRTime& aLastModified,
            const nsCString& aEntityID,
            const URIParams& aURI);

    virtual bool
    RecvOnDataAvailable(
            const nsresult& channelStatus,
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count);

    virtual bool
    RecvOnStopRequest(const nsresult& channelStatus);

    virtual bool
    RecvFailedAsyncOpen(const nsresult& statusCode);

    virtual bool
    RecvFlushedForDiversion();

    virtual bool
    RecvDivertMessages();

    virtual bool
    RecvDeleteSelf();

    MOZ_IMPLICIT FTPChannelChild();
    virtual ~FTPChannelChild();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
FTPChannelChild::RecvOnStartRequest(
        const nsresult& aChannelStatus,
        const int64_t& aContentLength,
        const nsCString& aContentType,
        const PRTime& aLastModified,
        const nsCString& aEntityID,
        const URIParams& aURI)
{
    return false;
}

bool
FTPChannelChild::RecvOnDataAvailable(
        const nsresult& channelStatus,
        const nsCString& data,
        const uint64_t& offset,
        const uint32_t& count)
{
    return false;
}

bool
FTPChannelChild::RecvOnStopRequest(const nsresult& channelStatus)
{
    return false;
}

bool
FTPChannelChild::RecvFailedAsyncOpen(const nsresult& statusCode)
{
    return false;
}

bool
FTPChannelChild::RecvFlushedForDiversion()
{
    return false;
}

bool
FTPChannelChild::RecvDivertMessages()
{
    return false;
}

bool
FTPChannelChild::RecvDeleteSelf()
{
    return false;
}

MOZ_IMPLICIT FTPChannelChild::FTPChannelChild()
{
    MOZ_COUNT_CTOR(FTPChannelChild);
}

MOZ_IMPLICIT FTPChannelChild::~FTPChannelChild()
{
    MOZ_COUNT_DTOR(FTPChannelChild);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PFTPChannelChild_h
