//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHttpChannelChild_h
#define PHttpChannelChild_h

#include "mozilla/net/PHttpChannel.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/net/DNS.h"
#include "mozilla/net/NeckoMessageUtils.h"
#include "mozilla/net/PHttpChannelParams.h"

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

class nsHttpHeaderArray;

class nsHttpResponseHead;

struct nsHttpAtom;

namespace mozilla {
namespace net {
struct ResourceTimingStruct;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PHttpChannelChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PNeckoChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::BufferedInputStreamParams BufferedInputStreamParams;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;
    typedef mozilla::ipc::GenericURIParams GenericURIParams;
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef mozilla::ipc::JARURIParams JARURIParams;
    typedef mozilla::ipc::MIMEInputStreamParams MIMEInputStreamParams;
    typedef mozilla::ipc::MultiplexInputStreamParams MultiplexInputStreamParams;
    typedef mozilla::net::NetAddr NetAddr;
    typedef mozilla::ipc::OptionalFileDescriptorSet OptionalFileDescriptorSet;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::ipc::PartialFileInputStreamParams PartialFileInputStreamParams;
    typedef mozilla::ipc::RemoteInputStreamParams RemoteInputStreamParams;
    typedef mozilla::net::ResourceTimingStruct ResourceTimingStruct;
    typedef mozilla::ipc::SameProcessInputStreamParams SameProcessInputStreamParams;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SimpleURIParams SimpleURIParams;
    typedef mozilla::ipc::StandardURLParams StandardURLParams;
    typedef mozilla::ipc::StandardURLSegment StandardURLSegment;
    typedef mozilla::ipc::StringInputStreamParams StringInputStreamParams;
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef mozilla::dom::PBlobChild PBlobChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PHttpChannel::State State;

    virtual bool
    RecvOnStartRequest(
            const nsresult& channelStatus,
            const nsHttpResponseHead& responseHead,
            const bool& useResponseHead,
            const nsHttpHeaderArray& requestHeaders,
            const bool& isFromCache,
            const bool& cacheEntryAvailable,
            const uint32_t& cacheExpirationTime,
            const nsCString& cachedCharset,
            const nsCString& securityInfoSerialization,
            const NetAddr& selfAddr,
            const NetAddr& peerAddr,
            const int16_t& redirectCount) = 0;
    virtual bool
    RecvOnTransportAndData(
            const nsresult& channelStatus,
            const nsresult& transportStatus,
            const uint64_t& progress,
            const uint64_t& progressMax,
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count) = 0;
    virtual bool
    RecvOnStopRequest(
            const nsresult& channelStatus,
            const ResourceTimingStruct& timing) = 0;
    virtual bool
    RecvOnProgress(
            const uint64_t& progress,
            const uint64_t& progressMax) = 0;
    virtual bool
    RecvOnStatus(const nsresult& status) = 0;
    virtual bool
    RecvFailedAsyncOpen(const nsresult& status) = 0;
    virtual bool
    RecvRedirect1Begin(
            const uint32_t& newChannelId,
            const URIParams& newUri,
            const uint32_t& redirectFlags,
            const nsHttpResponseHead& responseHead) = 0;
    virtual bool
    RecvRedirect3Complete() = 0;
    virtual bool
    RecvAssociateApplicationCache(
            const nsCString& groupID,
            const nsCString& clientID) = 0;
    virtual bool
    RecvFlushedForDiversion() = 0;
    virtual bool
    RecvDivertMessages() = 0;
    virtual bool
    RecvDeleteSelf() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PHttpChannelChild();

    virtual ~PHttpChannelChild();

    PNeckoChild*
    Manager() const;

    PHttpChannel::State
    state();

    bool
    SendSetPriority(const uint16_t& priority);

    bool
    SendSetCacheTokenCachedCharset(const nsCString& charset);

    bool
    SendUpdateAssociatedContentSecurity(
            const int32_t& broken,
            const int32_t& no);

    bool
    SendSuspend();

    bool
    SendResume();

    bool
    SendCancel(const nsresult& status);

    bool
    SendRedirect2Verify(
            const nsresult& result,
            const RequestHeaderTuples& changedHeaders,
            const OptionalURIParams& apiRedirectTo);

    bool
    SendDocumentChannelCleanup();

    bool
    SendMarkOfflineCacheEntryAsForeign();

    bool
    SendDivertOnDataAvailable(
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count);

    bool
    SendDivertOnStopRequest(const nsresult& statusCode);

    bool
    SendDivertComplete();

    static bool
    Send__delete__(PHttpChannelChild* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PHttpChannelChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PHttpChannelChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const JARURIParams& __v,
            Message* __msg);

    bool
    Read(
            JARURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const OptionalURIParams& __v,
            Message* __msg);

    bool
    Read(
            OptionalURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLParams& __v,
            Message* __msg);

    bool
    Read(
            StandardURLParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GenericURIParams& __v,
            Message* __msg);

    bool
    Read(
            GenericURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLSegment& __v,
            Message* __msg);

    bool
    Read(
            StandardURLSegment* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const URIParams& __v,
            Message* __msg);

    bool
    Read(
            URIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SimpleURIParams& __v,
            Message* __msg);

    bool
    Read(
            SimpleURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class HttpChannelChild :
    public PHttpChannelChild
{
    virtual bool
    RecvOnStartRequest(
            const nsresult& channelStatus,
            const nsHttpResponseHead& responseHead,
            const bool& useResponseHead,
            const nsHttpHeaderArray& requestHeaders,
            const bool& isFromCache,
            const bool& cacheEntryAvailable,
            const uint32_t& cacheExpirationTime,
            const nsCString& cachedCharset,
            const nsCString& securityInfoSerialization,
            const NetAddr& selfAddr,
            const NetAddr& peerAddr,
            const int16_t& redirectCount);

    virtual bool
    RecvOnTransportAndData(
            const nsresult& channelStatus,
            const nsresult& transportStatus,
            const uint64_t& progress,
            const uint64_t& progressMax,
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count);

    virtual bool
    RecvOnStopRequest(
            const nsresult& channelStatus,
            const ResourceTimingStruct& timing);

    virtual bool
    RecvOnProgress(
            const uint64_t& progress,
            const uint64_t& progressMax);

    virtual bool
    RecvOnStatus(const nsresult& status);

    virtual bool
    RecvFailedAsyncOpen(const nsresult& status);

    virtual bool
    RecvRedirect1Begin(
            const uint32_t& newChannelId,
            const URIParams& newUri,
            const uint32_t& redirectFlags,
            const nsHttpResponseHead& responseHead);

    virtual bool
    RecvRedirect3Complete();

    virtual bool
    RecvAssociateApplicationCache(
            const nsCString& groupID,
            const nsCString& clientID);

    virtual bool
    RecvFlushedForDiversion();

    virtual bool
    RecvDivertMessages();

    virtual bool
    RecvDeleteSelf();

    MOZ_IMPLICIT HttpChannelChild();
    virtual ~HttpChannelChild();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
HttpChannelChild::RecvOnStartRequest(
        const nsresult& channelStatus,
        const nsHttpResponseHead& responseHead,
        const bool& useResponseHead,
        const nsHttpHeaderArray& requestHeaders,
        const bool& isFromCache,
        const bool& cacheEntryAvailable,
        const uint32_t& cacheExpirationTime,
        const nsCString& cachedCharset,
        const nsCString& securityInfoSerialization,
        const NetAddr& selfAddr,
        const NetAddr& peerAddr,
        const int16_t& redirectCount)
{
    return false;
}

bool
HttpChannelChild::RecvOnTransportAndData(
        const nsresult& channelStatus,
        const nsresult& transportStatus,
        const uint64_t& progress,
        const uint64_t& progressMax,
        const nsCString& data,
        const uint64_t& offset,
        const uint32_t& count)
{
    return false;
}

bool
HttpChannelChild::RecvOnStopRequest(
        const nsresult& channelStatus,
        const ResourceTimingStruct& timing)
{
    return false;
}

bool
HttpChannelChild::RecvOnProgress(
        const uint64_t& progress,
        const uint64_t& progressMax)
{
    return false;
}

bool
HttpChannelChild::RecvOnStatus(const nsresult& status)
{
    return false;
}

bool
HttpChannelChild::RecvFailedAsyncOpen(const nsresult& status)
{
    return false;
}

bool
HttpChannelChild::RecvRedirect1Begin(
        const uint32_t& newChannelId,
        const URIParams& newUri,
        const uint32_t& redirectFlags,
        const nsHttpResponseHead& responseHead)
{
    return false;
}

bool
HttpChannelChild::RecvRedirect3Complete()
{
    return false;
}

bool
HttpChannelChild::RecvAssociateApplicationCache(
        const nsCString& groupID,
        const nsCString& clientID)
{
    return false;
}

bool
HttpChannelChild::RecvFlushedForDiversion()
{
    return false;
}

bool
HttpChannelChild::RecvDivertMessages()
{
    return false;
}

bool
HttpChannelChild::RecvDeleteSelf()
{
    return false;
}

MOZ_IMPLICIT HttpChannelChild::HttpChannelChild()
{
    MOZ_COUNT_CTOR(HttpChannelChild);
}

MOZ_IMPLICIT HttpChannelChild::~HttpChannelChild()
{
    MOZ_COUNT_DTOR(HttpChannelChild);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PHttpChannelChild_h
