//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHttpChannelParent_h
#define PHttpChannelParent_h

#include "mozilla/net/PHttpChannel.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/net/DNS.h"
#include "mozilla/net/NeckoMessageUtils.h"
#include "mozilla/net/PHttpChannelParams.h"

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

class nsHttpHeaderArray;

class nsHttpResponseHead;

struct nsHttpAtom;

namespace mozilla {
namespace net {
struct ResourceTimingStruct;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PHttpChannelParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PNeckoParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::BufferedInputStreamParams BufferedInputStreamParams;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;
    typedef mozilla::ipc::GenericURIParams GenericURIParams;
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef mozilla::ipc::JARURIParams JARURIParams;
    typedef mozilla::ipc::MIMEInputStreamParams MIMEInputStreamParams;
    typedef mozilla::ipc::MultiplexInputStreamParams MultiplexInputStreamParams;
    typedef mozilla::net::NetAddr NetAddr;
    typedef mozilla::ipc::OptionalFileDescriptorSet OptionalFileDescriptorSet;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::ipc::PartialFileInputStreamParams PartialFileInputStreamParams;
    typedef mozilla::ipc::RemoteInputStreamParams RemoteInputStreamParams;
    typedef mozilla::net::ResourceTimingStruct ResourceTimingStruct;
    typedef mozilla::ipc::SameProcessInputStreamParams SameProcessInputStreamParams;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SimpleURIParams SimpleURIParams;
    typedef mozilla::ipc::StandardURLParams StandardURLParams;
    typedef mozilla::ipc::StandardURLSegment StandardURLSegment;
    typedef mozilla::ipc::StringInputStreamParams StringInputStreamParams;
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PHttpChannel::State State;

    virtual bool
    RecvSetPriority(const uint16_t& priority) = 0;
    virtual bool
    RecvSetCacheTokenCachedCharset(const nsCString& charset) = 0;
    virtual bool
    RecvUpdateAssociatedContentSecurity(
            const int32_t& broken,
            const int32_t& no) = 0;
    virtual bool
    RecvSuspend() = 0;
    virtual bool
    RecvResume() = 0;
    virtual bool
    RecvCancel(const nsresult& status) = 0;
    virtual bool
    RecvRedirect2Verify(
            const nsresult& result,
            const RequestHeaderTuples& changedHeaders,
            const OptionalURIParams& apiRedirectTo) = 0;
    virtual bool
    RecvDocumentChannelCleanup() = 0;
    virtual bool
    RecvMarkOfflineCacheEntryAsForeign() = 0;
    virtual bool
    RecvDivertOnDataAvailable(
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count) = 0;
    virtual bool
    RecvDivertOnStopRequest(const nsresult& statusCode) = 0;
    virtual bool
    RecvDivertComplete() = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PHttpChannelParent();

    virtual ~PHttpChannelParent();

    PNeckoParent*
    Manager() const;

    PHttpChannel::State
    state();

    bool
    SendOnStartRequest(
            const nsresult& channelStatus,
            const nsHttpResponseHead& responseHead,
            const bool& useResponseHead,
            const nsHttpHeaderArray& requestHeaders,
            const bool& isFromCache,
            const bool& cacheEntryAvailable,
            const uint32_t& cacheExpirationTime,
            const nsCString& cachedCharset,
            const nsCString& securityInfoSerialization,
            const NetAddr& selfAddr,
            const NetAddr& peerAddr,
            const int16_t& redirectCount) NS_WARN_UNUSED_RESULT;

    bool
    SendOnTransportAndData(
            const nsresult& channelStatus,
            const nsresult& transportStatus,
            const uint64_t& progress,
            const uint64_t& progressMax,
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count) NS_WARN_UNUSED_RESULT;

    bool
    SendOnStopRequest(
            const nsresult& channelStatus,
            const ResourceTimingStruct& timing) NS_WARN_UNUSED_RESULT;

    bool
    SendOnProgress(
            const uint64_t& progress,
            const uint64_t& progressMax) NS_WARN_UNUSED_RESULT;

    bool
    SendOnStatus(const nsresult& status) NS_WARN_UNUSED_RESULT;

    bool
    SendFailedAsyncOpen(const nsresult& status) NS_WARN_UNUSED_RESULT;

    bool
    SendRedirect1Begin(
            const uint32_t& newChannelId,
            const URIParams& newUri,
            const uint32_t& redirectFlags,
            const nsHttpResponseHead& responseHead) NS_WARN_UNUSED_RESULT;

    bool
    SendRedirect3Complete() NS_WARN_UNUSED_RESULT;

    bool
    SendAssociateApplicationCache(
            const nsCString& groupID,
            const nsCString& clientID) NS_WARN_UNUSED_RESULT;

    bool
    SendFlushedForDiversion() NS_WARN_UNUSED_RESULT;

    bool
    SendDivertMessages() NS_WARN_UNUSED_RESULT;

    bool
    SendDeleteSelf() NS_WARN_UNUSED_RESULT;

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PHttpChannelParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PHttpChannelParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const JARURIParams& __v,
            Message* __msg);

    bool
    Read(
            JARURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const OptionalURIParams& __v,
            Message* __msg);

    bool
    Read(
            OptionalURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLParams& __v,
            Message* __msg);

    bool
    Read(
            StandardURLParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GenericURIParams& __v,
            Message* __msg);

    bool
    Read(
            GenericURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLSegment& __v,
            Message* __msg);

    bool
    Read(
            StandardURLSegment* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const URIParams& __v,
            Message* __msg);

    bool
    Read(
            URIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SimpleURIParams& __v,
            Message* __msg);

    bool
    Read(
            SimpleURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class HttpChannelParent :
    public PHttpChannelParent
{
    virtual bool
    RecvSetPriority(const uint16_t& priority);

    virtual bool
    RecvSetCacheTokenCachedCharset(const nsCString& charset);

    virtual bool
    RecvUpdateAssociatedContentSecurity(
            const int32_t& broken,
            const int32_t& no);

    virtual bool
    RecvSuspend();

    virtual bool
    RecvResume();

    virtual bool
    RecvCancel(const nsresult& status);

    virtual bool
    RecvRedirect2Verify(
            const nsresult& result,
            const RequestHeaderTuples& changedHeaders,
            const OptionalURIParams& apiRedirectTo);

    virtual bool
    RecvDocumentChannelCleanup();

    virtual bool
    RecvMarkOfflineCacheEntryAsForeign();

    virtual bool
    RecvDivertOnDataAvailable(
            const nsCString& data,
            const uint64_t& offset,
            const uint32_t& count);

    virtual bool
    RecvDivertOnStopRequest(const nsresult& statusCode);

    virtual bool
    RecvDivertComplete();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT HttpChannelParent();
    virtual ~HttpChannelParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
HttpChannelParent::RecvSetPriority(const uint16_t& priority)
{
    return false;
}

bool
HttpChannelParent::RecvSetCacheTokenCachedCharset(const nsCString& charset)
{
    return false;
}

bool
HttpChannelParent::RecvUpdateAssociatedContentSecurity(
        const int32_t& broken,
        const int32_t& no)
{
    return false;
}

bool
HttpChannelParent::RecvSuspend()
{
    return false;
}

bool
HttpChannelParent::RecvResume()
{
    return false;
}

bool
HttpChannelParent::RecvCancel(const nsresult& status)
{
    return false;
}

bool
HttpChannelParent::RecvRedirect2Verify(
        const nsresult& result,
        const RequestHeaderTuples& changedHeaders,
        const OptionalURIParams& apiRedirectTo)
{
    return false;
}

bool
HttpChannelParent::RecvDocumentChannelCleanup()
{
    return false;
}

bool
HttpChannelParent::RecvMarkOfflineCacheEntryAsForeign()
{
    return false;
}

bool
HttpChannelParent::RecvDivertOnDataAvailable(
        const nsCString& data,
        const uint64_t& offset,
        const uint32_t& count)
{
    return false;
}

bool
HttpChannelParent::RecvDivertOnStopRequest(const nsresult& statusCode)
{
    return false;
}

bool
HttpChannelParent::RecvDivertComplete()
{
    return false;
}

void
HttpChannelParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT HttpChannelParent::HttpChannelParent()
{
    MOZ_COUNT_CTOR(HttpChannelParent);
}

MOZ_IMPLICIT HttpChannelParent::~HttpChannelParent()
{
    MOZ_COUNT_DTOR(HttpChannelParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PHttpChannelParent_h
