//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PRtspControllerChild_h
#define PRtspControllerChild_h

#include "mozilla/net/PRtspController.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PRtspControllerChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PNeckoChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::GenericURIParams GenericURIParams;
    typedef mozilla::ipc::JARURIParams JARURIParams;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::net::RtspMetaValue RtspMetaValue;
    typedef mozilla::net::RtspMetadataParam RtspMetadataParam;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SimpleURIParams SimpleURIParams;
    typedef mozilla::ipc::StandardURLParams StandardURLParams;
    typedef mozilla::ipc::StandardURLSegment StandardURLSegment;
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PRtspController::State State;

    virtual bool
    RecvOnMediaDataAvailable(
            const uint8_t& index,
            const nsCString& data,
            const uint32_t& length,
            const uint32_t& offset,
            const nsTArray<RtspMetadataParam>& meta) = 0;
    virtual bool
    RecvOnConnected(
            const uint8_t& index,
            const nsTArray<RtspMetadataParam>& meta) = 0;
    virtual bool
    RecvOnDisconnected(
            const uint8_t& index,
            const nsresult& reason) = 0;
    virtual bool
    RecvAsyncOpenFailed(const nsresult& reason) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PRtspControllerChild();

    virtual ~PRtspControllerChild();

    PNeckoChild*
    Manager() const;

    PRtspController::State
    state();

    bool
    SendAsyncOpen(const URIParams& aURI);

    bool
    SendPlay();

    bool
    SendPause();

    bool
    SendResume();

    bool
    SendSuspend();

    bool
    SendSeek(const uint64_t& offset);

    bool
    SendStop();

    bool
    SendPlaybackEnded();

    static bool
    Send__delete__(PRtspControllerChild* actor);

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PRtspControllerChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PRtspControllerChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const nsTArray<RtspMetadataParam>& __v,
            Message* __msg);

    bool
    Read(
            nsTArray<RtspMetadataParam>* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLParams& __v,
            Message* __msg);

    bool
    Read(
            StandardURLParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const RtspMetadataParam& __v,
            Message* __msg);

    bool
    Read(
            RtspMetadataParam* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const JARURIParams& __v,
            Message* __msg);

    bool
    Read(
            JARURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GenericURIParams& __v,
            Message* __msg);

    bool
    Read(
            GenericURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLSegment& __v,
            Message* __msg);

    bool
    Read(
            StandardURLSegment* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const URIParams& __v,
            Message* __msg);

    bool
    Read(
            URIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const RtspMetaValue& __v,
            Message* __msg);

    bool
    Read(
            RtspMetaValue* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SimpleURIParams& __v,
            Message* __msg);

    bool
    Read(
            SimpleURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class RtspControllerChild :
    public PRtspControllerChild
{
    virtual bool
    RecvOnMediaDataAvailable(
            const uint8_t& index,
            const nsCString& data,
            const uint32_t& length,
            const uint32_t& offset,
            const nsTArray<RtspMetadataParam>& meta);

    virtual bool
    RecvOnConnected(
            const uint8_t& index,
            const nsTArray<RtspMetadataParam>& meta);

    virtual bool
    RecvOnDisconnected(
            const uint8_t& index,
            const nsresult& reason);

    virtual bool
    RecvAsyncOpenFailed(const nsresult& reason);

    MOZ_IMPLICIT RtspControllerChild();
    virtual ~RtspControllerChild();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
RtspControllerChild::RecvOnMediaDataAvailable(
        const uint8_t& index,
        const nsCString& data,
        const uint32_t& length,
        const uint32_t& offset,
        const nsTArray<RtspMetadataParam>& meta)
{
    return false;
}

bool
RtspControllerChild::RecvOnConnected(
        const uint8_t& index,
        const nsTArray<RtspMetadataParam>& meta)
{
    return false;
}

bool
RtspControllerChild::RecvOnDisconnected(
        const uint8_t& index,
        const nsresult& reason)
{
    return false;
}

bool
RtspControllerChild::RecvAsyncOpenFailed(const nsresult& reason)
{
    return false;
}

MOZ_IMPLICIT RtspControllerChild::RtspControllerChild()
{
    MOZ_COUNT_CTOR(RtspControllerChild);
}

MOZ_IMPLICIT RtspControllerChild::~RtspControllerChild()
{
    MOZ_COUNT_DTOR(RtspControllerChild);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PRtspControllerChild_h
