//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PRtspControllerParent_h
#define PRtspControllerParent_h

#include "mozilla/net/PRtspController.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PRtspControllerParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PNeckoParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::GenericURIParams GenericURIParams;
    typedef mozilla::ipc::JARURIParams JARURIParams;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::net::RtspMetaValue RtspMetaValue;
    typedef mozilla::net::RtspMetadataParam RtspMetadataParam;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SimpleURIParams SimpleURIParams;
    typedef mozilla::ipc::StandardURLParams StandardURLParams;
    typedef mozilla::ipc::StandardURLSegment StandardURLSegment;
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PRtspController::State State;

    virtual bool
    RecvAsyncOpen(const URIParams& aURI) = 0;
    virtual bool
    RecvPlay() = 0;
    virtual bool
    RecvPause() = 0;
    virtual bool
    RecvResume() = 0;
    virtual bool
    RecvSuspend() = 0;
    virtual bool
    RecvSeek(const uint64_t& offset) = 0;
    virtual bool
    RecvStop() = 0;
    virtual bool
    RecvPlaybackEnded() = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PRtspControllerParent();

    virtual ~PRtspControllerParent();

    PNeckoParent*
    Manager() const;

    PRtspController::State
    state();

    bool
    SendOnMediaDataAvailable(
            const uint8_t& index,
            const nsCString& data,
            const uint32_t& length,
            const uint32_t& offset,
            const nsTArray<RtspMetadataParam>& meta) NS_WARN_UNUSED_RESULT;

    bool
    SendOnConnected(
            const uint8_t& index,
            const nsTArray<RtspMetadataParam>& meta) NS_WARN_UNUSED_RESULT;

    bool
    SendOnDisconnected(
            const uint8_t& index,
            const nsresult& reason) NS_WARN_UNUSED_RESULT;

    bool
    SendAsyncOpenFailed(const nsresult& reason) NS_WARN_UNUSED_RESULT;

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            PRtspControllerParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PRtspControllerParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const nsTArray<RtspMetadataParam>& __v,
            Message* __msg);

    bool
    Read(
            nsTArray<RtspMetadataParam>* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLParams& __v,
            Message* __msg);

    bool
    Read(
            StandardURLParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const RtspMetadataParam& __v,
            Message* __msg);

    bool
    Read(
            RtspMetadataParam* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const JARURIParams& __v,
            Message* __msg);

    bool
    Read(
            JARURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GenericURIParams& __v,
            Message* __msg);

    bool
    Read(
            GenericURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLSegment& __v,
            Message* __msg);

    bool
    Read(
            StandardURLSegment* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const URIParams& __v,
            Message* __msg);

    bool
    Read(
            URIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const RtspMetaValue& __v,
            Message* __msg);

    bool
    Read(
            RtspMetaValue* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SimpleURIParams& __v,
            Message* __msg);

    bool
    Read(
            SimpleURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class RtspControllerParent :
    public PRtspControllerParent
{
    virtual bool
    RecvAsyncOpen(const URIParams& aURI);

    virtual bool
    RecvPlay();

    virtual bool
    RecvPause();

    virtual bool
    RecvResume();

    virtual bool
    RecvSuspend();

    virtual bool
    RecvSeek(const uint64_t& offset);

    virtual bool
    RecvStop();

    virtual bool
    RecvPlaybackEnded();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT RtspControllerParent();
    virtual ~RtspControllerParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
RtspControllerParent::RecvAsyncOpen(const URIParams& aURI)
{
    return false;
}

bool
RtspControllerParent::RecvPlay()
{
    return false;
}

bool
RtspControllerParent::RecvPause()
{
    return false;
}

bool
RtspControllerParent::RecvResume()
{
    return false;
}

bool
RtspControllerParent::RecvSuspend()
{
    return false;
}

bool
RtspControllerParent::RecvSeek(const uint64_t& offset)
{
    return false;
}

bool
RtspControllerParent::RecvStop()
{
    return false;
}

bool
RtspControllerParent::RecvPlaybackEnded()
{
    return false;
}

void
RtspControllerParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT RtspControllerParent::RtspControllerParent()
{
    MOZ_COUNT_CTOR(RtspControllerParent);
}

MOZ_IMPLICIT RtspControllerParent::~RtspControllerParent()
{
    MOZ_COUNT_DTOR(RtspControllerParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PRtspControllerParent_h
