//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PUDPSocketChild_h
#define PUDPSocketChild_h

#include "mozilla/net/PUDPSocket.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/net/DNS.h"
#include "mozilla/net/NeckoMessageUtils.h"
#include "prio.h"

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PUDPSocketChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PNeckoChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::BufferedInputStreamParams BufferedInputStreamParams;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef mozilla::ipc::MIMEInputStreamParams MIMEInputStreamParams;
    typedef mozilla::ipc::MultiplexInputStreamParams MultiplexInputStreamParams;
    typedef mozilla::net::NetAddr NetAddr;
    typedef mozilla::ipc::OptionalFileDescriptorSet OptionalFileDescriptorSet;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::ipc::PartialFileInputStreamParams PartialFileInputStreamParams;
    typedef mozilla::ipc::RemoteInputStreamParams RemoteInputStreamParams;
    typedef mozilla::ipc::SameProcessInputStreamParams SameProcessInputStreamParams;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::StringInputStreamParams StringInputStreamParams;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef mozilla::dom::PBlobChild PBlobChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PUDPSocket::State State;

    virtual bool
    RecvCallbackOpened(const UDPAddressInfo& addressInfo) = 0;
    virtual bool
    RecvCallbackClosed() = 0;
    virtual bool
    RecvCallbackReceivedData(
            const UDPAddressInfo& addressInfo,
            const nsTArray<uint8_t>& data) = 0;
    virtual bool
    RecvCallbackError(
            const nsCString& message,
            const nsCString& filename,
            const uint32_t& lineNumber) = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PUDPSocketChild();

    virtual ~PUDPSocketChild();

    PNeckoChild*
    Manager() const;

    PUDPSocket::State
    state();

    bool
    SendBind(
            const UDPAddressInfo& addressInfo,
            const bool& addressReuse,
            const bool& loopback);

    bool
    SendOutgoingData(
            const UDPData& data,
            const UDPSocketAddr& addr);

    bool
    SendJoinMulticast(
            const nsCString& multicastAddress,
            const nsCString& iface);

    bool
    SendLeaveMulticast(
            const nsCString& multicastAddress,
            const nsCString& iface);

    bool
    SendClose();

    bool
    SendRequestDelete();

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const StringInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            StringInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const FileInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            FileInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PUDPSocketChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PUDPSocketChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const MultiplexInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            MultiplexInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const nsTArray<InputStreamParams>& __v,
            Message* __msg);

    bool
    Read(
            nsTArray<InputStreamParams>* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const OptionalInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            OptionalInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const MIMEInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            MIMEInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const InputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            InputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const BufferedInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            BufferedInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SameProcessInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            SameProcessInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const UDPSocketAddr& __v,
            Message* __msg);

    bool
    Read(
            UDPSocketAddr* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const PartialFileInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            PartialFileInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const RemoteInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            RemoteInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const UDPAddressInfo& __v,
            Message* __msg);

    bool
    Read(
            UDPAddressInfo* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const UDPData& __v,
            Message* __msg);

    bool
    Read(
            UDPData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class UDPSocketChild :
    public PUDPSocketChild
{
    virtual bool
    RecvCallbackOpened(const UDPAddressInfo& addressInfo);

    virtual bool
    RecvCallbackClosed();

    virtual bool
    RecvCallbackReceivedData(
            const UDPAddressInfo& addressInfo,
            const nsTArray<uint8_t>& data);

    virtual bool
    RecvCallbackError(
            const nsCString& message,
            const nsCString& filename,
            const uint32_t& lineNumber);

    MOZ_IMPLICIT UDPSocketChild();
    virtual ~UDPSocketChild();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
UDPSocketChild::RecvCallbackOpened(const UDPAddressInfo& addressInfo)
{
    return false;
}

bool
UDPSocketChild::RecvCallbackClosed()
{
    return false;
}

bool
UDPSocketChild::RecvCallbackReceivedData(
        const UDPAddressInfo& addressInfo,
        const nsTArray<uint8_t>& data)
{
    return false;
}

bool
UDPSocketChild::RecvCallbackError(
        const nsCString& message,
        const nsCString& filename,
        const uint32_t& lineNumber)
{
    return false;
}

MOZ_IMPLICIT UDPSocketChild::UDPSocketChild()
{
    MOZ_COUNT_CTOR(UDPSocketChild);
}

MOZ_IMPLICIT UDPSocketChild::~UDPSocketChild()
{
    MOZ_COUNT_DTOR(UDPSocketChild);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PUDPSocketChild_h
