//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PUDPSocketParent_h
#define PUDPSocketParent_h

#include "mozilla/net/PUDPSocket.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/net/DNS.h"
#include "mozilla/net/NeckoMessageUtils.h"
#include "prio.h"

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
struct void_t;
} // namespace mozilla

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PUDPSocketParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PNeckoParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::BufferedInputStreamParams BufferedInputStreamParams;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef mozilla::ipc::MIMEInputStreamParams MIMEInputStreamParams;
    typedef mozilla::ipc::MultiplexInputStreamParams MultiplexInputStreamParams;
    typedef mozilla::net::NetAddr NetAddr;
    typedef mozilla::ipc::OptionalFileDescriptorSet OptionalFileDescriptorSet;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::ipc::PartialFileInputStreamParams PartialFileInputStreamParams;
    typedef mozilla::ipc::RemoteInputStreamParams RemoteInputStreamParams;
    typedef mozilla::ipc::SameProcessInputStreamParams SameProcessInputStreamParams;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::StringInputStreamParams StringInputStreamParams;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef mozilla::dom::PBlobParent PBlobParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PUDPSocket::State State;

    virtual bool
    RecvBind(
            const UDPAddressInfo& addressInfo,
            const bool& addressReuse,
            const bool& loopback) = 0;
    virtual bool
    RecvOutgoingData(
            const UDPData& data,
            const UDPSocketAddr& addr) = 0;
    virtual bool
    RecvJoinMulticast(
            const nsCString& multicastAddress,
            const nsCString& iface) = 0;
    virtual bool
    RecvLeaveMulticast(
            const nsCString& multicastAddress,
            const nsCString& iface) = 0;
    virtual bool
    RecvClose() = 0;
    virtual bool
    RecvRequestDelete() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PUDPSocketParent();

    virtual ~PUDPSocketParent();

    PNeckoParent*
    Manager() const;

    PUDPSocket::State
    state();

    bool
    SendCallbackOpened(const UDPAddressInfo& addressInfo) NS_WARN_UNUSED_RESULT;

    bool
    SendCallbackClosed() NS_WARN_UNUSED_RESULT;

    bool
    SendCallbackReceivedData(
            const UDPAddressInfo& addressInfo,
            const nsTArray<uint8_t>& data) NS_WARN_UNUSED_RESULT;

    bool
    SendCallbackError(
            const nsCString& message,
            const nsCString& filename,
            const uint32_t& lineNumber) NS_WARN_UNUSED_RESULT;

    static bool
    Send__delete__(PUDPSocketParent* actor) NS_WARN_UNUSED_RESULT;

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const StringInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            StringInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const FileInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            FileInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PUDPSocketParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PUDPSocketParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const MultiplexInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            MultiplexInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const nsTArray<InputStreamParams>& __v,
            Message* __msg);

    bool
    Read(
            nsTArray<InputStreamParams>* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const OptionalInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            OptionalInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const MIMEInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            MIMEInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const InputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            InputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const BufferedInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            BufferedInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SameProcessInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            SameProcessInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const UDPSocketAddr& __v,
            Message* __msg);

    bool
    Read(
            UDPSocketAddr* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const PartialFileInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            PartialFileInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const RemoteInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            RemoteInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const UDPAddressInfo& __v,
            Message* __msg);

    bool
    Read(
            UDPAddressInfo* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const UDPData& __v,
            Message* __msg);

    bool
    Read(
            UDPData* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class UDPSocketParent :
    public PUDPSocketParent
{
    virtual bool
    RecvBind(
            const UDPAddressInfo& addressInfo,
            const bool& addressReuse,
            const bool& loopback);

    virtual bool
    RecvOutgoingData(
            const UDPData& data,
            const UDPSocketAddr& addr);

    virtual bool
    RecvJoinMulticast(
            const nsCString& multicastAddress,
            const nsCString& iface);

    virtual bool
    RecvLeaveMulticast(
            const nsCString& multicastAddress,
            const nsCString& iface);

    virtual bool
    RecvClose();

    virtual bool
    RecvRequestDelete();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT UDPSocketParent();
    virtual ~UDPSocketParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
UDPSocketParent::RecvBind(
        const UDPAddressInfo& addressInfo,
        const bool& addressReuse,
        const bool& loopback)
{
    return false;
}

bool
UDPSocketParent::RecvOutgoingData(
        const UDPData& data,
        const UDPSocketAddr& addr)
{
    return false;
}

bool
UDPSocketParent::RecvJoinMulticast(
        const nsCString& multicastAddress,
        const nsCString& iface)
{
    return false;
}

bool
UDPSocketParent::RecvLeaveMulticast(
        const nsCString& multicastAddress,
        const nsCString& iface)
{
    return false;
}

bool
UDPSocketParent::RecvClose()
{
    return false;
}

bool
UDPSocketParent::RecvRequestDelete()
{
    return false;
}

void
UDPSocketParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT UDPSocketParent::UDPSocketParent()
{
    MOZ_COUNT_CTOR(UDPSocketParent);
}

MOZ_IMPLICIT UDPSocketParent::~UDPSocketParent()
{
    MOZ_COUNT_DTOR(UDPSocketParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PUDPSocketParent_h
