//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebSocketChild_h
#define PWebSocketChild_h

#include "mozilla/net/PWebSocket.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBlobChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoChild;
} // namespace net
} // namespace mozilla

namespace IPC {
class SerializedLoadContext;
} // namespace IPC

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PWebSocketChild :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PNeckoChild;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::BufferedInputStreamParams BufferedInputStreamParams;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::FileInputStreamParams FileInputStreamParams;
    typedef mozilla::ipc::GenericURIParams GenericURIParams;
    typedef mozilla::ipc::InputStreamParams InputStreamParams;
    typedef mozilla::ipc::JARURIParams JARURIParams;
    typedef mozilla::ipc::MIMEInputStreamParams MIMEInputStreamParams;
    typedef mozilla::ipc::MultiplexInputStreamParams MultiplexInputStreamParams;
    typedef mozilla::ipc::OptionalFileDescriptorSet OptionalFileDescriptorSet;
    typedef mozilla::ipc::OptionalInputStreamParams OptionalInputStreamParams;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::ipc::PartialFileInputStreamParams PartialFileInputStreamParams;
    typedef mozilla::ipc::RemoteInputStreamParams RemoteInputStreamParams;
    typedef mozilla::ipc::SameProcessInputStreamParams SameProcessInputStreamParams;
    typedef IPC::SerializedLoadContext SerializedLoadContext;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SimpleURIParams SimpleURIParams;
    typedef mozilla::ipc::StandardURLParams StandardURLParams;
    typedef mozilla::ipc::StandardURLSegment StandardURLSegment;
    typedef mozilla::ipc::StringInputStreamParams StringInputStreamParams;
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoChild PNeckoChild;
    typedef mozilla::dom::PBrowserChild PBrowserChild;
    typedef mozilla::dom::PBlobChild PBlobChild;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PWebSocket::State State;

    virtual bool
    RecvOnStart(
            const nsCString& aProtocol,
            const nsCString& aExtensions,
            const nsString& aEffectiveURL,
            const bool& aEncrypted) = 0;
    virtual bool
    RecvOnStop(const nsresult& aStatusCode) = 0;
    virtual bool
    RecvOnMessageAvailable(const nsCString& aMsg) = 0;
    virtual bool
    RecvOnBinaryMessageAvailable(const nsCString& aMsg) = 0;
    virtual bool
    RecvOnAcknowledge(const uint32_t& aSize) = 0;
    virtual bool
    RecvOnServerClose(
            const uint16_t& code,
            const nsCString& aReason) = 0;
    virtual bool
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PWebSocketChild();

    virtual ~PWebSocketChild();

    PNeckoChild*
    Manager() const;

    PWebSocket::State
    state();

    bool
    SendAsyncOpen(
            const URIParams& aURI,
            const nsCString& aOrigin,
            const nsCString& aProtocol,
            const bool& aSecure,
            const uint32_t& aPingInterval,
            const bool& aClientSetPingInterval,
            const uint32_t& aPingTimeout,
            const bool& aClientSetPingTimeout);

    bool
    SendClose(
            const uint16_t& code,
            const nsCString& reason);

    bool
    SendSendMsg(const nsCString& aMsg);

    bool
    SendSendBinaryMsg(const nsCString& aMsg);

    bool
    SendSendBinaryStream(
            const InputStreamParams& aStream,
            const uint32_t& aLength);

    bool
    SendDeleteSelf();

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const StringInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            StringInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const FileInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            FileInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const RemoteInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            RemoteInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const MultiplexInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            MultiplexInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLParams& __v,
            Message* __msg);

    bool
    Read(
            StandardURLParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const OptionalInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            OptionalInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const MIMEInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            MIMEInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const JARURIParams& __v,
            Message* __msg);

    bool
    Read(
            JARURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const InputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            InputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const BufferedInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            BufferedInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GenericURIParams& __v,
            Message* __msg);

    bool
    Read(
            GenericURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLSegment& __v,
            Message* __msg);

    bool
    Read(
            StandardURLSegment* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const nsTArray<InputStreamParams>& __v,
            Message* __msg);

    bool
    Read(
            nsTArray<InputStreamParams>* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const URIParams& __v,
            Message* __msg);

    bool
    Read(
            URIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const PartialFileInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            PartialFileInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PWebSocketChild* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PWebSocketChild** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SimpleURIParams& __v,
            Message* __msg);

    bool
    Read(
            SimpleURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SameProcessInputStreamParams& __v,
            Message* __msg);

    bool
    Read(
            SameProcessInputStreamParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class WebSocketChild :
    public PWebSocketChild
{
    virtual bool
    RecvOnStart(
            const nsCString& aProtocol,
            const nsCString& aExtensions,
            const nsString& aEffectiveURL,
            const bool& aEncrypted);

    virtual bool
    RecvOnStop(const nsresult& aStatusCode);

    virtual bool
    RecvOnMessageAvailable(const nsCString& aMsg);

    virtual bool
    RecvOnBinaryMessageAvailable(const nsCString& aMsg);

    virtual bool
    RecvOnAcknowledge(const uint32_t& aSize);

    virtual bool
    RecvOnServerClose(
            const uint16_t& code,
            const nsCString& aReason);

    MOZ_IMPLICIT WebSocketChild();
    virtual ~WebSocketChild();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
WebSocketChild::RecvOnStart(
        const nsCString& aProtocol,
        const nsCString& aExtensions,
        const nsString& aEffectiveURL,
        const bool& aEncrypted)
{
    return false;
}

bool
WebSocketChild::RecvOnStop(const nsresult& aStatusCode)
{
    return false;
}

bool
WebSocketChild::RecvOnMessageAvailable(const nsCString& aMsg)
{
    return false;
}

bool
WebSocketChild::RecvOnBinaryMessageAvailable(const nsCString& aMsg)
{
    return false;
}

bool
WebSocketChild::RecvOnAcknowledge(const uint32_t& aSize)
{
    return false;
}

bool
WebSocketChild::RecvOnServerClose(
        const uint16_t& code,
        const nsCString& aReason)
{
    return false;
}

MOZ_IMPLICIT WebSocketChild::WebSocketChild()
{
    MOZ_COUNT_CTOR(WebSocketChild);
}

MOZ_IMPLICIT WebSocketChild::~WebSocketChild()
{
    MOZ_COUNT_DTOR(WebSocketChild);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PWebSocketChild_h
