//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWyciwygChannelParent_h
#define PWyciwygChannelParent_h

#include "mozilla/net/PWyciwygChannel.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace net {
class PNeckoParent;
} // namespace net
} // namespace mozilla

namespace IPC {
class SerializedLoadContext;
} // namespace IPC

namespace mozilla {
namespace net {


class /*NS_ABSTRACT_CLASS*/ PWyciwygChannelParent :
    public mozilla::ipc::IProtocol,
    protected mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>
{
    friend class mozilla::net::PNeckoParent;

protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ContentPrincipalInfo ContentPrincipalInfo;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::ipc::GenericURIParams GenericURIParams;
    typedef mozilla::ipc::JARURIParams JARURIParams;
    typedef mozilla::ipc::NullPrincipalInfo NullPrincipalInfo;
    typedef mozilla::ipc::OptionalURIParams OptionalURIParams;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef IPC::SerializedLoadContext SerializedLoadContext;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::SimpleURIParams SimpleURIParams;
    typedef mozilla::ipc::StandardURLParams StandardURLParams;
    typedef mozilla::ipc::StandardURLSegment StandardURLSegment;
    typedef mozilla::ipc::SystemPrincipalInfo SystemPrincipalInfo;
    typedef mozilla::ipc::URIParams URIParams;
    typedef mozilla::void_t void_t;
    typedef mozilla::net::PNeckoParent PNeckoParent;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;

    typedef PWyciwygChannel::State State;

    virtual bool
    Recv__delete__();
    virtual bool
    RecvInit(
            const URIParams& uri,
            const PrincipalInfo& requestingPrincipalInfo,
            const uint32_t& securityFlags,
            const uint32_t& contentPolicyType) = 0;
    virtual bool
    RecvAsyncOpen(
            const URIParams& originalURI,
            const uint32_t& loadFlags,
            const SerializedLoadContext& loadContext,
            PBrowserParent* browser) = 0;
    virtual bool
    RecvAppData(
            const SerializedLoadContext& loadContext,
            PBrowserParent* browser) = 0;
    virtual bool
    RecvWriteToCacheEntry(const nsString& data) = 0;
    virtual bool
    RecvCloseCacheEntry(const nsresult& reason) = 0;
    virtual bool
    RecvSetCharsetAndSource(
            const int32_t& source,
            const nsCString& charset) = 0;
    virtual bool
    RecvSetSecurityInfo(const nsCString& securityInfo) = 0;
    virtual bool
    RecvCancel(const nsresult& status) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::MessageListener ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;
    typedef mozilla::ipc::Trigger Trigger;
    typedef mozilla::ipc::ProtocolCloneContext ProtocolCloneContext;

public:
    MOZ_IMPLICIT PWyciwygChannelParent();

    virtual ~PWyciwygChannelParent();

    PNeckoParent*
    Manager() const;

    PWyciwygChannel::State
    state();

    bool
    SendOnStartRequest(
            const nsresult& statusCode,
            const int64_t& contentLength,
            const int32_t& source,
            const nsCString& charset,
            const nsCString& securityInfo) NS_WARN_UNUSED_RESULT;

    bool
    SendOnDataAvailable(
            const nsCString& data,
            const uint64_t& offset) NS_WARN_UNUSED_RESULT;

    bool
    SendOnStopRequest(const nsresult& statusCode) NS_WARN_UNUSED_RESULT;

    bool
    SendCancelEarly(const nsresult& statusCode) NS_WARN_UNUSED_RESULT;

    virtual int32_t
    Register(ProtocolBase* aRouted);
    virtual int32_t
    RegisterID(
            ProtocolBase* aRouted,
            int32_t aId);
    virtual ProtocolBase*
    Lookup(int32_t aId);
    virtual void
    Unregister(int32_t aId);
    virtual void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener);
    virtual Shmem::SharedMemory*
    CreateSharedMemory(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            bool aUnsafe,
            Shmem::id_t* aId);
    virtual bool
    AdoptSharedMemory(
            Shmem::SharedMemory* segment,
            Shmem::id_t* aId);
    virtual Shmem::SharedMemory*
    LookupSharedMemory(Shmem::id_t aId);
    virtual bool
    IsTrackingSharedMemory(Shmem::SharedMemory* segment);
    virtual bool
    DestroySharedMemory(Shmem& shmem);
    virtual ProcessHandle
    OtherProcess() const;
    virtual MessageChannel*
    GetIPCChannel();
    virtual void
    CloneManagees(
            ProtocolBase* aSource,
            ProtocolCloneContext* aCtx);
    virtual mozilla::ipc::IProtocol*
    CloneProtocol(
            Channel* aChannel,
            ProtocolCloneContext* aCtx);

    virtual Result
    OnMessageReceived(const Message& __msg);

    virtual Result
    OnMessageReceived(
            const Message& __msg,
            Message*& __reply);

    virtual Result
    OnCallReceived(
            const Message& __msg,
            Message*& __reply);

    void
    OnProcessingError(Result aCode);

    int32_t
    GetProtocolTypeId();

    bool
    OnReplyTimeout();

    void
    OnChannelClose();

    void
    OnChannelError();

    void
    OnChannelConnected(int32_t aPid);

    // Methods for managing shmem
    bool
    AllocShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AllocUnsafeShmem(
            size_t aSize,
            Shmem::SharedMemory::SharedMemoryType aType,
            Shmem* aOutMem);

    bool
    AdoptShmem(
            Shmem& aMem,
            Shmem* aOutMem);

    bool
    DeallocShmem(Shmem& aMem);

private:
    void
    FatalError(const char* const aMsg) const;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    template<typename T>
    void
    Write(
            const T& __v,
            Message* __msg)
    {
        IPC::WriteParam(__msg, __v);
    }

    template<typename T>
    bool
    Read(
            T* __v,
            const Message* __msg,
            void** __iter)
    {
        return IPC::ReadParam(__msg, __iter, __v);
    }

    void
    Write(
            const SystemPrincipalInfo& __v,
            Message* __msg);

    bool
    Read(
            SystemPrincipalInfo* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PBrowserParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PBrowserParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            PWyciwygChannelParent* __v,
            Message* __msg,
            bool __nullable);

    bool
    Read(
            PWyciwygChannelParent** __v,
            const Message* __msg,
            void** __iter,
            bool __nullable) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLParams& __v,
            Message* __msg);

    bool
    Read(
            StandardURLParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const PrincipalInfo& __v,
            Message* __msg);

    bool
    Read(
            PrincipalInfo* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const JARURIParams& __v,
            Message* __msg);

    bool
    Read(
            JARURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const ContentPrincipalInfo& __v,
            Message* __msg);

    bool
    Read(
            ContentPrincipalInfo* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const GenericURIParams& __v,
            Message* __msg);

    bool
    Read(
            GenericURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const NullPrincipalInfo& __v,
            Message* __msg);

    bool
    Read(
            NullPrincipalInfo* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const StandardURLSegment& __v,
            Message* __msg);

    bool
    Read(
            StandardURLSegment* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const URIParams& __v,
            Message* __msg);

    bool
    Read(
            URIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    void
    Write(
            const SimpleURIParams& __v,
            Message* __msg);

    bool
    Read(
            SimpleURIParams* __v,
            const Message* __msg,
            void** __iter) NS_WARN_UNUSED_RESULT;

    Channel* mChannel;
    mozilla::ipc::IProtocolManager<mozilla::ipc::IProtocol>* mManager;
    int32_t mId;
    State mState;
};


} // namespace net
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace net {
class WyciwygChannelParent :
    public PWyciwygChannelParent
{
    virtual bool
    RecvInit(
            const URIParams& uri,
            const PrincipalInfo& requestingPrincipalInfo,
            const uint32_t& securityFlags,
            const uint32_t& contentPolicyType);

    virtual bool
    RecvAsyncOpen(
            const URIParams& originalURI,
            const uint32_t& loadFlags,
            const SerializedLoadContext& loadContext,
            PBrowserParent* browser);

    virtual bool
    RecvAppData(
            const SerializedLoadContext& loadContext,
            PBrowserParent* browser);

    virtual bool
    RecvWriteToCacheEntry(const nsString& data);

    virtual bool
    RecvCloseCacheEntry(const nsresult& reason);

    virtual bool
    RecvSetCharsetAndSource(
            const int32_t& source,
            const nsCString& charset);

    virtual bool
    RecvSetSecurityInfo(const nsCString& securityInfo);

    virtual bool
    RecvCancel(const nsresult& status);

    virtual void
    ActorDestroy(ActorDestroyReason aWhy);

    MOZ_IMPLICIT WyciwygChannelParent();
    virtual ~WyciwygChannelParent();
};
} // namespace net
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace net {
bool
WyciwygChannelParent::RecvInit(
        const URIParams& uri,
        const PrincipalInfo& requestingPrincipalInfo,
        const uint32_t& securityFlags,
        const uint32_t& contentPolicyType)
{
    return false;
}

bool
WyciwygChannelParent::RecvAsyncOpen(
        const URIParams& originalURI,
        const uint32_t& loadFlags,
        const SerializedLoadContext& loadContext,
        PBrowserParent* browser)
{
    return false;
}

bool
WyciwygChannelParent::RecvAppData(
        const SerializedLoadContext& loadContext,
        PBrowserParent* browser)
{
    return false;
}

bool
WyciwygChannelParent::RecvWriteToCacheEntry(const nsString& data)
{
    return false;
}

bool
WyciwygChannelParent::RecvCloseCacheEntry(const nsresult& reason)
{
    return false;
}

bool
WyciwygChannelParent::RecvSetCharsetAndSource(
        const int32_t& source,
        const nsCString& charset)
{
    return false;
}

bool
WyciwygChannelParent::RecvSetSecurityInfo(const nsCString& securityInfo)
{
    return false;
}

bool
WyciwygChannelParent::RecvCancel(const nsresult& status)
{
    return false;
}

void
WyciwygChannelParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT WyciwygChannelParent::WyciwygChannelParent()
{
    MOZ_COUNT_CTOR(WyciwygChannelParent);
}

MOZ_IMPLICIT WyciwygChannelParent::~WyciwygChannelParent()
{
    MOZ_COUNT_DTOR(WyciwygChannelParent);
}

} // namespace net
} // namespace mozilla
#endif // if 0

#endif // ifndef PWyciwygChannelParent_h
